Package: dearseq
Type: Package
Title: Differential Expression Analysis for RNA-seq data through a
        robust variance component test
Version: 1.25.0
Date: 2023-06-16
Authors@R: c(person("Denis", "Agniel", role = c("aut"),
                    email = "denis.agniel@gmail.com"),
	           person("Boris P.", "Hejblum", role = c("aut", "cre"),
	                  email = "boris.hejblum@u-bordeaux.fr",
	                  comment = c(ORCID="0000-0003-0646-452X")),
	           person("Marine", "Gauthier", role = c("aut"),
	                  email = "marine.gauthier@u-bordeaux.fr"),
	           person("Mélanie", "Huchon", role = c("ctb"),
	                  email = "melanie.huchon@u-bordeaux.fr"))
Depends: R (>= 3.6.0)
Imports: CompQuadForm, dplyr, ggplot2, KernSmooth, magrittr,
        matrixStats, methods, patchwork, parallel, pbapply, reshape2,
        rlang, scattermore, stats, statmod, survey, tibble, viridisLite
Suggests: Biobase, BiocManager, BiocSet, edgeR, DESeq2, GEOquery, GSA,
        knitr, limma, readxl, rmarkdown, S4Vectors,
        SummarizedExperiment, testthat, covr
Description: Differential Expression Analysis RNA-seq data with variance 
             component score test accounting for data heteroscedasticity through
             precision weights. Perform both gene-wise and gene set analyses, 
             and can deal with repeated or longitudinal data. Methods are 
             detailed in: i) Agniel D & Hejblum BP (2017) Variance component score 
             test for time-course gene set analysis of longitudinal RNA-seq 
             data, Biostatistics, 18(4):589-604 ; and ii) Gauthier M, Agniel D, 
             Thiébaut R & Hejblum BP (2020) dearseq: a variance component 
             score test for RNA-Seq differential analysis that effectively 
             controls the false discovery rate, NAR Genomics and Bioinformatics,
             2(4):lqaa093.
License: GPL-2 | file LICENSE
biocViews: BiomedicalInformatics, CellBiology, DifferentialExpression,
        DNASeq, GeneExpression, Genetics, GeneSetEnrichment,
        ImmunoOncology, KEGG, Regression, RNASeq, Sequencing,
        SystemsBiology, TimeCourse, Transcription, Transcriptomics
BugReports: https://github.com/borishejblum/dearseq/issues
Encoding: UTF-8
RoxygenNote: 7.2.3
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/dearseq
git_branch: devel
git_last_commit: 568dec0
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:15:01 UTC; biocbuild
Author: Denis Agniel [aut],
  Boris P. Hejblum [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-0646-452X>),
  Marine Gauthier [aut],
  Mélanie Huchon [ctb]
Maintainer: Boris P. Hejblum <boris.hejblum@u-bordeaux.fr>

#'Computes variance component score test statistics for homogeneous trajectory
#'and its permuted distribution
#'
#'This function computes the variance component score test statistics
#'for homogeneous trajectories along with its permuted values for estimating
#'its distribution under the null hypothesis.
#'
#'@keywords internal
#'
#'@param y a numeric matrix of dim \code{g x n} containing the raw or
#'normalized RNA-seq counts for g genes from \code{n} samples.
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the \code{p}
#'covariates to be adjusted for.
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced
#'to be a \code{factor}.
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} longitudinal variables to be tested (typically a vector of time
#'points or functions of time).
#'
#'@param w a vector of length \code{n} containing the weights for the \code{n}
#'samples, corresponding to the inverse of the diagonal of the estimated
#'covariance matrix of y.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects corresponding to \code{phi}.
#'
#'@param na_rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@param n_perm the number of permutation to perform. Default is \code{1000}.
#'
#'@param progressbar logical indicating wether a progressBar should be displayed
#'when computing permutations (only in interactive mode).
#'
#'@param parallel_comp a logical flag indicating whether parallel computation
#'should be enabled. Only Linux and MacOS are supported, this is ignored on
#'Windows. Default is \code{TRUE}.
#'
#'@param nb_cores an integer indicating the number of cores to be used when
#'\code{parallel_comp} is \code{TRUE}.
#'Default is \code{parallel::detectCores(logical=FALSE) - 1}.
#'
#'@return A list with the following elements:
#'\itemize{
#'   \item \code{score}: an approximation of the observed set score
#'   \item \code{scores_perm}: a vector containing the permuted set scores
#'   \item \code{gene_scores_unscaled}: approximation of the individual gene
#'   scores
#'   \item \code{gene_scores_unscaled_perm}: a list of approximation of the
#'   permuted individual gene scores
#' }
#'
#'
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'ng <- 100
#'nindiv <- 30
#'nt <- 5
#'nsample <- nindiv*nt
#'tim <- matrix(rep(1:nt), nindiv, ncol=1, nrow=nsample)
#'tim2 <- tim^2
#'sigma <- 5
#'b0 <- 10
#'
#'#under the null:
#'beta1 <- rnorm(n=ng, 0, sd=0)
#'#under the (heterogen) alternative:
#'beta1 <- rnorm(n=ng, 0, sd=0.1)
#'#under the (homogen) alternative:
#'beta1 <- rnorm(n=ng, 0.06, sd=0)
#'
#'y.tilde <- b0 + rnorm(ng, sd = sigma)
#'y <- t(matrix(rep(y.tilde, nsample), ncol=ng, nrow=nsample, byrow=TRUE) +
#'       matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
#'            matrix(rep(tim, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
#'       #matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
#'       #     matrix(rep(tim2, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
#'       matrix(rnorm(ng*nsample, sd = sigma), ncol=ng, nrow=nsample,
#'              byrow=FALSE)
#'       )
#'myindiv <- rep(1:nindiv, each=nt)
#'x <- cbind(1, myindiv/2==floor(myindiv/2))
#'myw <- matrix(rnorm(nsample*ng, sd=0.1), ncol=nsample, nrow=ng)
#'
#'#run test
#'#We only use few permutations (10) to keep example running time low
#'#Otherwise one can use n_perm = 1000
#'score_homogen <- vc_score_h_perm(y, x, phi=tim, indiv=myindiv,
#'                                 w=myw, Sigma_xi=cov(tim), n_perm = 10,
#'                                 parallel_comp = FALSE)
#'score_homogen$score
#'
#'score_heterogen <- vc_score_perm(y, x, phi=tim, indiv=myindiv,
#'                            w=myw, Sigma_xi=cov(tim), n_perm = 10,
#'                            parallel_comp = FALSE)
#'score_heterogen$score
#'
#'scoreTest_homogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv, each=nt),
#'                                  w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                                  Sigma_xi=cov(tim), homogen_traj = TRUE)
#'scoreTest_homogen$set_pval
#'scoreTest_heterogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv,
#'                                                             each=nt),
#'                                    w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                                    Sigma_xi=cov(tim), homogen_traj = FALSE)
#'scoreTest_heterogen$set_pval
#'
#'@importFrom pbapply pbsapply
#'@importFrom parallel mclapply
#'
#'@export
vc_score_h_perm <- function(y, x, indiv, phi, w,
                            Sigma_xi = diag(ncol(phi)),
                            na_rm = FALSE,
                            n_perm = 1000,
                            progressbar = TRUE,
                            parallel_comp = TRUE,
                            nb_cores = parallel::detectCores(logical=FALSE) - 1) {

    ## validity checks
    if (sum(!is.finite(w)) > 0) {
        stop("At least 1 non-finite weight in 'w'")
    }

    ## dimensions check------

    stopifnot(is.matrix(y))
    stopifnot(is.matrix(x))
    stopifnot(is.matrix(phi))

    g <- nrow(y)  # the number of genes measured
    n <- ncol(y)  # the number of samples measured
    p <- ncol(x)  # the number of covariates
    n_t <- ncol(phi)  # the number of time bases
    stopifnot(nrow(x) == n)
    stopifnot(nrow(w) == g)
    stopifnot(ncol(w) == n)
    stopifnot(nrow(phi) == n)
    stopifnot(length(indiv) == n)


    # the number of random effects
    if (length(Sigma_xi) == 1) {
        K <- 1
        Sigma_xi <- matrix(Sigma_xi, K, K)
    } else {
        K <- nrow(Sigma_xi)
        stopifnot(ncol(Sigma_xi) == K)
    }
    stopifnot(n_t == K)


    ## data formating ------
    indiv <- factor(indiv, ordered = TRUE)
    nb_indiv <- length(levels(indiv))

    y_T <- t(y)

    ## x_tilde_list <- y_tilde_list <- Phi_list <- list()
    ## for (i in 1:nb_indiv) {
    ##     select <- indiv==levels(indiv)[i]
    ##     n_i <- length(which(select))
    ##     x_i <- x[select,]
    ##     y_i <- y_T[select,]
    ##     phi_i <- phi[select,]
    ##     Phi_list[[i]] <- do.call(rbind, replicate(g, phi_i,
    ##                              simplify = FALSE)) #TODO
    ##     x_tilde_list[[i]] <- matrix(data=rep(x_i, each=g), ncol = p) #TODO
    ##     y_tilde_list[[i]] <- matrix(y_i, ncol=1)
    ## }
    ## x_tilde <- do.call(rbind, x_tilde_list)
    ## y_tilde <- do.call(rbind, y_tilde_list)
    ## Phi <- do.call(rbind, Phi_list)
    ## alpha <- solve(t(x_tilde)%*%x_tilde)%*%t(x_tilde)%*%y_tilde
    ## mu_new <- x_tilde %*% alpha
    ## y_mu <- y_tilde - mu_new


    alpha <- solve(crossprod(x)) %*% t(x) %*% rowMeans(y_T, na.rm = na_rm)
    yt_mu <- y_T - do.call(cbind, replicate(g, x %*% alpha, simplify = FALSE))


    ## test statistic computation ------
    sig_xi_sqrt <- (Sigma_xi * diag(K)) %^% (-0.5)
    # sig_xi_sqrt <- (Sigma_xi %^% (-0.5))
    ## xtx_inv <- solve(t(x_tilde) %*% x_tilde)
    ## long_indiv <- rep(indiv, each = g)
    ## q <- matrix(NA, nrow=nb_indiv, ncol=K)
    ## XT_i <- array(NA, c(nb_indiv, p, K))
    ## U <- matrix(NA, nrow = nb_indiv, ncol = p)
    ## for (i in 1:nb_indiv){ #for all the genes at once
    ##     select <- indiv==levels(indiv)[i]
    ##     long_select <- long_indiv==levels(indiv)[i]
    ##     y_mu_i <- as.vector(y_mu[long_select,])
    ##     y_tilde_i <- c(y_ij)
    ##     x_tilde_i <- x_tilde[long_select,]
    ##     sigma_eps_inv_diag <- c(t(w)[select,])
    ##     T_i <- sigma_eps_inv_diag*(Phi[long_select,] %*% sig_xi_sqrt)
    ##     q[i,] <- c(y_mu_i %*% T_i)
    ##     XT_i[i,,] <- t(x_tilde_i) %*% T_i
    ##     U[i,] <- xtx_inv %*% t(x_tilde_i) %*% y_mu_i
    ## }
    ## XT <- colMeans(XT_i) q_ext <- q - U %*% XT

    sig_eps_inv_T <- t(w)
    if (length(levels(indiv)) > 1) {
        indiv_mat <- stats::model.matrix(~0 + factor(indiv))
    } else {
        indiv_mat <- matrix(as.numeric(indiv), ncol = 1)
    }
    avg_xtx_inv_tx <- nb_indiv * tcrossprod(solve(crossprod(x, x)), x)

    compute_genewise_scores <- function(v, indiv_mat, avg_xtx_inv_tx) {
        phi_perm <- phi[v, , drop = FALSE]
        phi_sig_xi_sqrt <- phi_perm %*% sig_xi_sqrt
        T_fast <- do.call(cbind, replicate(K, sig_eps_inv_T,
                                           simplify = FALSE)) *
            matrix(apply(phi_sig_xi_sqrt, 2, rep, g), ncol = g * K)
        q_fast <- matrix(yt_mu, ncol = g * n_t, nrow = n) * T_fast
        if (na_rm & sum(is.na(q_fast)) > 0) {
            q_fast[is.na(q_fast)] <- 0
        }
        q <- crossprod(indiv_mat, q_fast)
        XT_fast <- t(x) %*% T_fast/nb_indiv
        U_XT <- matrix(yt_mu, ncol = g * n_t, nrow = n) *
            crossprod(avg_xtx_inv_tx, XT_fast)
        if (na_rm & sum(is.na(U_XT)) > 0) {
            U_XT[is.na(U_XT)] <- 0
        }
        U_XT_indiv <- crossprod(indiv_mat, U_XT)
        q_ext <- q - U_XT_indiv
        qq <- colSums(q, na.rm = na_rm)^2/nb_indiv
        return(rowSums(matrix(qq, ncol = K)))  # genewise scores
    }

    perm_list <- c(list(seq_len(n)), lapply(seq_len(n_perm), function(x) {
        as.numeric(unlist(lapply(split(x = as.character(seq_len(n)), f = indiv),
                                 FUN = sample)))
    }))

    if(!parallel_comp){
        if(progressbar){
            gene_Q <- pbapply::pbsapply(perm_list, compute_genewise_scores,
                                        indiv_mat = indiv_mat,
                                        avg_xtx_inv_tx = avg_xtx_inv_tx)
        }else{
            gene_Q <- vapply(perm_list, compute_genewise_scores,
                             FUN.VALUE = rep(1.1, g),
                             indiv_mat = indiv_mat,
                             avg_xtx_inv_tx = avg_xtx_inv_tx)
        }
    }else{
        if(progressbar){
            gene_Q <- pbapply::pbsapply(perm_list, compute_genewise_scores,
                                        indiv_mat = indiv_mat,
                                        avg_xtx_inv_tx = avg_xtx_inv_tx,
                                        cl = nb_cores)
        }else{
            gene_Q <- simplify2array(
                parallel::mclapply(X = perm_list,
                                   FUN = compute_genewise_scores,
                                   indiv_mat = indiv_mat,
                                   avg_xtx_inv_tx = avg_xtx_inv_tx,
                                   mc.cores = nb_cores))
        }
    }
    QQ <- colSums(gene_Q)

    return(list(score = QQ[1], scores_perm = QQ[-1],
                gene_scores_unscaled = gene_Q[, 1],
                gene_scores_unscaled_perm = gene_Q[, -1]))
}

#'Permutation-based variance component test statistic and p-value
#'
#'This function computes an approximation of the Variance Component test for a
#'mixture of \eqn{\chi^{2}}s using permutations. This is preferable to the
#'asymptotic approximation for small sample sizes. We rely on exact p-values
#'following Phipson and Smyth, 2010 (see References).
#'
#'
#'@param y a numeric matrix of dim \code{G x n} containing the raw RNA-seq
#'counts for G genes from \code{n} samples.
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the \code{p}
#'covariates to be adjusted for.
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced to be a
#'\code{factor}.
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} variables to be tested
#'
#'@param w a vector of length \code{n} containing the weights for the \code{n}
#'samples.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects.
#'
#'@param n_perm the number of perturbations. Default is \code{1000}.
#'
#'@param progressbar logical indicating wether a progressBar should be displayed
#'when computing permutations (only in interactive mode).
#'
#'@param parallel_comp a logical flag indicating whether parallel computation
#'should be enabled. Only Linux and MacOS are supported, this is ignored on
#'Windows. Default is \code{TRUE}.
#'
#'@param nb_cores an integer indicating the number of cores to be used when
#'\code{parallel_comp} is \code{TRUE}.
#'Default is \code{parallel::detectCores(logical=FALSE) - 1}.
#'
#'@param genewise_pvals a logical flag indicating whether gene-wise p-values
#'should be returned. Default is \code{FALSE} in which case gene-set p-value is
#'computed and returned instead.
#'
#'@param adaptive a logical flag indicating whether adaptive permutation should
#'be performed. Default is \code{TRUE}
#'
#'@param max_adaptive The maximum number of permutations considered.
#'Default is \code{64000}
#'
#'@param homogen_traj a logical flag indicating whether trajectories should be
#'considered homogeneous. Default is \code{FALSE} in which case trajectories are
#'not only tested for trend, but also for heterogeneity.
#'
#'@param na.rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@references Phipson B, and Smyth GK (2010). Permutation p-values should
#'never be zero: calculating exact p-values when permutations are randomly
#'drawn. \emph{Statistical Applications in Genetics and Molecular Biology},
#'Volume 9, Issue 1, Article 39.
#'\url{http://www.statsci.org/smyth/pubs/PermPValuesPreprint.pdf}
#'
#'@return A list with the following elements when the set p-value is computed:
#'\itemize{
#'   \item \code{set_score_obs}: the approximation of the observed set score
#'   \item \code{set_pval}: the associated set p-value
#' }
#'or a list with the following elements when gene-wise p-values are computed:
#'\itemize{
#'   \item \code{gene_scores_obs}: vector of approximating the observed
#'   gene-wise scores
#'   \item \code{gene_pvals}: vector of associated gene-wise p-values
#'   \item \code{ds_fdr}: vector of associated gene-wise discrete false
#'   discovery rates
#' }
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'n <- 100
#'r <- 12
#'t <- matrix(rep(1:3), 4, ncol=1, nrow=r)
#'sigma <- 0.4
#'b0 <- 1
#'
#'#under the null:
#'b1 <- 0
#'#under the alternative:
#'b1 <- 0.5
#'y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'x <- matrix(1, ncol=1, nrow=r)
#'
#'#run test
#'permTestRes <- vc_test_perm(y, x, phi=t,
#'                            w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                            indiv=rep(1:4, each=3), n_perm=50, #1000,
#'                            parallel_comp = FALSE)
#'permTestRes$set_pval
#'
#'@export
vc_test_perm <- function(y, x, indiv = rep(1, nrow(x)), phi, w,
                         Sigma_xi = diag(ncol(phi)),
                         n_perm = 1000, progressbar = TRUE,
                         parallel_comp = TRUE,
                         nb_cores = parallel::detectCores(logical=FALSE) - 1,
                         genewise_pvals = FALSE,
                         adaptive = TRUE, max_adaptive = 64000,
                         homogen_traj = FALSE, na.rm = FALSE) {

    n_samples <- ncol(y)
    if (is.null(colnames(y))) {
        colnames(y) <- seq_len(n_samples)
    }
    indiv_fact <- factor(indiv)

    if (homogen_traj) {
        vc_score_2use <- vc_score_h_perm
    } else {
        vc_score_2use <- vc_score_perm
    }

    if (is.null(indiv)) {
        #suppressWarnings(
        N_possible_perms <- factorial(ncol(y))
        #)
    } else {
        #suppressWarnings(
        N_possible_perms <- prod(vapply(table(indiv), factorial, FUN.VALUE = 1))
        #)
    }

    if(adaptive){
        message("Performing ", n_perm, " initial permutations for ", nrow(y),
                " genes")
    }
    score_list_res <- vc_score_2use(y = y, x = x, indiv = indiv_fact, phi = phi,
                                    w = w, Sigma_xi = Sigma_xi, na_rm = na.rm,
                                    n_perm = n_perm,
                                    progressbar = progressbar,
                                    parallel_comp = parallel_comp,
                                    nb_cores = nb_cores)

    if (genewise_pvals) {
        gene_scores_obs <- score_list_res$gene_scores_unscaled
        gene_scores_perm <- score_list_res$gene_scores_unscaled_perm

        nperm_sup_obs <- rowSums(gene_scores_perm >= gene_scores_obs)
        #pvals_naive <- nperm_sup_obs/n_perm
        #pvals_u <- (nperm_sup_obs + 1)/(n_perm +1)
        pvals_e <- permPvals(nPermSupObs = nperm_sup_obs, nPermEff = n_perm,
                             totalPossibleNPerm = N_possible_perms)
        ind_threshold <- which(nperm_sup_obs < 5)
        #ind_threshold <- as.numeric(which(pvals_e<=2/(n_perm/10)))
        n_perm_threshold <- n_perm
        gene_scores_perm_threshold <- gene_scores_perm[ind_threshold, ]
        nperm_sup_obs_threshold <- nperm_sup_obs

        if(adaptive && (min(pvals_e)!=(0.05/length(pvals_e))) &&
           (length(ind_threshold)>1) && (n_perm_threshold <= max_adaptive)){
            message("Adaptive permutation strategy:")
        }

        while(adaptive && (min(pvals_e)!=(0.05/length(pvals_e))) &&
              (length(ind_threshold)>0) && (n_perm_threshold <= max_adaptive)){
            message("  performing ", n_perm_threshold,
                    " additional permutations for ", length(ind_threshold),
                    " genes")
            score_list_res <- vc_score_2use(y = y[ind_threshold, ], x = x,
                                            indiv = indiv_fact, phi = phi,
                                            w = w[ind_threshold, ],
                                            Sigma_xi = Sigma_xi, na_rm = na.rm,
                                            n_perm = n_perm_threshold,
                                            progressbar = progressbar,
                                            parallel_comp = parallel_comp,
                                            nb_cores = nb_cores)

            gene_scores_perm_threshold <- cbind(gene_scores_perm_threshold,
                                                score_list_res$gene_scores_unscaled_perm)
            n_perm_ad <- ncol(gene_scores_perm_threshold)
            nperm_sup_obs_threshold <- rowSums(gene_scores_perm_threshold >=
                                                 gene_scores_obs[ind_threshold])
            pvals_e_threshold <- permPvals(nPermSupObs = nperm_sup_obs_threshold,
                                           nPermEff = n_perm_ad,
                                           totalPossibleNPerm = N_possible_perms)

            pvals_e[ind_threshold] <- pvals_e_threshold


            still_needed <- which(nperm_sup_obs_threshold<5)
            if(length(still_needed)>1){
                ind_threshold <- ind_threshold[still_needed]
                gene_scores_perm_threshold <- gene_scores_perm_threshold[still_needed, ]
                n_perm_threshold <- n_perm_threshold*4
            }else{
                ind_threshold <- NULL
                n_perm_threshold <- max_adaptive + 1
            }

        }
        names(pvals_e) <- names(gene_scores_obs)

        ans <- list(gene_scores_obs = gene_scores_obs, gene_pvals = pvals_e)
    } else {
        pvals_u <- (sum(score_list_res$scores_perm >=
                            score_list_res$score) + 1)/(n_perm + 1)

        ans <- list(set_score_obs = score_list_res$score, set_pval = pvals_u)

    }
    return(ans)
}

#'Plot method for dearseq objects 
#'
#'@param x an object of class \code{dear_seq}
#'
#'@param signif_threshold a value between \code{0} and {1} specifying the 
#'nominal significance threshold. Default is \code{0.05}.
#'
#'@param ... further arguments
#'
#'
#'@author Boris Hejblum
#'
#'@return a \code{\link[ggplot2]{ggplot}} object
#'
#'@import patchwork
#'
#'@export

plot.dearseq <- function(x, signif_threshold = 0.05, ...){
  
  p1 <- plot_hist_pvals(x$pvals$rawPval)
  p2 <- plot_ord_pvals(x$pvals$rawPval, signif_threshold = signif_threshold)
  pf <- p1 +p2
  if(x$weight_object$plot_utilities$method != "none"){
    p3 <- plot_weights(x$weight_object)
    pf <- (p1 + p2) / p3
  }
  return(pf)
}

#'Computes variance component score test statistic for homogeneous trajectories
#'
#'This function computes the variance component score test statistics for 
#'homogeneous trajectories
#'
#'@keywords internal
#'
#'@param y a numeric matrix of dim \code{g x n} containing the raw or
#'normalized RNA-seq counts for g genes from \code{n} samples.
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the \code{p}
#'covariates to be adjusted for.
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced
#'to be a \code{factor}.
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} longitudinal variables to be tested (typically a vector of time
#'points or functions of time).
#'
#'@param w a vector of length \code{n} containing the weights for the \code{n}
#'samples, corresponding to the inverse of the diagonal of the estimated
#'covariance matrix of y.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects corresponding to \code{phi}.
#'
#'@param na_rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@return A list with the following elements:\itemize{
#'   \item \code{score}: approximation of the set observed score
#'   \item \code{q}: observation-level contributions to the score
#'   \item \code{q_ext}: pseudo-observations used to compute covariance
#'   taking into account the contributions of OLS estimates
#'   \item \code{gene_scores}: approximation of the individual gene scores
#' }
#'
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'ng <- 100
#'nindiv <- 30
#'nt <- 5
#'nsample <- nindiv*nt
#'tim <- matrix(rep(1:nt), nindiv, ncol=1, nrow=nsample)
#'tim2 <- tim^2
#'sigma <- 5
#'b0 <- 10
#'
#'#under the null:
#'beta1 <- rnorm(n=ng, 0, sd=0)
#'#under the (heterogen) alternative:
#'beta1 <- rnorm(n=ng, 0, sd=0.1)
#'#under the (homogen) alternative:
#'beta1 <- rnorm(n=ng, 0.06, sd=0)
#'
#'y.tilde <- b0 + rnorm(ng, sd = sigma)
#'y <- t(matrix(rep(y.tilde, nsample), ncol=ng, nrow=nsample, byrow=TRUE) +
#'       matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
#'            matrix(rep(tim, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
#'       #matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
#'       #    matrix(rep(tim2, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
#'       matrix(rnorm(ng*nsample, sd = sigma), ncol=ng, nrow=nsample,
#'              byrow=FALSE)
#'       )
#'myindiv <- rep(1:nindiv, each=nt)
#'x <- cbind(1, myindiv/2==floor(myindiv/2))
#'myw <- matrix(rnorm(nsample*ng, sd=0.1), ncol=nsample, nrow=ng)
#'
#'#run test
#'score_homogen <- vc_score_h(y, x, phi=tim, indiv=myindiv,
#'                            w=myw, Sigma_xi=cov(tim))
#'score_homogen$score
#'
#'score_heterogen <- vc_score(y, x, phi=tim, indiv=myindiv,
#'                            w=myw, Sigma_xi=cov(tim))
#'score_heterogen$score
#'
#'scoreTest_homogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv, each=nt),
#'                                  w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                                  Sigma_xi=cov(tim),
#'                                  homogen_traj = TRUE)
#'scoreTest_homogen$set_pval
#'scoreTest_heterogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv,
#'                                                          each=nt),
#'                                    w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                                    Sigma_xi=cov(tim),
#'                                    homogen_traj = FALSE)
#'scoreTest_heterogen$set_pval
#'
#'@export
vc_score_h <- function(y, x, indiv, phi, w, Sigma_xi = diag(ncol(phi)),
                       na_rm = FALSE) {

    ## validity checks
    if (sum(!is.finite(w)) > 0) {
        stop("At least 1 non-finite weight in 'w'")
    }

    ## dimensions check------

    stopifnot(is.matrix(y))
    stopifnot(is.matrix(x))
    stopifnot(is.matrix(phi))

    g <- nrow(y)  # the number of genes measured
    n <- ncol(y)  # the number of samples measured
    p <- ncol(x)  # the number of covariates
    n_t <- ncol(phi)  # the number of time bases
    stopifnot(nrow(x) == n)
    stopifnot(nrow(w) == g)
    stopifnot(ncol(w) == n)
    stopifnot(nrow(phi) == n)
    stopifnot(length(indiv) == n)


    # the number of random effects
    if (length(Sigma_xi) == 1) {
        K <- 1
        Sigma_xi <- matrix(Sigma_xi, K, K)
    } else {
        K <- nrow(Sigma_xi)
        stopifnot(ncol(Sigma_xi) == K)
    }
    stopifnot(n_t == K)


    ## data formating ------
    indiv <- as.factor(indiv)
    nb_indiv <- length(levels(indiv))

    y_T <- t(y)

    ## x_tilde_list <- y_tilde_list <- Phi_list <- list()
    ## for (i in 1:nb_indiv) {
    ##      select <- indiv==levels(indiv)[i]
    ##      n_i <- length(which(select))
    ##      x_i <- x[select,]
    ##      y_i <- y_T[select,]
    ##      phi_i <- phi[select,]
    ##      Phi_list[[i]] <- do.call(rbind, replicate(g, phi_i,
    ##                               simplify = FALSE))
    ##      x_tilde_list[[i]] <- matrix(data=rep(x_i, each=g), ncol = p)
    ##      y_tilde_list[[i]] <- matrix(y_i, ncol=1) }
    ## x_tilde <- do.call(rbind, x_tilde_list)
    ## y_tilde <- o.call(rbind, y_tilde_list)
    ## Phi <- do.call(rbind, Phi_list)
    ## alpha <- solve(t(x_tilde)%*%x_tilde)%*%t(x_tilde)%*%y_tilde
    ## mu_new <- x_tilde %*% alpha
    ## y_mu <- y_tilde - mu_new


    alpha <- solve(crossprod(x)) %*% t(x) %*% rowMeans(y_T, na.rm = na_rm)
    yt_mu <- y_T - do.call(cbind, replicate(g, x %*% alpha, simplify = FALSE))


    ## test statistic computation ------
    sig_xi_sqrt <- (Sigma_xi * diag(K)) %^% (-0.5)
    # sig_xi_sqrt <- (Sigma_xi %^% (-0.5))

    ## xtx_inv <- solve(t(x_tilde) %*% x_tilde)
    ## long_indiv <- rep(indiv, each = g)
    ## q <- matrix(NA, nrow=nb_indiv, ncol=K)
    ## XT_i <- array(NA, c(nb_indiv, p, K))
    ## U <- matrix(NA, nrow = nb_indiv, ncol = p)
    ## for (i in 1:nb_indiv){ #for all the genes at once
    ##      select <- indiv==levels(indiv)[i]
    ##      long_select <- long_indiv==levels(indiv)[i]
    ##      y_mu_i <- as.vector(y_mu[long_select,])
    ##      y_tilde_i <- c(y_ij)
    ##      x_tilde_i <- x_tilde[long_select,]
    ##      sigma_eps_inv_diag <- c(t(w)[select,])
    ##      T_i <- sigma_eps_inv_diag*(Phi[long_select,] %*% sig_xi_sqrt)
    ##      q[i,] <- c(y_mu_i %*% T_i)
    ##      XT_i[i,,] <- t(x_tilde_i) %*% T_i
    ##      U[i,] <- xtx_inv %*% t(x_tilde_i) %*% y_mu_i
    ## }
    ## XT <- colMeans(XT_i)
    ## q_ext <- q - U %*% XT

    sig_eps_inv_T <- t(w)
    phi_sig_xi_sqrt <- phi %*% sig_xi_sqrt
    T_fast <- do.call(cbind, replicate(K, sig_eps_inv_T, simplify = FALSE)) *
        matrix(apply(phi_sig_xi_sqrt, 2, rep, g), ncol = g * K)
    q_fast <- do.call(cbind, replicate(K, yt_mu, simplify = FALSE)) * T_fast

    if (length(levels(indiv)) > 1) {
        indiv_mat <- stats::model.matrix(~0 + factor(indiv))
    } else {
        indiv_mat <- matrix(as.numeric(indiv), ncol = 1)
    }

    if (na_rm & sum(is.na(q_fast)) > 0) {
        q_fast[is.na(q_fast)] <- 0
    }
    q <- crossprod(indiv_mat, q_fast)
    XT_fast <- t(x) %*% T_fast/nb_indiv
    avg_xtx_inv_tx <- nb_indiv * tcrossprod(solve(crossprod(x, x)), x)
    U_XT <- matrix(yt_mu, ncol = g * n_t, nrow = n) *
        crossprod(avg_xtx_inv_tx, XT_fast)
    if (na_rm & sum(is.na(U_XT)) > 0) {
        U_XT[is.na(U_XT)] <- 0
    }
    U_XT_indiv <- crossprod(indiv_mat, U_XT)
    q_ext <- q - U_XT_indiv

    qq <- colSums(q, na.rm = na_rm)^2/nb_indiv

    gene_Q <- rowSums(matrix(qq, ncol = K))

    QQ <- sum(qq)  #nb_indiv=nrow(q) # set score

    return(list(score = QQ, q = q, q_ext = q_ext,
                gene_scores_unscaled = gene_Q))
}

#'Precision weights accounting for heteroscedasticity in RNA-seq count data
#'
#'Implementation of the procedure described in Law \emph{et al.} for estimating
#'precision weights from RNA-seq data.
#'
#'@param y a matrix of size \code{G x n} containing the raw RNA-seq counts or
#'preprocessed expressions from \code{n} samples for \code{G} genes.
#'
#'@param x a matrix of size \code{n x p} containing the model covariates from
#'\code{n} samples (design matrix).
#'
#'@param preprocessed a logical flag indicating whether the expression data have
#'already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
#'which case \code{y} is assumed to contain raw counts and is normalized into
#'log(counts) per million.
#'
#'@param lowess_span smoother span for the lowess function, between 0 and 1.
#'This gives the proportion of points in the plot which influence the smooth at
#'each value. Larger values give more smoothness. Default is \code{0.5}.
#'
#'@param R library.size (optional, important to provide if
#'\code{preprocessed = TRUE}). Default is \code{NULL}
#'
#'@return a vector of length \code{n} containing the computed precision weights
#'
#'@seealso \code{\link{lowess}} \code{\link{approxfun}}
#'\code{\link[limma]{voom}}
#'
#'@references Law, C. W., Chen, Y., Shi, W., & Smyth, G. K. (2014). voom:
#'Precision weights unlock linear model analysis tools for RNA-seq read counts.
#'\emph{Genome Biology}, 15(2), R29.
#'
#'@examples
#'set.seed(123)
#'
#'G <- 10000
#'n <- 12
#'p <- 2
#'
#'y <- sapply(1:n, FUN=function(x){rnbinom(n=G, size=0.07, mu=200)})
#'x <- sapply(1:p, FUN=function(x){rnorm(n=n, mean=n, sd=1)})
#'
#'my_w <-  voom_weights(y, x)
#'plot_weights(my_w)
#'if (requireNamespace('limma', quietly = TRUE)) {
#'  w_voom <- limma::voom(counts=y, design=x, plot=TRUE)
#'  #slightly faster, same results
#'  all.equal(my_w$weights, w_voom$weights)
#'}
#'
#'if(interactive()){
#'#microbenchmark::microbenchmark(limma::voom(counts=t(y), design=x,
#'#                               plot=FALSE), voom_weights(x, y),
#'#                               times=30)
#'}
#'
#'@author Boris Hejblum
#'
#'@import ggplot2
#'@importFrom stats approxfun lowess
#'@export


voom_weights <- function(y, x, preprocessed = FALSE,
                         lowess_span = 0.5, R = NULL) {
    
    ## dimensions check------
    
    stopifnot(is.matrix(y))
    stopifnot(is.matrix(x))
    
    n <- ncol(y)  # the number of samples measured
    g <- nrow(y)  # the number of genes measured
    qq <- ncol(x)  # the number of covariates
    stopifnot(nrow(x) == n)
    
    # transforming rna to log-counts per million (lcpm)
    if (preprocessed) {
        y_lcpm <- t(y)
    } else {
        y_lcpm <- t(apply(y, MARGIN = 2, function(v) {
            log2((v + 0.5)/(sum(v) + 1) * 10^6)
        }))
    }
    
    # library size
    if(is.null(R)){
        R <- colSums(y, na.rm = TRUE)
    }
    
    # fitting OLS to the lcpm
    B_ols <- solve(t(x) %*% x) %*% t(x) %*% y_lcpm
    mu <- x %*% B_ols
    resi <- y_lcpm - mu
    s <- sqrt(apply(resi, MARGIN = 2, crossprod)/(nrow(x) - ncol(x)))
    s_rs <- sqrt(s)
    
    # average lcpm
    y_bar <- colMeans(y_lcpm, na.rm = TRUE)
    
    # average log-counts
    r_tilde <- y_bar + mean(log2(R + 1)) - log2(10^6)
    
    # fitted log-counts
    lambda <- mu + log2(R + 1) - log2(10^6)
    
    
    
    # lowess fit for predicted square root sd
    observed <- which(rowSums(y) != 0)  #removing genes never observed
    lowess_fit <- stats::lowess(x = r_tilde[observed], y = s_rs[observed],
                                f = lowess_span)
    f_interp <- stats::approxfun(lowess_fit, rule = 2, ties=mean)
    
    # weights
    wg <- t(apply(lambda, MARGIN = 2, f_interp)^(-4))
    
    colnames(wg) <- rownames(y_lcpm)
    
    return(list("weights" = wg,
                "plot_utilities" = list("reverse_trans" = identity,
                                        "method" = "voom",
                                        "smth" = lowess_fit,
                                        "gene_based" = NA,
                                        "mu" = r_tilde,
                                        "v" = s_rs
                )
    ))
}

#'
#'@details
#'Analysis of RNA-seq data with variance component score
#'test accounting for data heteroscedasticity through precision weights.
#'Performs gene-wise analysis as well as gene set analysis, including for
#'complex experimental designs such as longitudinal data.
#'
#'\tabular{ll}{
#'Package: \tab dearseq\cr
#'Type: \tab Package\cr
#'Version: \tab 1.13.3\cr
#'Date: \tab 2023-06-16\cr
#'License:\tab \href{http://www.gnu.org/licenses/gpl-2.0.txt}{GPL-2}\cr
#'}
#'The two main functions of the \code{dearseq} package are
#'\code{\link{dear_seq}} and \code{\link{dgsa_seq}}.
#'
#'
#'@references Agniel D & Hejblum BP (2017). Variance component score test for
#'time-course gene set analysis of longitudinal RNA-seq data,
#'\emph{Biostatistics}, 18(4):589-604.
#'\href{https://doi.org/10.1093/biostatistics/kxx005}{DOI: 10.1093/biostatistics/kxx005}.
#'\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.
#'
#'Gauthier M, Agniel D, Thiébaut R & Hejblum BP (2020). dearseq: a variance
#'component score test for RNA-Seq differential analysis that effectively
#'controls the false discovery rate, \emph{NAR Genomics and Bioinformatics},
#'2(4):lqaa093.
#'\href{https://doi.org/10.1093/nargab/lqaa093}{DOI: 10.1093/nargab/lqaa093}.
#'\href{https://www.biorxiv.org/content/10.1101/635714}{DOI: 10.1101/635714}
#'
"_PACKAGE"

#'Exact permutation p-values
#'
#'Calculates exact p-values for permutation tests when permutations are randomly
#'drawn with replacement. This implementation is based on
#'(slightly adapted) the implementation by Belinda Phipson and Gordon Smyth
#'from the R package \code{statmod}
#'
#'
#'@author Belinda Phipson and Gordon Smyth (adapted by Boris Hejblum)
#'
#'@param nPermSupObs number of permutations that yielded test statistics at
#'least as extreme as the observed data. Can be a vector or an array of values.
#'@param nPermEff number of permutations effectively computed.
#'@param totalPossibleNPerm total number of permutations possible.
#'
#'@references Phipson B, and Smyth GK (2010). Permutation p-values should never
#'be zero: calculating exact p-values when permutations are randomly drawn.
#'\emph{Statistical Applications in Genetics and Molecular Biology}, Volume 9,
#'Issue 1, Article 39.
#'\url{http://www.statsci.org/smyth/pubs/PermPValuesPreprint.pdf}
#'
#'@importFrom statmod gauss.quad.prob
#'@importFrom stats pbinom
#'@seealso statmod::permp
#'
#'@return a vector (or an array, similar to \code{nperm_supobs})
#'of exact p-values
#'
#'@examples
#'permPvals(10, 100, 1000)
#'
#'@export

permPvals <- function(nPermSupObs, nPermEff, totalPossibleNPerm) {

    ## (slightly) adapted from the implementation by Belinda Phipson and
    ## Gordon Smyth from the R package statmod

    nbnodes_quad <- 128
    z <- statmod::gauss.quad.prob(n = nbnodes_quad, l = 0,
                                  u = 0.5/totalPossibleNPerm)
    npvals <- length(nPermSupObs)
    prob <- rep(z$nodes, npvals)
    x2 <- rep(nPermSupObs, each = nbnodes_quad)
    Y <- matrix(data = stats::pbinom(x2, prob = prob, size = nPermEff),
                nrow = nbnodes_quad,
                ncol = npvals)
    int <- 0.5/totalPossibleNPerm * colSums(z$weights * Y)

    pe <- (nPermSupObs + 1)/(nPermEff + 1) - int

    return(pe)
}

#'Asymptotic variance component test statistic and p-value
#'
#'This function computes an approximation of the variance component test based
#'on the asymptotic distribution of a mixture of \eqn{\chi^{2}}s using the saddlepoint
#'method from \code{\link[survey]{pchisqsum}}, as per Chen & Lumley 20219 CSDA.
#'
#'@param y a numeric matrix of dim \code{g x n} containing the raw or normalized
#'RNA-seq counts for g genes from \code{n} samples.
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the \code{p}
#'covariates to be adjusted for
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced
#'to be a \code{factor}.
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} longitudinal variables to be tested (typically a vector of time
#'points or functions of time)
#'
#'@param w numeric matrix of dim \code{G x n} containing the weights for G genes from the \code{n}
#'samples, corresponding to the inverse of the diagonal of the estimated
#'covariance matrix of y.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects corresponding to \code{phi}.
#'
#'@param genewise_pvals a logical flag indicating whether gene-wise p-values
#'should be returned. Default is \code{FALSE} in which case gene set p-value is
#'computed and returned instead.
#'
#'@param homogen_traj a logical flag indicating whether trajectories should be
#'considered homogeneous. Default is \code{FALSE} in which case trajectories
#'are not only tested for trend, but also for heterogeneity.
#'
#'@param na.rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@return A list with the following elements when the set p-value is computed:
#'\itemize{
#'   \item \code{set_score_obs}: the approximation of the observed set score
#'   \item \code{set_pval}: the associated set p-value
#' }
#' or a list with the following elements when gene-wise p-values are computed:
#' \itemize{
#'   \item \code{gene_scores_obs}: vector of approximating the observed
#'   gene-wise scores
#'   \item \code{gene_pvals}: vector of associated gene-wise p-values
#' }
#'
#'
#'@seealso \code{\link[survey]{pchisqsum}}
#'
#'@references
#'Chen T & Lumley T (2019), Numerical evaluation of methods approximating the
#'distribution of a large quadratic form in normal variables, Computational
#'Statistics & Data Analysis, 139:75-81.
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'n <- 100
#'r <- 12
#'t <- matrix(rep(1:(r/4)), 4, ncol=1, nrow=r)
#'sigma <- 0.4
#'b0 <- 1
#'
#'#under the null:
#'b1 <- 0
#'#under the alternative:
#'#b1 <- 0.5
#'y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'x <- matrix(1, ncol=1, nrow=r)
#'
#'#run test
#'asymTestRes <- vc_test_asym(y, x, phi=cbind(t, t^2),
#'                            w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                            Sigma_xi=diag(2), indiv=1:r, genewise_pvals=TRUE)
#'plot(density(asymTestRes$gene_pvals))
#'quantile(asymTestRes$gene_pvals)
#'
#'@importFrom survey pchisqsum
#'@importFrom CompQuadForm davies
#'@importFrom stats pchisq cov
#'@importFrom matrixStats colVars
#'
#'@export
vc_test_asym <- function(y, x, indiv = rep(1, nrow(x)), phi, w,
                         Sigma_xi = diag(ncol(phi)),
                         genewise_pvals = FALSE, homogen_traj = FALSE,
                         na.rm = FALSE) {

    if (homogen_traj) {
        score_list <- vc_score_h(y = y, x = x, indiv = factor(indiv), phi = phi,
                                 w = w, Sigma_xi = Sigma_xi, na_rm = na.rm)
    } else {
        score_list <- vc_score(y = y, x = x, indiv = factor(indiv), phi = phi,
                               w = w, Sigma_xi = Sigma_xi, na_rm = na.rm)
    }

    nindiv <- nrow(score_list$q_ext)
    ng <- nrow(y)
    nphi <- ncol(phi)

    if (ng * nindiv < 1) {
        stop("no gene measured/no sample included ...")
    }

    if (genewise_pvals) {
        gene_scores_obs <- score_list$gene_scores_unscaled
        if (nindiv == 1) {
            pv <- stats::pchisq(gene_scores_obs, df = 1, lower.tail = FALSE)
        } else if (nphi == 1) {
          gene_lambda <- matrixStats::colVars(score_list$q_ext)
          pv <- stats::pchisq(gene_scores_obs/gene_lambda, df = 1,
                              lower.tail = FALSE)
        } else {
            gene_inds <- lapply(seq_len(ng), function(x) {
                x + (ng) * (seq_len(nphi) - 1)
            })

            gene_lambda <- lapply(gene_inds, function(x) {
                Sig_q_gene <- cov(score_list$q_ext[, x, drop = FALSE])
                lam <- tryCatch(eigen(Sig_q_gene, symmetric = TRUE, only.values = TRUE)$values,
                                error=function(cond){return(NULL)}
                )
                if (is.null(lam)){
                    lam <- tryCatch(svd(Sig_q_gene)$d,
                                    error=function(cond){return(NULL)}
                    )
                }
                if (is.null(lam)){
                    lam <- tryCatch(svd(Sig_q_gene)$d,
                                    error=function(cond){
                                        warning("SVD decomposition failed for at least one ",
                                                "gene")
                                        return(NA)
                                    })
                }
                return(lam)
            })
            pv <- try(mapply(FUN = survey::pchisqsum,
                             x = gene_scores_obs,
                             df=1,
                             a = gene_lambda,
                             lower.tail=FALSE,
                             method = "saddlepoint"
            ), silent = TRUE)
            if(inherits(pv, "try-error")){
              ## old slow CompQuadForm::davies method  (sometimes accuracy issues with low p-vals)
              pv <- unlist(mapply(FUN = CompQuadForm::davies,
                                  q = gene_scores_obs,
                                  lambda = gene_lambda, lim = 15000,
                                  acc = 5e-04)["Qq", ])
            }
        }

        names(pv) <- rownames(y)

        ans <- list("gene_scores_obs" = gene_scores_obs,
                    "gene_pvals" = pv)

    } else {

        if (nindiv == 1) {
            Sig_q <- matrix(1, ng, ng)
        } else {
            Sig_q <- cov(score_list$q_ext)
        }

        lam <- tryCatch(eigen(Sig_q, symmetric = TRUE, only.values = TRUE)$values,
                        error=function(cond){return(NULL)}
        )
        if (is.null(lam)) {
            lam <- tryCatch(svd(Sig_q)$d,
                            error=function(cond){return(NULL)}
            )
        }
        if (is.null(lam)) {
            lam <- tryCatch(svd(round(Sig_q, 6))$d,
                            error=function(cond){
                                stop("SVD decomposition failed")
                            })
        }

        dv <- survey::pchisqsum(x = score_list$score,
                                    df=1,
                                    a = lam,
                                    lower.tail = FALSE,
                                    method = "saddlepoint")

        ans <- list("set_score_obs" = score_list$score,
                    "set_pval" = dv)
    }

    return(ans)
}

#' Small portion of RNA-seq data from plant physiology study.
#'
#'A subsample of the RNA-seq data from Baduel \emph{et al.} studying Arabidopsis
#'Arenosa physiology.
#'
#'@name baduel_5gs
#'@rdname baduel_5gs
#'@aliases baduel baduel_5gs baduel_gmt design expr_norm_corr
#'
#'@usage data(baduel_5gs)
#'
#'@references Baduel P, Arnold B, Weisman CM, Hunter B & Bomblies K (2016).
#'Habitat-Associated Life History and Stress-Tolerance Variation in Arabidopsis
#'Arenosa. \emph{Plant Physiology}, 171(1):437-51.
#'\href{https://doi.org/10.1104/pp.15.01875}{10.1104/pp.15.01875}.

#'@references Agniel D & Hejblum BP (2017). Variance component score test for
#'time-course gene set analysis of longitudinal RNA-seq data,
#'\emph{Biostatistics}, 18(4):589-604.
#'\href{https://doi.org/10.1093/biostatistics/kxx005}{10.1093/biostatistics/kxx005}.
#'\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.
#'
#'@format 3 objects\itemize{
#'\item{\code{design}:} a design matrix for the 48 measured samples, containing
#'the following variables:\itemize{
#'  \item \code{SampleName} corresponding column names from
#'  \code{expr_norm_corr}
#'  \item \code{Intercept} an intercept variable
#'  \item \code{Population} a factor identifying the plant population
#'  \item \code{Age_weeks} numeric age of the plant at sampling time (in weeks)
#'  \item \code{Replicate} a purely technical variable as replicates are not
#'  from the same individual over weeks. Should not be used in analysis.
#'  \item \code{Vernalized} a logical variable indicating whether the plant had
#'  undergone vernalization (exposition to cold and short day photoperiods)
#'  \item \code{Vernalized} a binary variable indicating whether the plant
#'  belonged to the KA population
#'  \item \code{AgeWeeks_Population} interaction variable between the
#'  \code{AgeWeeks} and \code{Population} variables
#'  \item \code{AgeWeeks_Vernalized} interaction variable between the
#'  \code{AgeWeeks} and \code{Vernalized} variables
#'  \item \code{Vernalized_Population} interaction variable between the
#'  \code{Vernalized} and \code{Population} variables
#'  \item \code{AgeWeeks_Vernalized_Population} interaction variable between the
#'  \code{AgeWeeks}, \code{Vernalized} and \code{Population} variables
#'}
#'\item{\code{baduel_gmt}:} a \code{gmt} object containing 5 gene sets of
#'interest (see \code{\link[GSA]{GSA.read.gmt}}), which is simply a
#'\code{list} with the 3 following components:\itemize{
#'\item \code{genesets}: a \code{list} of \code{n} gene identifiers vectors 
#'composing eachgene set (each gene set is represented as the vector of the 
#'gene identifiers composing it)
#'\item \code{geneset.names}: a vector of length \code{n} containing the gene 
#'set names (i.e. gene sets identifiers)
#'\item{geneset.descriptions}: a vector of length \code{n} containing gene set 
#'descriptions (e.g. textual information on their biological function)
#'}
#'
#'\item{\code{expr_norm_corr}:} a numeric matrix containing the normalized batch
#'corrected expression for the 2454 genes included in either of the 5 gene sets
#'of interests
#'}
#'
#'@examples
#' if(interactive()){
#' data('baduel_5gs')
#'
#' set.seed(54321)
#' KAvsTBG <- dgsa_seq(exprmat=log2(expr_norm_corr+1),
#'                     covariates=apply(as.matrix(design[,
#'   c('Intercept', 'Vernalized', 'AgeWeeks', 'Vernalized_Population',
#'   'AgeWeeks_Population'), drop=FALSE]), 2, as.numeric),
#'                      variables2test =
#'                          as.matrix(design[, c('PopulationKA'), drop=FALSE]),
#'                      genesets=baduel_gmt$genesets[c(3,5)],
#'                      which_test = 'permutation', which_weights = 'loclin',
#'                      n_perm=1000, preprocessed = TRUE)
#'
#' set.seed(54321)
#' Cold <- dgsa_seq(exprmat=log2(expr_norm_corr+1),
#'                  covariates=apply(as.matrix(design[,
#'    c('Intercept', 'AgeWeeks', 'PopulationKA', 'AgeWeeks_Population'),
#'    drop=FALSE]), 2, as.numeric),
#'                 variables2test=as.matrix(design[, c('Vernalized',
#'                  'Vernalized_Population')]),
#'                  genesets=baduel_gmt$genesets[c(3,5)],
#'                  which_test = 'permutation', which_weights = 'loclin',
#'                  n_perm=1000, preprocessed = TRUE)
#' }
#'
#'
#' @source \url{http://www.ncbi.nlm.nih.gov/bioproject/PRJNA312410}
#'
#' @keywords datasets
#' @docType data
NULL

#'Computes variance component score test statistics
#'
#'This function computes the variance component score test statistics
#'
#'@keywords internal
#'
#'@param y a numeric matrix of dim \code{g x n} containing the raw RNA-seq
#'counts for g genes from \code{n} samples.
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the \code{p}
#'covariates to be adjusted for.
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced
#'to be a \code{factor}.
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} variables to .be tested
#'
#'@param w a vector of length \code{n} containing the weights for the \code{n}
#'samples.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects on \code{phi}.
#'
#'@param na_rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@return A list with the following elements:\itemize{
#'   \item \code{score}: approximation of the set observed score
#'   \item \code{q}: observation-level contributions to the score
#'   \item \code{q_ext}: pseudo-observations used to compute the covariance,
#'    taking into account the contributions of OLS estimates
#'   \item \code{gene_scores_unscaled}: a vector of the approximations of the
#'   individual gene scores
#' }
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'n <- 100
#'r <- 12
#'t <- matrix(rep(1:3), r/3, ncol=1, nrow=r)
#'sigma <- 0.4
#'b0 <- 1
#'
#'#under the null:
#'b1 <- 0
#'#under the alternative:
#'b1 <- 0.7
#'y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'x <- matrix(1, ncol=1, nrow=r)
#'
#'#run test
#'scoreTest <- vc_score(y, x, phi=t, w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
#'                     Sigma_xi=matrix(1), indiv=rep(1:(r/3), each=3))
#'scoreTest$score
#'
#'@importFrom stats model.matrix
#'
#'@export
vc_score <- function(y, x, indiv, phi, w, Sigma_xi = diag(ncol(phi)),
                     na_rm = FALSE) {
    ## validity checks
    if (sum(!is.finite(w)) > 0) {
        stop("At least 1 non-finite weight in 'w'")
    }

    ## dimensions check------
    stopifnot(is.matrix(y))
    stopifnot(is.matrix(x))
    stopifnot(is.matrix(phi))

    g <- nrow(y)  # the number of genes measured
    n <- ncol(y)  # the number of samples measured
    p <- ncol(x)  # the number of covariates
    n_t <- ncol(phi)  # the number of time bases
    stopifnot(nrow(x) == n)
    stopifnot(nrow(w) == g)
    stopifnot(ncol(w) == n)
    stopifnot(nrow(phi) == n)
    stopifnot(length(indiv) == n)


    # the number of random effects
    if (length(Sigma_xi) == 1) {
        K <- 1
        Sigma_xi <- matrix(Sigma_xi, K, K)
    } else {
        K <- nrow(Sigma_xi)
        stopifnot(ncol(Sigma_xi) == K)
    }
    stopifnot(n_t == K)


    ## data formating ------
    indiv <- as.factor(indiv)
    nb_indiv <- length(levels(indiv))

    ## OLS for conditional mean -----
    y_T <- t(y)
    if (na_rm & sum(is.na(y_T)) > 0) {
        y_T0 <- y_T
        y_T0[is.na(y_T0)] <- 0
        yt_mu <- y_T - x %*% solve(crossprod(x)) %*% t(x) %*% y_T0
    } else {
        yt_mu <- y_T - x %*% solve(crossprod(x)) %*% t(x) %*% y_T
    }
    ## x_tilde_list <- y_tilde_list <- Phi_list <- list()
    ## for (i in 1:nb_indiv) {
    ##     select <- indiv==levels(indiv)[i]
    ##     n_i <- length(which(select))
    ##     x_i <- x[select,]
    ##     y_i <- y[,select]
    ##     phi_i <- phi[select,]
    ##     Phi_list[[i]] <- kronecker(diag(g), phi_i)
    ##     x_tilde_list[[i]] <- kronecker(diag(g), x_i)
    ##     y_tilde_list[[i]] <- matrix(t(y_i), ncol=1)
    ## }
    ## x_tilde <- do.call(rbind, x_tilde_list)
    ## y_tilde <- do.call(rbind, y_tilde_list)
    ## Phi <- do.call(rbind, Phi_list)
    ## alpha <- solve(t(x_tilde)%*%x_tilde)%*%t(x_tilde)%*%y_tilde
    ## mu_new <- x_tilde %*% alpha
    ## y_mu <- y_tilde - mu_new


    ## test statistic computation ------
    ## q <- matrix(NA, nrow=nb_indiv, ncol=g*K)
    ## XT_i <- array(NA, c(nb_indiv, g*p, g*K))
    ## U <- matrix(NA, nrow = nb_indiv, ncol = p*g)
    ## long_indiv <- rep(indiv, each = g)
    ## xtx_inv <- solve(t(x_tilde) %*% x_tilde)
    ## Sigma_xi_new_sqrt <- kronecker(diag(g), (Sigma_xi*diag(K))%^% (-0.5))
    ## for (i in 1:nb_indiv){ #for all the genes at once
    ##     select <- indiv==levels(indiv)[i]
    ##     long_select <- long_indiv==levels(indiv)[i]
    ##     y_mu_i <- as.vector(y_mu[long_select,])
    ##     y_tilde_i <- c(t(y_ij))
    ##     x_tilde_i <- x_tilde[long_select,]
    ##     sigma_eps_inv_diag <- as.vector(t(w)[select,])#/sigma
    ##     T_i <- sigma_eps_inv_diag*(Phi[long_select,] %*% Sigma_xi_new_sqrt)
    ##     q[i,] <- c(y_mu_i %*% T_i)
    ##     XT_i[i,,] <- t(x_tilde_i) %*% T_i
    ##     U[i,] <- xtx_inv %*% t(x_tilde_i) %*% y_mu_i }
    ## XT <- colMeans(XT_i) q_ext <- q - U %*% XT

    ## sig_eps_inv <- w/sigma #no need as this just scales the test statistics

    sig_xi_sqrt <- (Sigma_xi * diag(K)) %^% (-0.5)
    sig_eps_inv_T <- t(w)
    phi_sig_xi_sqrt <- phi %*% sig_xi_sqrt

    T_fast <- do.call(cbind, replicate(K, sig_eps_inv_T, simplify = FALSE)) *
        matrix(apply(phi_sig_xi_sqrt, 2, rep, g), ncol = g * K)
    ##---------------------
    ## the structure of T_fast is time_basis_1*gene_1, time_basis_1*gene_2, ...,
    ## time_basis_1*gene_p, ..., time_basis_K*gene_1, ..., time_basis_K*gene_p
    ##----------------------------
    q_fast <- matrix(yt_mu, ncol = g * n_t, nrow = n) * T_fast

    ## dplyr seems to be less efficient here
    ## q_fast_tb <- tibble::as_tibble(cbind.data.frame(indiv, q_fast))
    ## q_dp <- q_fast_tb %>% group_by(indiv) %>% summarise_all(sum)

    ## aggregate is much slower also
    ## qtemp <- aggregate(. ~ indiv, cbind.data.frame(indiv, q_fast), sum)
    ## qtemp <- aggregate(. ~ indiv, cbind.data.frame(indiv, q_fast), sum)

    ## data.table hard to test, but seems to be at least 10 times slower on big
    ## datasets (weird)
    ## m_dt <- data.table('indiv'=factor(rep(c(1:20), each=5)), mbig)
    ## temp <- m_dt[, lapply(.SD, sum), by=indiv]


    # the 2 'by' statements below used to represent the longest AND most memory
    # intensive part of this for genewise analysis:
    if (length(levels(indiv)) > 1) {
        indiv_mat <- stats::model.matrix(~0 + factor(indiv))
    } else {
        indiv_mat <- matrix(as.numeric(indiv), ncol = 1)
    }

    if (na_rm & sum(is.na(q_fast)) > 0) {
        q_fast[is.na(q_fast)] <- 0
    }
    q <- crossprod(indiv_mat, q_fast)
    XT_fast <- crossprod(x, T_fast)/nb_indiv
    avg_xtx_inv_tx <- nb_indiv * tcrossprod(solve(crossprod(x, x)), x)
    U_XT <- matrix(yt_mu, ncol = g * n_t, nrow = n) *
        crossprod(avg_xtx_inv_tx, XT_fast)
    if (na_rm & sum(is.na(U_XT)) > 0) {
        U_XT[is.na(U_XT)] <- 0
    }
    U_XT_indiv <- crossprod(indiv_mat, U_XT)
    q_ext <- q - U_XT_indiv
    # sapply(1:6, function(i){(q_ext[i,] - q_ext_fast_indiv[i,])})



    qq <- colSums(q, na.rm = na_rm)^2/nb_indiv  # genewise scores

    ##qq <- unlist(by(data=matrix(qq, ncol=1), INDICES=rep(1:g, K), FUN=sum,
    ##                simplify = FALSE)) # veryslow
    ## gene_inds <- lapply(1:g, function(x){x + (g)*(0:(K-1))})
    ## gene_Q <- sapply(gene_inds, function(x) sum(qq[x])) # old computation
    ## gene_Q <- tcrossprod(qq, matrix(diag(g), nrow=g, ncol=g*K))[1, ] # faster
    gene_Q <- rowSums(matrix(qq, ncol = K))  # even faster

    QQ <- sum(qq)  #nb_indiv=nrow(q) # set score

    return(list(score = QQ, q = q, q_ext = q_ext,
                gene_scores_unscaled = gene_Q))
}

#'Power for covaroances matrices
#'
#'Compute the power of a positive definite symmetric
#'
#'@param x a positive definite symmetric matrix
#'
#'@param n a real number
#'
#'@return a matrix of the same dimensions as \code{x}
#'
#'@keywords internal

"%^%" <- function(x, n) {
    x_pow <- eigen(x)
    x_pow$vectors %*% (x_pow$values^n * t(x_pow$vectors))
}

#'Time-course Gene Set Analysis
#'
#'Wrapper function for performing gene set analysis of (potentially
#'longitudinal) RNA-seq data
#'
#'@param exprmat a numeric matrix of size \code{G x n} containing the raw
#'RNA-seq counts or preprocessed expressions from \code{n} samples for \code{G}
#'genes. Default is \code{NULL}, in which case \code{object} must not be
#'\code{NULL}.
#'
#'@param object an object that can be either an
#'\code{\link[SummarizedExperiment:RangedSummarizedExperiment-class]{SummarizedExperiment}},
#'an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, a
#'\code{\link[DESeq2:DESeqDataSet]{DESeqDataSet}}, or a
#'\code{\link[edgeR:DGEList]{DGEList}}.
#'Default is \code{NULL}, in which case \code{exprmat} must not be
#'\code{NULL}.
#'
#'@param covariates \itemize{
#'\item If \code{exprmat} is specified as a matrix:
#'then \code{covariates} must be a numeric matrix of size \code{n x p}
#'containing the model covariates for \code{n} samples (design matrix).
#'Usually, its first column is the intercept (full of \code{1}s).
#'\item If \code{object} is specified: then \code{covariates} must be a
#'character vector of length \code{p} containing the colnames of the
#'design matrix given in \code{object}.
#'} If \code{covariates} is \code{NULL} (the default), then it is just the
#'intercept.
#'
#'@param variables2test \itemize{
#'\item If \code{exprmat} is specified as a matrix:
#'a numeric design matrix of size \code{n x K} containing
#'the \code{K} variables to be tested.
#'\item If \code{object} is specified: then \code{variables2test} must be a
#'character vector of length \code{K} containing the colnames of the
#'design matrix given in \code{object}.
#'}
#'
#'@param weights_var2test_condi a logical flag indicating whether
#'heteroscedasticity weights computation should be conditional on both the
#'variable(s) to be tested \code{phi} and on covariate(s) \code{x}, or on
#'\code{x} alone.  Default is \code{TRUE} for the asymptotic test
#'(in which case conditional means are estimated conditionally on both
#'\code{variables2test} and \code{covariates}), and \code{FALSE} for the
#'permutation test (in which case conditional means are estimated
#'conditionally on only the  \code{covariates}).
#'
#'@param genesets Can be either:\itemize{
#'\item a \code{vector}
#'\item a \code{list}
#'\item a \code{BiocSet} object
#'}
#'Can be a vector of index or subscripts that defines which
#'rows of \code{y} constitute the investigated gene set (when only 1 gene
#'set is being tested).
#'
#'Can also be a \code{list} of index (or \code{rownames} of \code{y}) when
#'several gene sets are tested at once, such as the first element of a
#'\code{\link[GSA:GSA.read.gmt]{gmt}} object.
#'
#'Finally, can also be a \code{\link[BiocSet:BiocSet-class]{BiocSet}} object
#'
#'If \code{NULL}, then gene-wise p-values are returned.
#'
#'@param sample_group a vector of length \code{n} indicating whether the samples
#'should be grouped (e.g. paired samples or longitudinal data). Coerced
#'to be a \code{factor}. Default is \code{NULL} in which case no grouping is
#'performed.
#'
#'@param cov_variables2test_eff a matrix of size \code{K x K} containing the
#'covariance matrix of the \code{K} random effects. Only used if
#'\code{homogen_traj} is \code{FALSE}. Default assume diagonal correlation
#'matrix, i.e. independence of random effects.
#'
#'@param which_weights a character string indicating which method to use to
#'estimate the mean-variance relationship weights. Possibilities are
#'\code{'loclin'}, \code{'voom'} or \code{'none'} (in which case no weighting is
#'performed). Default is \code{'loclin'}.
#'See \code{\link{sp_weights}} and \code{\link{voom_weights}} for details.
#'
#'@param which_test a character string indicating which method to use to
#'approximate the variance component score test, either \code{'permutation'} or
#'\code{'asymptotic'}. Default is \code{'permutation'}.
#'
#'@param n_perm the number of perturbations. Default is \code{1000}.
#'
#'@param progressbar logical indicating wether a progressBar should be displayed
#'when computing permutations (only in interactive mode).
#'
#'@param parallel_comp a logical flag indicating whether parallel computation
#'should be enabled. Only Linux and MacOS are supported, this is ignored on
#'Windows. Default is \code{TRUE}.
#'
#'@param nb_cores an integer indicating the number of cores to be used when
#'\code{parallel_comp} is \code{TRUE}.
#'Default is \code{parallel::detectCores(logical=FALSE) - 1}.
#'
#'@param preprocessed a logical flag indicating whether the expression data have
#'already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
#'which case \code{y} is assumed to contain raw counts and is normalized into
#'log(counts) per million.
#'
#'@param gene_based_weights a logical flag used for \code{'loclin'} weights,
#'indicating whether to estimate weights at the gene-level, or rather at the
#'observation-level. Default is \code{TRUE}, and weights are then estimated at
#'the gene-level.
#'
#'@param bw a character string indicating the smoothing bandwidth selection
#'method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
#' are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}
#'
#'@param kernel a character string indicating which kernel should be used.
#'Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
#'\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
#'\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
#'\code{'gaussian'} (NB: \code{'tricube'} kernel
#'corresponds to the loess method).
#'
#'@param transform a logical flag used for \code{'loclin'} weights, indicating
#'whether values should be transformed to uniform for the purpose of local
#'linear smoothing. This may be helpful if tail observations are sparse and the
#'specified bandwidth gives suboptimal performance there. Default is
#'\code{TRUE}.
#'
#'@param padjust_methods multiple testing correction method used if
#'\code{genesets} is a list. Default is 'BH', i.e. Benjamini-Hochberg procedure
#'for controlling the FDR. Other possibilities are: \code{'holm'},
#'\code{'hochberg'}, \code{'hommel'}, \code{'bonferroni'} or \code{'BY'}
#'(for Benjamini-Yekutieli procedure).
#'
#'@param lowess_span smoother span for the lowess function, between 0 and 1.
#'This gives the proportion of points in the plot which influence the smooth at
#'each value. Larger values give more smoothness. Only used if
#'\code{which_weights} is \code{'voom'}. Default is \code{0.5}.
#'
#'@param R library size (optional, important to provide if
#'\code{preprocessed = TRUE}). Default is \code{NULL}
#'
#'@param adaptive a logical flag indicating whether adaptive permutation should
#'be performed. Default is \code{TRUE}
#'
#'@param max_adaptive The maximum number of permutations considered.
#'Default is \code{64000}
#'
#'@param homogen_traj a logical flag indicating whether trajectories should be
#'considered homogeneous. Default is \code{FALSE} in which case trajectories are
#'not only tested for trend, but also for heterogeneity.
#'
#'@param na.rm_gsaseq logical: should missing values in \code{y} (including
#'\code{NA} and \code{NaN}) be omitted from the calculations?
#'Default is \code{TRUE}.
#'
#'@param verbose logical: should informative messages be printed during the
#'computation? Default is \code{TRUE}.
#'
#'@return A list with the following elements:\itemize{
#'   \item \code{which_test}: a character string carrying forward the value of
#'   the '\code{which_test}' argument indicating which test was perform (either
#'   'asymptotic' or 'permutation').
#'   \item \code{preprocessed}: a logical flag carrying forward the value of the
#'   '\code{preprocessed}' argument indicating whether the expression data were
#'   already preprocessed, or were provided as raw counts and transformed into
#'   log-counts per million.
#'   \item \code{n_perm}: an integer carrying forward the value of the
#'   '\code{n_perm}' argument indicating the number of perturbations performed
#'   (\code{NA} if asymptotic test was performed).
#'   \item \code{genesets}: carrying forward the value of the '\code{genesets}'
#'   argument defining the gene sets of interest (\code{NULL} for gene-wise t
#'   esting).
#'   \item \code{pval}: computed p-values. A \code{data.frame} with one raw for
#'   each each gene set, or for each gene if \code{genesets} argument is
#'   \code{NULL}, and with 2 columns: the first one '\code{rawPval}' contains
#'   the raw p-values, the second one contains the FDR adjusted p-values
#'   (according to the '\code{padjust_methods}' argument) and is named
#'   '\code{adjPval}'.
#' }
#'
#'@seealso \code{\link{sp_weights}} \code{\link{vc_test_perm}}
#'\code{\link{vc_test_asym}} \code{\link{p.adjust}}
#'
#'@references Agniel D & Hejblum BP (2017). Variance component score test for
#'time-course gene set analysis of longitudinal RNA-seq data,
#'\emph{Biostatistics}, 18(4):589-604.
#'\href{https://doi.org/10.1093/biostatistics/kxx005}{10.1093/biostatistics/kxx005}.
#'\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.
#'
#'@references Law, C. W., Chen, Y., Shi, W., & Smyth, G. K. (2014). voom:
#'Precision weights unlock linear model analysis tools for RNA-seq read counts.
#'\emph{Genome Biology}, 15(2), R29.
#'
#'@importFrom stats p.adjust as.formula model.matrix
#'@importFrom matrixStats rowVars
#'@importFrom methods is
#'
#'@examples
#'
#'nsims <- 2 #100
#'res_quant <- list()
#'for(i in 1:2){
#'  n <- 2000#0
#'  nr <- 3
#'  r <- nr*20 #4*nr#100*nr
#'  t <- matrix(rep(1:nr), r/nr, ncol=1, nrow=r)
#'  sigma <- 0.4
#'  b0 <- 1
#'
#'  #under the null:
#'  b1 <- 0
#'
#'  y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'  y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'         matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'  x <- matrix(1, ncol=1, nrow=r)
#'
#'  #run test
#'  res <- dgsa_seq(exprmat = y, covariates = x, variables2test = t,
#'                 genesets=lapply(0:9, function(x){x*10+(1:10)}),
#'                 cov_variables2test_eff = matrix(1),
#'                 sample_group = rep(1:(r/nr), each=nr),
#'                 which_test='asymptotic',
#'                 which_weights='none', preprocessed=TRUE)
#'  res_genes <- dgsa_seq(exprmat = y, covariates = x,
#'                       variables2test = cbind(t),#, rnorm(r)), #t^2
#'                       genesets = NULL,
#'                       cov_variables2test_eff = diag(1),
#'                       sample_group = rep(1:(r/nr), each=nr),
#'                       which_test = 'asymptotic',
#'                       which_weights = 'none', preprocessed = TRUE)
#'  length(res_genes$pvals[, 'rawPval'])
#'  quantile(res_genes$pvals[, 'rawPval'])
#'  res_quant[[i]] <- res_genes$pvals[, 'rawPval']
#'}
#'
#'
#'#round(rowMeans(vapply(res_quant, FUN = quantile, FUN.VALUE = rep(1.1, 5))), 3)
#'#plot(density(unlist(res_quant)))
#'#mean(unlist(res_quant)<0.05)
#'
#'if(interactive()){
#'res_genes <- dgsa_seq(exprmat = y, covariates = x, variables2test = t,
#'                     genesets = NULL,
#'                     cov_variables2test_eff = matrix(1),
#'                     sample_group = rep(1:(r/nr), each=nr),
#'                     which_test = 'permutation',
#'                     which_weights = 'none', preprocessed = TRUE,
#'                     n_perm = 1000, parallel_comp = FALSE)
#'
#'mean(res_genes$pvals$rawPval < 0.05)
#'summary(res_genes$pvals$adjPval)
#'}
#'@export
dgsa_seq <- function(exprmat = NULL, object = NULL,
                     covariates = NULL,
                     variables2test,
                     weights_var2test_condi = (which_test != "permutation"),
                     genesets,
                     sample_group = NULL,
                     cov_variables2test_eff = NULL,
                     which_test = c("permutation", "asymptotic"),
                     which_weights = c("loclin", "voom", "none"),
                     n_perm = 1000, progressbar = TRUE, parallel_comp = TRUE,
                     nb_cores = parallel::detectCores(logical=FALSE) - 1,
                     preprocessed = FALSE,
                     gene_based_weights = TRUE,
                     bw = "nrd",
                     kernel = c("gaussian", "epanechnikov", "rectangular",
                                "triangular", "biweight", "tricube", "cosine",
                                "optcosine"),
                     transform = TRUE,
                     padjust_methods = c("BH", "BY", "holm", "hochberg",
                                         "hommel", "bonferroni"),
                     lowess_span = 0.5,
                     R=NULL,
                     adaptive = TRUE, max_adaptive = 64000,
                     homogen_traj = FALSE,
                     na.rm_gsaseq = TRUE,
                     verbose = TRUE) {

  if(weights_var2test_condi & which_test == "permutation"){
      warning("`weights_var2test_condi` must be FALSE for the ",
              "permutation test, as `phi` gets permuted.")
      weights_var2test_condi <- FALSE
      message("Setting `weights_var2test_condi` to FALSE ",
              "with the permutation test.")
  }

  if(!is.null(object) & !is.null(exprmat)){
    stop("only one of 'object' or 'exprmat' should be specified")
  }
  if(is.null(object) & is.null(exprmat)){
    stop("One of either 'object' or 'exprmat' should be specified")
  }
  stopifnot(!is.null(variables2test))

  if(!is.null(object)){

    stopifnot(is.character(covariates) | is.null(covariates))
    stopifnot(is.character(variables2test))

    if(is(object, "DGEList")){
      stopifnot(!is.null(object$samples))
      stopifnot(nrow(object$samples)==ncol(object$counts))
      y <- object$counts
      design_df <- as.data.frame(object$samples[, c(covariates,
                                                    variables2test),
                                                drop=FALSE])
    }else if(is(object, "DESeqDataSet")){
      if(!requireNamespace("DESeq2", quietly = TRUE)){
        stop("DESeq2 package required but is not available")
      }
      if(!requireNamespace("SummarizedExperiment", quietly = TRUE)){
        stop("SummarizedExperiment package required but not available")
      }
      stopifnot(!is.null(SummarizedExperiment::colData(object)))
      stopifnot(nrow(SummarizedExperiment::colData(object)) ==
                  DESeq2::counts(object))
      y <- DESeq2::counts(object)
      design_df <- as.data.frame(SummarizedExperiment::colData(object)[, c(covariates, variables2test), drop=FALSE])
    }else if(is(object, "ExpressionSet")){
      if(!requireNamespace("Biobase",quietly=TRUE)){
        stop("Biobase package required but not available")
      }
      stopifnot(!is.null(Biobase::phenoData(object)))
      stopifnot(nrow(Biobase::phenoData(object)) ==
                  ncol(Biobase::exprs(object)))
      y <- Biobase::exprs(object)
      design_df <- as.data.frame(Biobase::phenoData(object)[, c(covariates, variables2test), drop=FALSE])
    }else if(is(object, "SummarizedExperiment")){
      #Note: DESeqDataSet are SummarizedExperiments
      if(!requireNamespace("SummarizedExperiment", quietly = TRUE)){
        stop("SummarizedExperiment package required but is not available")
      }
      y <- SummarizedExperiment::assay(object)
      design_df <- as.data.frame(SummarizedExperiment::colData(object)[, c(covariates, variables2test), drop=FALSE])
    }else{
      stop("'object' is neither a 'DGEList', nor a 'DESeqDataSet',",
           "nor an 'ExpressionSet'.\n",
           "Consider specifying 'exprmat' as a matrix instead...")
    }

    variables2test_formula <- stats::as.formula(paste0("~ 1 + ",
                                                       variables2test,
                                                       collapse=" + "))
    if(is.null(covariates)){
      covariates_formula <- stats::as.formula("~1")
    }else{
      covariates_formula <- stats::as.formula(paste0("~ 1 + ",
                                                     covariates,
                                                     collapse=" + "))
    }

    x <- stats::model.matrix(covariates_formula,
                             data = droplevels(design_df))
    phi <- stats::model.matrix(variables2test_formula,
                               data = droplevels(design_df))[, -1,
                                                             drop=FALSE]
  }else{
    if(is.null(covariates)){
      covariates <- matrix(1, ncol=1, nrow=nrow(variables2test))
    }
    y <- exprmat
    x <- covariates
    phi <- variables2test
  }

  stopifnot(is.matrix(y))
  stopifnot(is.matrix(x) | is.data.frame(x))
  stopifnot(is.matrix(phi) | is.data.frame(phi))

  if (sum(is.na(y)) > 0 & na.rm_gsaseq) {
    warning("'y' contains ", sum(is.na(y)), " `NA` values. ",
            "Currently they are ignored in the computations but ",
            "you should think carefully about where do those NA/NaN ",
            "come from... If you want to carry over those NA/NaN ",
            "values in the results, set the `na.rm_gsaseq` argument to 'FALSE' ",
            "(this has not been fully tested ",
            "and should be used with extreme care).")
  }

  if(is.null(cov_variables2test_eff)){
    cov_variables2test_eff <- diag(ncol(phi))
  }

  # checking for 0 variance genes
  v_g <- matrixStats::rowVars(y, na.rm = TRUE)
  if(sum(v_g == 0) > 0){
    warning("Removing ", sum(v_g == 0), " genes with 0 variance from ",
            "the testing procedure.\n",
            "  !! Those genes should probably have been removed ",
            "beforehand...")
    y <- y[v_g>0, ]
  }

  # normalization if needed
  if (!preprocessed) {
    R <- colSums(y, na.rm = TRUE)
    y_lcpm <- apply(y, MARGIN = 2, function(v) {
      log2((v + 0.5)/(sum(v, na.rm = TRUE) + 1) * 10^6)
    })
  } else {
    y_lcpm <- y
  }

  if (is.data.frame(x)) {
    message("'x' is a data.frame -> converted to a matrix: ",
            "\n all variables (including factors) are converted ",
            "to numeric...")
    x <- as.matrix(as.data.frame(lapply(x, as.numeric)))
  }

  if (is.data.frame(phi)) {
    message("'phi' is a data.frame -> converted to a matrix: ",
            "\n all variables (including factors) are ",
            "converted to numeric... ")
    phi <- as.matrix(as.data.frame(lapply(phi, as.numeric)))
  }

  if (det(crossprod(cbind(x, phi))) == 0) {
    stop("crossprod(cbind(x, phi)) cannot be inversed. 'x' and ",
         "'phi' are likely colinear...")
  }

  if (length(padjust_methods) > 1) {
    padjust_methods <- padjust_methods[1]
  }
  stopifnot(padjust_methods %in% c("BH", "BY", "holm", "hochberg",
                                   "hommel", "bonferroni"))

  if (length(which_weights) > 1) {
    which_weights <- which_weights[1]
  }
  stopifnot(which_weights %in% c("loclin", "voom", "none"))

  if (length(which_test) > 1) {
    which_test <- which_test[1]
  }
  stopifnot(which_test %in% c("asymptotic", "permutation"))


  if (which_test == "asymptotic") {
    n_perm <- NA

    if (nrow(x) < 10)
      warning("Less than 10 samples: asymptotics likely not ",
              "reached\nYou should probably run permutation test ",
              "instead...")
  }



  if (which_test == "permutation") {
    if (is.null(sample_group)) {
      #suppressWarnings(
      N_possible_perms <- factorial(ncol(y_lcpm))
      #)
    } else {
      # suppressWarnings(
      N_possible_perms <- prod(vapply(table(sample_group), factorial,
                                      FUN.VALUE = 1))
      #)
    }

    if (n_perm > N_possible_perms) {
      warning("The number of permutations requested 'n_perm' is ",
              n_perm, "which is larger than the total number of ",
              "existing permutations ", N_possible_perms,
              ". Try a lower number for 'n_perm' (currently ",
              "running with 'nperm=", N_possible_perms, "').")
      n_perm <- N_possible_perms
    }
  }



  # Computing the weights
  if (which_weights != "none" & verbose) {
    message("Computing the weights... ")
  }
  w_full <- switch(which_weights,
                   loclin = sp_weights(y = y_lcpm, x = x, phi = phi,
                                       use_phi = weights_var2test_condi,
                                       preprocessed = TRUE,
                                       gene_based = gene_based_weights,
                                       bw = bw, kernel = kernel,
                                       transform = transform,
                                       verbose = verbose,
                                       na.rm = na.rm_gsaseq),
                   voom = voom_weights(y = y_lcpm,
                                       x = if(weights_var2test_condi) {
                                         cbind(x, phi)
                                       } else {
                                         x
                                       }, preprocessed = TRUE,
                                       lowess_span = lowess_span,
                                       R = R),
                   none = list(
                     "weights" = matrix(1, ncol = ncol(y_lcpm),
                                        nrow = nrow(y_lcpm),
                                        dimnames = list(rownames(y_lcpm),
                                                        colnames(y_lcpm))),
                     "plot_utilities" = list("method" = "none"))
  )
  if (which_weights != "none" & verbose) {
    message("Done!\n")
  }
  w <- w_full$weights


  if (is.null(genesets)) {
    if (verbose) {
      message("'genesets' argument not provided => only gene-wise ",
              "p-values are computed\n")
    }
    if (which_test == "asymptotic") {
      if (is.null(sample_group)) {
        sample_group <- seq_len(nrow(x))
      }
      rawPvals <- vc_test_asym(y = y_lcpm, x = x, indiv = sample_group,
                               phi = phi, w = w,
                               Sigma_xi = cov_variables2test_eff,
                               genewise_pvals = TRUE,
                               homogen_traj = homogen_traj,
                               na.rm = na.rm_gsaseq)$gene_pvals
    } else if (which_test == "permutation") {
      if (is.null(sample_group)) {
        sample_group <- rep(1, nrow(x))
      }

      # constructing residuals
      if (na.rm_gsaseq) {
        y_lcpm0 <- y_lcpm
        y_lcpm0[is.na(y_lcpm0)] <- 0
        y_lcpm_res <- y_lcpm - t(x %*% solve(crossprod(x)) %*% t(x) %*%
                                   t(y_lcpm0))
      } else {
        y_lcpm_res <- y_lcpm - t(x %*% solve(crossprod(x)) %*% t(x) %*%
                                   t(y_lcpm))
      }
      x_res <- matrix(1, nrow = nrow(x), ncol = 1)
      perm_result <- vc_test_perm(y = y_lcpm_res, x = x_res,
                                  indiv = sample_group, phi = phi, w = w,
                                  Sigma_xi = cov_variables2test_eff,
                                  n_perm = n_perm,
                                  progressbar = progressbar,
                                  parallel_comp = parallel_comp,
                                  nb_cores = nb_cores,
                                  genewise_pvals = TRUE,
                                  adaptive = adaptive,
                                  max_adaptive = max_adaptive,
                                  homogen_traj = homogen_traj,
                                  na.rm = na.rm_gsaseq)
      rawPvals <- perm_result$gene_pvals
    }

    pvals <- data.frame(rawPval = rawPvals,
                        adjPval = stats::p.adjust(rawPvals, padjust_methods)
    )

    if (!is.null(rownames(y_lcpm))) {
      rownames(pvals) <- rownames(y_lcpm)
    }
  } else {
    if(is(genesets, "BiocSet")){
      genesets <- BiocSet::es_elementset(genesets)
      genesets_names <- unique(genesets$set)
      genesets <- lapply(X  = unique(genesets$set),
                         FUN = function(x){
                           genesets[genesets$set == x,]$element
                         }
      )
      names(genesets) <- genesets_names

    }
    if (!is.list(genesets)) {
      if (!is.vector(genesets)) {
        stop("'genesets' argument provided but is neither a list ",
             ", a vector, nor a BiocSet object")
      }

      if (is(genesets, "character")) {
        if (is.null(rownames(y_lcpm))) {
          stop("Gene sets specified as character but no rownames",
               "available for the expression matrix")
        }
        gene_names_measured <- rownames(y_lcpm)
        if ((length(intersect(genesets,
                              gene_names_measured))/length(x)) != 1) {
          message("Some transcripts in the investigated gene set ",
                  "were not measured:\n-> automatically removing ",
                  "those transcripts from the gene set definition")
          genesets <- genesets[which(genesets %in%
                                       gene_names_measured)]
        }
      }
      padjust_methods <- NA
      genesets <- list(genesets)
    }

    if (is(genesets[[1]], "character")) {
      if (is.null(rownames(y_lcpm))) {
        stop("Gene sets specified as character but no rownames ",
             "available for the expression matrix")
      }
      gene_names_measured <- rownames(y_lcpm)
      prop_meas <- vapply(genesets, function(x) {
        length(intersect(x, gene_names_measured))/length(x)
      }, FUN.VALUE = 1)
      if (sum(prop_meas, na.rm = TRUE) != length(prop_meas)) {
        warning("Some transcripts in the investigated gene sets were ",
                "not measured:\nremoving those transcripts from the ",
                "gene set definition...")
        genesets <- lapply(genesets, function(x) {
          x[which(x %in% gene_names_measured)]
        })
      }
    }

    if (which_test == "asymptotic") {
      if (is.null(sample_group)) {
        sample_group <- seq_len(nrow(x))
      }
      rawPvals <- vapply(seq_along(genesets), FUN = function(i_gs) {
        gs <- genesets[[i_gs]]
        e <- tryCatch(y_lcpm[gs, 1, drop = FALSE],
                      error=function(cond){return(NULL)})
        if (length(e) < 1) {
          warning("Gene set ", i_gs, " contains 0 measured ",
                  "transcript: associated p-value cannot ",
                  "be computed")
          NA
        } else {
          vc_test_asym(y = y_lcpm[gs, , drop = FALSE], x = x,
                       indiv = sample_group, phi = phi,
                       w = w[gs, , drop = FALSE],
                       Sigma_xi = cov_variables2test_eff,
                       genewise_pvals = FALSE,
                       homogen_traj = homogen_traj,
                       na.rm = na.rm_gsaseq
          )$set_pval
        }
      }, FUN.VALUE = 0.5)
    } else if (which_test == "permutation") {
      if (is.null(sample_group)) {
        sample_group <- rep(1, nrow(x))
      }

      if (na.rm_gsaseq) {
        y_lcpm0 <- y_lcpm
        y_lcpm0[is.na(y_lcpm0)] <- 0
        y_lcpm_res <- y_lcpm - t(x %*% solve(crossprod(x)) %*% t(x) %*%
                                   t(y_lcpm0))
      } else {
        y_lcpm_res <- y_lcpm - t(x %*% solve(crossprod(x)) %*% t(x) %*%
                                   t(y_lcpm))
      }

      x_res <- matrix(1, nrow = nrow(x), ncol = 1)
      rawPvals <- vapply(seq_along(genesets), FUN = function(i_gs) {
        gs <- genesets[[i_gs]]
        e <- tryCatch(y_lcpm[gs, 1, drop = FALSE],
                      error=function(cond){return(NULL)})
        if (length(e) < 1) {
          warning("Gene set ", i_gs, " contains 0 measured ",
                  "transcript: associated p-value cannot be computed")
          NA
        } else {
          if(verbose){
            message("Analyzing gene set ", i_gs)
          }
          vc_test_perm(y = y_lcpm[gs, , drop = FALSE], x = x,
                       indiv = sample_group,
                       phi = phi, w = w[gs, , drop = FALSE],
                       Sigma_xi = cov_variables2test_eff,
                       n_perm = n_perm,
                       progressbar = progressbar,
                       parallel_comp = parallel_comp,
                       nb_cores = nb_cores,
                       genewise_pvals = FALSE,
                       adaptive = adaptive,
                       max_adaptive = max_adaptive,
                       homogen_traj = homogen_traj,
                       na.rm = na.rm_gsaseq
          )$set_pval
        }
      }, FUN.VALUE = 0.5)
    }

    if(!is.na(padjust_methods)){
      pvals <- data.frame(rawPval = rawPvals,
                          adjPval = stats::p.adjust(rawPvals,
                                                    padjust_methods)
      )
    }else{
      pvals <- data.frame(rawPval = rawPvals, adjPval = NA)
    }
    if (!is.null(names(genesets))) {
      rownames(pvals) <- names(genesets)
    }

  }
  if(is.null(genesets)){
    ans_final <- list(which_test = which_test, preprocessed = preprocessed,
                      n_perm = n_perm, pvals = pvals, precision_weights = w,
                      weight_object = w_full
    )
  }else{
    ans_final <- list(which_test = which_test, preprocessed = preprocessed,
                      n_perm = n_perm, genesets = genesets, pvals = pvals,
                      precision_weights = lapply(genesets,
                                                 FUN = function(gs){tryCatch(w[gs, , drop = FALSE],
                                                                             error=function(cond){return(NA)})
                                                 }
                      ),
                      weight_object = w_full
    )
  }

  class(ans_final) <- "dearseq"
  return(ans_final)

}

library(dearseq)
context("Gene Set Analysis with dgsa_seq wrapper")

test_that("Gene sets with no genes measure trigger warnings", {
  rm(list = ls())
  n <- 200
  r <- 12
  t <- matrix(rep(1:3), 4, ncol=1, nrow=r)
  sigma <- 0.4
  b0 <- 1
  b1 <- 0 #under the null
  y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
  y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
           matrix(rep(y.tilde, n), ncol=n, nrow=r))
  x <- matrix(1, ncol=1, nrow=r)
  gs <- list(nrow(y) + 1:10)
  expect_warning(dgsa_seq(exprmat = y, covariates = x, variables2test = t,
                          genesets = gs, cov_variables2test_eff = matrix(1),
                          sample_group = rep(1:4, each=3),
                          which_test = "permutation",
                          which_weights = "none", preprocessed = TRUE))
  expect_warning(dgsa_seq(exprmat = y, covariates = x, variables2test = t,
                          genesets = gs, cov_variables2test_eff = matrix(1),
                          sample_group = rep(1:4, each=3),
                          which_test = "asymptotic",
                          which_weights = "none", preprocessed = TRUE))
})

test_that("NA runs", {
  rm(list = ls())
  n <- 1000 #number of genes
  nr=5 #number of measurements per subject (grouped data)
  ni=50 #number of subjects
  r <- nr*ni #number of measurements
  t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested
  sigma <- 0.5
  b0 <- 1
  
  #under the null:
  b1 <- 0
  
  #create the matrix of gene expression
  y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
  y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
           matrix(rep(y.tilde, n), ncol=n, nrow=r))
  
  # add NA
  y[10,8] = NA
  
  #no covariates
  x <- matrix(1, ncol=1, nrow=r)
  
  #run test
  #asymptotic test with preprocessed grouped data
  
  expect_warning(res <- dear_seq(exprmat=y, covariates=x, variables2test=t,
                                 sample_group=rep(1:ni, each=nr),
                                 which_test = "asymptotic",
                                 na.rm_dearseq = TRUE,
                                 which_weights='loclin', preprocessed=TRUE))
  
})

test_that("Returned as many p-values as there are genesets", {
  rm(list = ls())
  n <- 200
  r <- 12
  t <- matrix(rep(1:3), 4, ncol=1, nrow=r)
  sigma <- 0.4
  b0 <- 1
  b1 <- 0 #under the null
  y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
  y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
           matrix(rep(y.tilde, n), ncol=n, nrow=r))
  x <- matrix(1, ncol=1, nrow=r)
  res <- dgsa_seq(exprmat = y, covariates = x, variables2test = t,
                  genesets = list(1:10, 11:20),
                  cov_variables2test_eff = matrix(1),
                  sample_group = rep(1:4, each=3), which_test = "asymptotic",
                  which_weights = "none", preprocessed = TRUE)
  expect_length(res$pvals$rawPval, n = length(res$genesets))
  expect_length(res$pvals$adjPval, n = length(res$genesets))
})

#'Non parametric local heteroscedasticity weights
#'
#'Computes precision weights that account for heteroscedasticity in RNA-seq
#'count data based on non-parametric local linear regression estimates.
#'
#'@param y a numeric matrix of size \code{G x n} containing the raw RNA-seq
#'counts or preprocessed expression from \code{n} samples for \code{G} genes.
#'
#'@param x a numeric matrix of size \code{n x p} containing the model
#'covariate(s) from \code{n} samples (design matrix).
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the K
#'variable(s) of interest( e.g. bases of time).
#'
#'@param use_phi a logical flag indicating whether conditional means should be
#'conditioned on \code{phi} and on covariate(s) \code{x}, or on \code{x} alone.
#'Default is \code{TRUE} in which case conditional means are estimated
#'conditionally on both \code{x} and \code{phi}.
#'
#'@param preprocessed a logical flag indicating whether the expression data have
#'already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
#'which case \code{y} is assumed to contain raw counts and is normalized into
#'log(counts) per million.
#'
#'@param gene_based a logical flag indicating whether to estimate weights at the
#'gene-level. Default is \code{FALSE}, when weights will be estimated at the
#'observation-level.
#'
#'@param bw a character string indicating the smoothing bandwidth selection
#'method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
#'are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}.
#'Default is \code{'nrd'}.
#'
#'@param kernel a character string indicating which kernel should be used.
#'Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
#'\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
#'\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
#'\code{'gaussian'} (NB: \code{'tricube'} kernel corresponds to the loess
#'method).
#'
#'@param transform a logical flag indicating whether values should be
#'transformed to uniform for the purpose of local linear smoothing. This may be
#'helpful if tail observations are sparse and the specified bandwidth gives
#'suboptimal performance there. Default is \code{TRUE}.
#'
#'@param verbose a logical flag indicating whether informative messages are
#'printed during the computation. Default is \code{TRUE}.
#'
#'@param na.rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@return a list containing the following components:\itemize{
#'\item \code{weights}: a matrix \code{n x G} containing the computed precision 
#'weights 
#'\item \code{plot_utilities}: a list containing the following elements:\itemize{
#'      \item\code{reverse_trans}: a function encoding the reverse function used 
#'      for smoothing the observations before computing the weights
#'      \item\code{method}: the weight computation method (\code{"loclin"})
#'      \item\code{smth}: the vector of the smoothed values computed 
#'      \item\code{gene_based}: a logical indicating whether the computed 
#'      weights are based on average at the gene level or on individual 
#'      observations
#'      \item\code{mu}: the transformed observed counts or averages
#'      \item\code{v}: the observed variability estimates
#' }
#'}
#'
#'@author Boris Hejblum
#'
#'@seealso \code{\link[stats]{bandwidth}} \code{\link{density}}
#'
#'@examples
#'set.seed(123)
#'
#'G <- 10000
#'n <- 12
#'p <- 2
#'y <- sapply(1:n, FUN = function(x){rnbinom(n = G, size = 0.07, mu = 200)})
#'
#'x <- sapply(1:p, FUN = function(x){rnorm(n = n, mean = n, sd = 1)})
#'
#'w <- sp_weights(y, x, use_phi=FALSE, na.rm = TRUE)
#'
#'@import ggplot2
#'@importFrom stats bw.bcv bw.nrd0 bw.nrd bw.SJ bw.ucv dnorm approx sd pnorm
#'qnorm na.omit
#'@importFrom KernSmooth locpoly
#'@export


sp_weights <- function(y, x, phi = NULL, use_phi = TRUE, preprocessed = FALSE,
                       gene_based = FALSE,
                       bw = c("nrd", "ucv", "SJ", "nrd0", "bcv"),
                       kernel = c("gaussian", "epanechnikov", "rectangular",
                                  "triangular", "biweight", "tricube", "cosine",
                                  "optcosine"),
                       transform = TRUE, verbose = TRUE,
                       na.rm = FALSE) {
  
  
  ## dimensions & validity checks
  
  stopifnot(is.matrix(y))
  stopifnot(is.matrix(x))
  stopifnot(is.null(phi) | is.matrix(phi))
  
  g <- nrow(y)  # the number of genes measured
  n <- ncol(y)  # the number of samples measured
  qq <- ncol(x)  # the number of covariates
  stopifnot(nrow(x) == n)
  if(use_phi){
    stopifnot(nrow(phi) == n)
  }
  
  # removing genes never observed:
  observed <- which(rowSums(y, na.rm = TRUE) != 0)
  nb_g_sum0 <- length(observed) - g
  if (nb_g_sum0 > 0) {
    warning(nb_g_sum0, " y rows sum to 0 (i.e. are never observed)",
            "and have been removed")
  }
  
  kernel <- match.arg(kernel)
  if (preprocessed) {
    y_lcpm <- t(y[observed, ])
  } else {
    # transforming raw counts to log-counts per million (lcpm)
    y_lcpm <- t(apply(y[observed, ], MARGIN = 2, function(v) {
      log2((v + 0.5)/(sum(v) + 1) * 10^6)
    }))
  }
  N <- length(y_lcpm)
  p <- ncol(y_lcpm)
  
  
  # fitting OLS to the lcpm
  xphi <- if (use_phi) {
    cbind(x, phi)
  } else {
    x
  }
  if (na.rm) {
    y_lcpm0 <- y_lcpm
    y_lcpm0[is.na(y_lcpm0)] <- 0
    B_ols <- solve(crossprod(xphi)) %*% t(xphi) %*% y_lcpm0
  } else {
    B_ols <- solve(crossprod(xphi)) %*% t(xphi) %*% y_lcpm
  }
  mu <- xphi %*% B_ols
  
  sq_err <- (y_lcpm - mu)^2
  lse <- log(sq_err)
  v <- colMeans(sq_err, na.rm = na.rm)
  mu_avg <- colMeans(mu, na.rm = na.rm)
  
  if (gene_based) {
    mu_x <- mu_avg
  } else {
    mu_x <- mu
    mu_x[is.na(y_lcpm)] <- NA
  }
  # transforming if necessary
  if (transform) {
    sd_mu <- sd(mu_x, na.rm = na.rm)
    mean_mu <- mean(mu_x, na.rm = na.rm)
    mu_x <- pnorm((mu_x - mean_mu)/sd_mu)
    reverse_trans <- function(x) {
      qnorm(x) * sd_mu + mean_mu
    }
  } else {
    reverse_trans <- identity
  }
  
  if (is.character(bw)) {
    if (length(bw > 1)) {
      bw <- bw[1]
    }
    if (N < 2) {
      stop("need at least 2 points to select a bandwidth automatically")
    }
    
    # remove NA to compute the bandwith
    if(sum(is.na(mu_x))>0 & na.rm){
      mu_x_nona <- na.omit(mu_x)
    }else{
      mu_x_nona <- mu_x
    }
    bw <- switch(bw,
                 nrd0 = stats::bw.nrd0(as.vector(mu_x_nona)),
                 nrd = stats::bw.nrd(as.vector(mu_x_nona)),
                 ucv = stats::bw.ucv(as.vector(mu_x_nona)),
                 bcv = stats::bw.bcv(as.vector(mu_x_nona)),
                 SJ = stats::bw.SJ(as.vector(mu_x_nona), method = "ste"),
                 stop("unknown bandwidth rule: 'bw' argument",
                      "must be among 'nrd0', 'nrd', 'ucv',",
                      "'bcv', 'SJ'")
    )
    
    if (verbose) {
      message("\nBandwith computed.\n")
    }
  }
  
  if (!is.finite(bw)) {
    stop("non-finite 'bw'")
  }
  if (bw <= 0) {
    stop("'bw' is not positive")
  }
  
  # choose kernel ----
  if (kernel == "gaussian") {
    kern_func <- function(x, bw) {
      stats::dnorm(x, sd = bw)
    }
  } else if (kernel == "rectangular") {
    kern_func2 <- function(x, bw) {
      a <- bw * sqrt(3)
      (abs(x) < a) * 0.5/a  #ifelse(abs(x) < a, 0.5/a, 0)
      
    }
  } else if (kernel == "triangular") {
    kern_func <- function(x, bw) {
      h <- bw * sqrt(6)
      ax <- abs(x)
      (ax < h) * ((1 - ax/h)/h)
    }
  } else if (kernel == "tricube") {
    kern_func <- function(x, bw) {
      h <- bw * sqrt(243/35)
      ax <- abs(x)
      (ax < h) * (70/81 * (1 - (ax/h)^3)^3)/h
    }
  } else if (kernel == "epanechnikov") {
    kern_func <- function(x, bw) {
      h <- bw * sqrt(5)
      ax <- abs(x)
      (ax < h) * (3/4 * (1 - (ax/h)^2)/h)
    }
  } else if (kernel == "biweight") {
    kern_func <- function(x, bw) {
      h <- bw * sqrt(7)
      ax <- abs(x)
      (ax < h) * (15/16 * (1 - (ax/h)^2)^2/h)
    }
  } else if (kernel == "cosine") {
    kern_func <- function(x, bw) {
      h <- bw/sqrt(1/3 - 2/pi^2)
      (abs(x) < h) * ((1 + cos(pi * x/h))/(2 * h))
    }
  } else if (kernel == "optcosine") {
    kern_func <- function(x, bw) {
      h <- bw/sqrt(1 - 8/pi^2)
      (abs(x) < h) * (pi/4 * cos(pi * x/(2 * h))/h)
    }
  } else {
    stop("unknown kernel: 'kernel' argument must be among",
         "'gaussian', 'rectangular', 'triangular', 'epanechnikov',",
         "'biweight', 'cosine', 'optcosine'")
  }
  
  if (gene_based) {
    
    w <- function(x) {
      x_ctr <- (mu_x - x)
      kernx <- kern_func(x_ctr, bw)
      Sn1 <- kernx * x_ctr
      #Sn2 <- Sn1 * x_ctr
      b <- kernx * (sum(Sn1 * x_ctr) - x_ctr * sum(Sn1))
      l <- b/sum(b)
      sum(l * v)
    }
    
    
    kern_fit <- vapply(mu_x, w, FUN.VALUE = 1.1)
    weights <- 1/matrix(kern_fit, nrow = n, ncol = p, byrow = TRUE)
    if (sum(!is.finite(weights)) > 0) {
      warning("At least 1 non finite weight. ",
              "Try to increase the bandwith")
    }
    
  } else {
    
    mu_x_fit <- mu_x
    lse_fit <- lse
    
    na_mux <- which(is.na(mu_x))
    if (!na.rm) {
      stop("Cannot compute the weights without ignoring NA/NaN ",
           "values...\nTry setting 'na.rm' or na.rm_gsaseq' to 'TRUE' ",
           "to ignore NA/NaN values, but think carefully about where ",
           "does those NA/NaN come from...")
      
    } else if (length(na_mux) > 0) {
      mu_x_fit <- mu_x_fit[-na_mux]
      lse_fit <- lse_fit[-na_mux]
    }
    
    inf_lse <- which(is.infinite(lse_fit))
    if(length(inf_lse) > 0){
      mu_x_fit <- mu_x_fit[-inf_lse]
      lse_fit <- lse_fit[-inf_lse]
    }
    min_gridsize <- ceiling((max(mu_x_fit) - min(mu_x_fit))/(4*bw))+1
    gridsize <- max(min_gridsize, 401)
    smth <- KernSmooth::locpoly(x = c(mu_x_fit), y = c(lse_fit), degree = 2,
                                kernel = kernel, bandwidth = bw, gridsize = gridsize)
    w <- exp(-stats::approx(x = reverse_trans(smth$x), y = smth$y,
                            xout = reverse_trans(mu_x),
                            rule = 2)$y)
    cnt <- 0
    while((sum(is.na(w)) > 0 | sum(is.infinite(w)) > 0 ) & cnt < 5){
      cnt <- cnt + 1
      bw <- 2*bw
      min_gridsize <- ceiling((max(mu_x_fit) - min(mu_x_fit))/(4*bw))+1
      gridsize <- max(min_gridsize, 401)
      smth <- KernSmooth::locpoly(x = c(mu_x_fit), y = c(lse_fit), degree = 2,
                                  kernel = kernel, bandwidth = bw, gridsize = gridsize)
      w <- exp(-stats::approx(x = reverse_trans(smth$x), y = smth$y,
                              xout = reverse_trans(mu_x),
                              rule = 2)$y)
    }
    weights <- matrix(w, nrow(mu_x), ncol(mu_x))
  }
  if(sum(is.na(weights)) < 1){
    if(sum(weights < 0) > 0){
      stop("negative variance weights estimated")
    }
  }else{
    if(na.rm){
      if(all.equal(which(is.na(weights)), which(is.na(y_lcpm)))){
        weights[is.na(weights)] <- 1
      }else{
        stop("NA variance weights estimated not matching NA in `y`")
      }
    }else{
      stop("NA variance weights estimated while `na.rm`is FALSE")
    }
    
  }
  colnames(weights) <- colnames(y_lcpm)
  rownames(weights) <- rownames(y_lcpm)
  
  
  if(gene_based){
    v_out <- v
    smth_out <- kern_fit
  }else{
    v_out <- lse
    smth_out <- smth
  }
  
  return(list("weights" = t(weights), 
              "plot_utilities" = list("reverse_trans" = reverse_trans,
                                      "method" = "loclin",
                                      "smth" = smth_out,
                                      "gene_based" = gene_based,
                                      "mu" = mu_x,
                                      "v" = v_out
              )
  ))
}

#'Differential expression analyis of RNA-seq data through a variance component
#'test
#'
#'Wrapper function for gene-by-gene association testing of RNA-seq data
#'
#'@param exprmat a numeric matrix of size \code{G x n} containing the raw
#'RNA-seq counts or preprocessed expressions from \code{n} samples for \code{G}
#'genes. Default is \code{NULL}, in which case \code{object} must not be
#'\code{NULL}.
#'
#'@param object an object that can be either a
#'\code{\link[SummarizedExperiment:RangedSummarizedExperiment-class]{SummarizedExperiment}},
#'an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, a
#'\code{\link[DESeq2:DESeqDataSet]{DESeqDataSet}}, or a
#'\code{\link[edgeR:DGEList]{DGEList}}.
#'Default is \code{NULL}, in which case \code{exprmat} must not be
#'\code{NULL}.
#'
#'@param covariates \itemize{
#'\item If \code{exprmat} is specified as a matrix:
#'then \code{covariates} must be a numeric matrix of size \code{n x p}
#'containing the model covariates for \code{n} samples (design matrix).
#'Usually, its first column is the intercept (full of \code{1}s).
#'\item If \code{object} is specified: then \code{covariates} must be a
#'character vector of length \code{p} containing the colnames of the
#'design matrix given in \code{object}.
#'} If \code{covariates} is \code{NULL} (the default), then it is just the
#'intercept.
#'
#'@param variables2test \itemize{
#'\item If \code{exprmat} is specified as a matrix:
#'a numeric design matrix of size \code{n x K} containing
#'the \code{K} variables to be tested.
#'\item If \code{object} is specified: then \code{variables2test} must be a
#'character vector of length \code{K} containing the colnames of the
#'design matrix given in \code{object}.
#'}
#'
#'@param weights_var2test_condi  a logical flag indicating whether
#'heteroscedasticity weights computation should be conditional on both the
#'variables to be tested \code{variables2test} and on the \code{covariates},
#'or on \code{covariates} alone. Default is \code{TRUE} for the asymptotic test
#'(in which case conditional means are estimated conditionally on both
#'\code{variables2test} and \code{covariates}), and \code{FALSE} for the
#'permutation test (in which case conditional means are estimated
#'conditionally on only the  \code{covariates}).
#'
#'@param sample_group a vector of length \code{n} indicating whether the samples
#'should be grouped (e.g. paired samples or longitudinal data). Coerced
#'to be a \code{factor}. Default is \code{NULL} in which case no grouping is
#'performed.
#'
#'@param cov_variables2test_eff a matrix of size \code{K x K} containing the
#'covariance matrix of the \code{K} random effects. Only used if
#'\code{homogen_traj} is \code{FALSE}. Default assume diagonal correlation
#'matrix, i.e. independence of random effects.
#'
#'@param which_weights a character string indicating which method to use to
#'estimate the mean-variance relationship weights. Possibilities are
#'\code{'loclin'}, \code{'voom'} or \code{'none'} (in which case no weighting is
#' performed). Default is \code{'loclin'}. See \code{\link{sp_weights}} and
#' \code{\link{voom_weights}} for details.
#'
#'@param which_test a character string indicating which method to use to
#'approximate the variance component score test, either \code{'permutation'} or
#'\code{'asymptotic'}. Default is \code{'permutation'}.
#'
#'@param n_perm the number of perturbations. Default is \code{1000}
#'
#'@param progressbar logical indicating wether a progressBar should be displayed
#'when computing permutations (only in interactive mode).
#'
#'@param parallel_comp a logical flag indicating whether parallel computation
#'should be enabled. Only Linux and MacOS are supported, this is ignored on
#'Windows. Default is \code{TRUE}.
#'
#'@param nb_cores an integer indicating the number of cores to be used when
#'\code{parallel_comp} is \code{TRUE}.
#'Default is \code{parallel::detectCores(logical=FALSE) - 1}.
#'
#'@param preprocessed a logical flag indicating whether the expression data have
#'already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
#'which case \code{y} is assumed to contain raw counts and is normalized into
#'log(counts) per million.
#'
#'@param gene_based_weights a logical flag used for \code{'loclin'} weights,
#'indicating whether to estimate weights at the gene-level, or rather at the
#'observation-level. Default is \code{FALSE}, which is what it should be for
#'gene-wise analysis.
#'
#'@param bw a character string indicating the smoothing bandwidth selection
#'method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
#'are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}.
#'
#'@param kernel a character string indicating which kernel should be used.
#'Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
#'\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
#'\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
#'\code{'gaussian'} (NB: \code{'tricube'} kernel corresponds to the loess
#'method).
#'
#'@param transform a logical flag used for \code{'loclin'} weights, indicating
#'whether values should be transformed to uniform for the purpose of local
#'linear smoothing. This may be helpful if tail observations are sparse and the
#'specified bandwidth gives suboptimal performance there. Default is
#'\code{TRUE}.
#'
#'@param padjust_methods multiple testing correction method used if
#'\code{genesets} is a list. Default is 'BH', i.e. Benjamini-Hochberg procedure
#'for controlling the FDR. Other possibilities are: \code{'holm'},
#'\code{'hochberg'}, \code{'hommel'}, \code{'bonferroni'} or \code{'BY'} (for
#'Benjamini-Yekutieli procedure).
#'
#'@param lowess_span smoother span for the lowess function, between 0 and 1.
#'This gives the proportion of points in the plot which influence the smooth at
#'each value. Larger values give more smoothness. Only used if
#'\code{which_weights} is \code{'voom'}. Default is \code{0.5}.
#'
#'@param R library.size (optional, important to provide if
#'\code{preprocessed = TRUE}). Default is \code{NULL}
#'
#'@param adaptive a logical flag indicating whether adaptive permutation should
#'be performed. Default is \code{TRUE}
#'
#'@param max_adaptive The maximum number of permutations considered.
#'Default is \code{64000}
#'
#'@param homogen_traj a logical flag indicating whether trajectories should be
#'considered homogeneous. Default is \code{FALSE} in which case trajectories
#'are not only tested for trend, but also for heterogeneity.
#'
#'@param na.rm_dearseq logical: should missing values in \code{y} (including
#'\code{NA} and \code{NaN}) be omitted from the calculations?
#'Default is \code{TRUE}.
#'
#'
#'@return A list with the following elements:\itemize{
#'   \item \code{which_test}: a character string carrying forward the value of
#'   the '\code{which_test}' argument indicating which test was perform (either
#'   'asymptotic' or 'permutation').
#'   \item \code{preprocessed}: a logical flag carrying forward the value of the
#'   '\code{preprocessed}' argument indicating whether the expression data were
#'   already preprocessed, or were provided as raw counts and transformed into
#'   log-counts per million.
#'   \item \code{n_perm}: an integer carrying forward the value of the
#'   '\code{n_perm}' argument indicating the number of perturbations performed
#'   (\code{NA} if asymptotic test was performed).
#'   \item \code{genesets}: carrying forward the value of the '\code{genesets}'
#'   argument defining the gene sets of interest (\code{NULL} for gene-wise
#'   testing).
#'   \item \code{pval}: computed p-values. A \code{data.frame} with one raw for
#'   each each gene set, or for each gene if \code{genesets} argument is
#'   \code{NULL}, and with 2 columns: the first one '\code{rawPval}' contains
#'   the raw p-values, the second one contains the FDR adjusted p-values
#'   (according to the '\code{padjust_methods}' argument) and is named
#'   '\code{adjPval}'.
#' }
#'
#'@seealso \code{\link{sp_weights}} \code{\link{vc_test_perm}}
#'\code{\link{vc_test_asym}} \code{\link{p.adjust}}
#'
#'@references Gauthier M, Agniel D, Thiébaut R & Hejblum BP (2020). dearseq:
#'a variance component score test for RNA-Seq differential analysis that
#'effectivelycontrols the false discovery rate,
#'\emph{NAR Genomics and Bioinformatics}, 2(4):lqaa093.
#'\href{https://doi.org/10.1093/nargab/lqaa093}{DOI: 10.1093/nargab/lqaa093}.
#'\href{https://www.biorxiv.org/content/10.1101/635714}{DOI: 10.1101/635714}
#'
#'@examples
#'
#'#Monte-Carlo estimation of the proportion of DE genes over `nsims`
#'#simulations under the null
#'
#'#number of runs
#'nsims <- 2 #100
#'res <- numeric(nsims)

#'for(i in 1:nsims){
#'  n <- 1000 #number of genes
#'  nr=5 #number of measurements per subject (grouped data)
#'  ni=50 #number of subjects
#'  r <- nr*ni #number of measurements
#'  t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested
#'  sigma <- 0.5
#'  b0 <- 1
#'
#'  #under the null:
#'  b1 <- 0
#'
#'  #create the matrix of gene expression
#'  y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'  y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'           matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'
#'  #no covariates
#'  x <- matrix(1, ncol=1, nrow=r)
#'
#'  #run test
#'  #asymptotic test with preprocessed grouped data
#'  res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
#'                        sample_group=rep(1:ni, each=nr),
#'                        which_test='asymptotic',
#'                       which_weights='none', preprocessed=TRUE)
#'
#'  #proportion of raw p-values>0.05
#'  mean(res_genes$pvals[, 'rawPval']>0.05)
#'
#'  #quantiles of raw p-values
#'  quantile(res_genes$pvals[, 'rawPval'])
#'
#'  #proportion of raw p-values<0.05 i.e. proportion of DE genes
#'  res[i] <- mean(res_genes$pvals[, 'rawPval']<0.05)
#'  message(i)
#'}
#'
#'#results
#'mean(res)
#'
#'if(interactive()){
#'b0 <- 1
#'#under the null:
#'b1 <- 0
#'
#'#create the matrix of gene expression
#'y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'
#'#run test
#'#asymptotic test with preprocessed grouped data
#'res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
#'                    sample_group=rep(1:ni, each=nr),
#'                    which_weights='none', preprocessed=TRUE)
#'
#'#results
#'summary(res_genes$pvals)
#'}
#'@export
dear_seq <- function(exprmat = NULL, object = NULL,
                     covariates =NULL,
                     variables2test,
                     sample_group = NULL,
                     weights_var2test_condi = (which_test != "permutation"),
                     cov_variables2test_eff = NULL,
                     which_test = c("permutation", "asymptotic"),
                     which_weights = c("loclin", "voom", "none"),
                     n_perm = 1000, progressbar = TRUE, parallel_comp = TRUE,
                     nb_cores = parallel::detectCores(logical=FALSE) - 1,
                     preprocessed = FALSE,
                     gene_based_weights = FALSE,
                     bw = "nrd",
                     kernel = c("gaussian", "epanechnikov", "rectangular",
                                "triangular", "biweight", "tricube", "cosine",
                                "optcosine"),
                     transform = TRUE,
                     padjust_methods = c("BH", "BY", "holm", "hochberg",
                                         "hommel", "bonferroni"),
                     lowess_span = 0.5,
                     R=NULL,
                     adaptive = TRUE, max_adaptive = 64000,
                     homogen_traj = FALSE,
                     na.rm_dearseq = TRUE) {

  return(dgsa_seq(exprmat = exprmat, object = object,
                 covariates = covariates,
                 variables2test = variables2test,
                 weights_var2test_condi = weights_var2test_condi,
                 genesets = NULL,
                 sample_group = sample_group,
                 cov_variables2test_eff = cov_variables2test_eff,
                 which_test = which_test,
                 which_weights = which_weights,
                 n_perm = n_perm, progressbar = progressbar,
                 parallel_comp = parallel_comp, nb_cores = nb_cores,
                 preprocessed = preprocessed,
                 gene_based_weights = gene_based_weights,
                 bw = bw,
                 kernel = kernel,
                 transform = transform,
                 padjust_methods = padjust_methods,
                 lowess_span = lowess_span,
                 R = R,
                 adaptive = adaptive, max_adaptive = max_adaptive,
                 homogen_traj = homogen_traj,
                 na.rm_gsaseq = na.rm_dearseq,
                 verbose = FALSE))

}

#'Computes variance component score test statistics and its permuted distribution
#'
#'This function computes the variance component score test statistics along
#'with its permuted values for estimating its distribution under the null
#'hypothesis.
#'
#'@keywords internal
#'
#'@param y a numeric matrix of dim \code{g x n} containing the raw RNA-seq
#'counts for g genes from \code{n} samples
#'
#'@param x a numeric design matrix of dim \code{n x p} containing the
#'\code{p} covariates to be adjusted for
#'
#'@param indiv a vector of length \code{n} containing the information for
#'attributing each sample to one of the studied individuals. Coerced
#'to be a \code{factor}
#'
#'@param phi a numeric design matrix of size \code{n x K} containing the
#'\code{K} variables to be tested.
#'
#'@param w a vector of length \code{n} containing the weights for the \code{n}
#'samples.
#'
#'@param Sigma_xi a matrix of size \code{K x K} containing the covariance matrix
#'of the \code{K} random effects on \code{phi}
#'
#'@param na_rm logical: should missing values (including \code{NA} and
#'\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.
#'
#'@param n_perm the number of permutation to perform. Default is \code{1000}.
#'
#'@param progressbar logical indicating wether a progressBar should be displayed
#'when computing permutations (only in interactive mode).
#'
#'@param parallel_comp a logical flag indicating whether parallel computation
#'should be enabled. Only Linux and MacOS are supported, this is ignored on
#'Windows. Default is \code{TRUE}.
#'
#'@param nb_cores an integer indicating the number of cores to be used when
#'\code{parallel_comp} is \code{TRUE}.
#'Default is \code{parallel::detectCores(logical=FALSE) - 1}.
#'
#'@return A list with the following elements:\itemize{
#'   \item \code{score}: an approximation of the observed set score
#'   \item \code{scores_perm}: a vector containing the permuted set scores
#'   \item \code{gene_scores_unscaled}: approximation of the individual gene
#'   scores
#'   \item \code{gene_scores_unscaled_perm}: a list of approximationq of the
#'   permuted individual gene scores
#' }
#'
#'@examples
#'set.seed(123)
#'
#'##generate some fake data
#'########################
#'n <- 100
#'r <- 12
#'t <- matrix(rep(1:3), r/3, ncol=1, nrow=r)
#'sigma <- 0.4
#'b0 <- 1
#'
#'#under the null:
#'b1 <- 0
#'#under the alternative:
#'b1 <- 0.7
#'y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'x <- matrix(1, ncol=1, nrow=r)
#'
#'#run test
#'scoreTest <- vc_score_perm(y, x, phi=t, w=matrix(1, ncol=ncol(y),
#'                                                 nrow=nrow(y)),
#'                     Sigma_xi=matrix(1), indiv=rep(1:(r/3), each=3),
#'                     parallel_comp = FALSE)
#'scoreTest$score
#'
#'@importFrom stats model.matrix
#'@importFrom pbapply pbsapply pboptions
#'@importFrom parallel makeCluster stopCluster detectCores
#'
#'@export
vc_score_perm <- function(y, x, indiv, phi, w, Sigma_xi = diag(ncol(phi)),
                          na_rm = FALSE,
                          n_perm = 1000, progressbar = TRUE,
                          parallel_comp = TRUE,
                          nb_cores = parallel::detectCores(logical=FALSE) - 1) {
    ## validity checks
    if (sum(!is.finite(w)) > 0) {
        stop("At least 1 non-finite weight in 'w'")
    }

    ## dimensions check------
    stopifnot(is.matrix(y))
    stopifnot(is.matrix(x))
    stopifnot(is.matrix(phi))

    g <- nrow(y)  # the number of genes measured
    n <- ncol(y)  # the number of samples measured
    p <- ncol(x)  # the number of covariates
    n_t <- ncol(phi)  # the number of time bases
    stopifnot(nrow(x) == n)
    stopifnot(nrow(w) == g)
    stopifnot(ncol(w) == n)
    stopifnot(nrow(phi) == n)
    stopifnot(length(indiv) == n)


    # the number of random effects
    if (length(Sigma_xi) == 1) {
        K <- 1
        Sigma_xi <- matrix(Sigma_xi, K, K)
    } else {
        K <- nrow(Sigma_xi)
        stopifnot(ncol(Sigma_xi) == K)
    }
    stopifnot(n_t == K)


    ## data formating ------
    indiv <- as.factor(indiv)
    nb_indiv <- length(levels(indiv))

    ## OLS for conditional mean -----
    y_T <- t(y)
    if (na_rm & sum(is.na(y_T)) > 0) {
        y_T0 <- y_T
        y_T0[is.na(y_T0)] <- 0
        yt_mu <- y_T - x %*% solve(crossprod(x)) %*% t(x) %*% y_T0
    } else {
        yt_mu <- y_T - x %*% solve(crossprod(x)) %*% t(x) %*% y_T
    }
    ## x_tilde_list <- y_tilde_list <- Phi_list <- list()
    ## for (i in 1:nb_indiv) {
    ##     select <- indiv==levels(indiv)[i]
    ##     n_i <- length(which(select))
    ##     x_i <- x[select,]
    ##     y_i <- y[,select]
    ##     phi_i <- phi[select,]
    ##     Phi_list[[i]] <- kronecker(diag(g), phi_i)
    ##     x_tilde_list[[i]] <- kronecker(diag(g), x_i)
    ##     y_tilde_list[[i]] <- matrix(t(y_i), ncol=1)
    ## }
    ## x_tilde <- do.call(rbind, x_tilde_list)
    ## y_tilde <- do.call(rbind, y_tilde_list)
    ## Phi <- do.call(rbind, Phi_list)
    ## alpha <- solve(t(x_tilde)%*%x_tilde)%*%t(x_tilde)%*%y_tilde
    ## mu_new <- x_tilde %*% alpha
    ## y_mu <- y_tilde - mu_new


    ## test statistic computation ------
    ## q <- matrix(NA, nrow=nb_indiv, ncol=g*K)
    ## XT_i <- array(NA, c(nb_indiv, g*p, g*K))
    ## U <- matrix(NA, nrow = nb_indiv, ncol = p*g)
    ## long_indiv <- rep(indiv, each = g)
    ## xtx_inv <- solve(t(x_tilde) %*% x_tilde)
    ## Sigma_xi_new_sqrt <- kronecker(diag(g), (Sigma_xi*diag(K))%^% (-0.5))
    ## for (i in 1:nb_indiv){ #for all the genes at once
    ##     select <- indiv==levels(indiv)[i]
    ##     long_select <- long_indiv==levels(indiv)[i]
    ##     y_mu_i <- as.vector(y_mu[long_select,])
    ##     y_tilde_i <- c(t(y_ij))
    ##     x_tilde_i <- x_tilde[long_select,]
    ##     sigma_eps_inv_diag <- as.vector(t(w)[select,])#/sigma
    ##     T_i <- sigma_eps_inv_diag*(Phi[long_select,] %*% Sigma_xi_new_sqrt)
    ##     q[i,] <- c(y_mu_i %*% T_i)
    ##     XT_i[i,,] <- t(x_tilde_i) %*% T_i
    ##     U[i,] <- xtx_inv %*% t(x_tilde_i) %*% y_mu_i
    ## }
    ## XT <- colMeans(XT_i) q_ext <- q - U %*% XT

    # sig_eps_inv <- w/sigma #no need as this just scales the test statistics

    sig_xi_sqrt <- (Sigma_xi * diag(K)) %^% (-0.5)
    sig_eps_inv_T <- t(w)

    if (length(levels(indiv)) > 1) {
        indiv_mat <- stats::model.matrix(~0 + factor(indiv))
    } else {
        indiv_mat <- matrix(as.numeric(indiv), ncol = 1)
    }
    avg_xtx_inv_tx <- nb_indiv * tcrossprod(solve(crossprod(x, x)), x)

    compute_genewise_scores <- function(v, indiv_mat, avg_xtx_inv_tx) {
        phi_perm <- phi[v, , drop = FALSE]
        phi_sig_xi_sqrt <- phi_perm %*% sig_xi_sqrt
        T_fast <- do.call(cbind, replicate(K, sig_eps_inv_T,#[v, , drop = FALSE],
                                           simplify = FALSE)) *
            matrix(apply(phi_sig_xi_sqrt, 2, rep, g), ncol = g * K)
        q_fast <- matrix(yt_mu, ncol = g * n_t, nrow = n) * T_fast
        if (na_rm & sum(is.na(q_fast)) > 0) {
            q_fast[is.na(q_fast)] <- 0
        }
        q <- crossprod(indiv_mat, q_fast)
        XT_fast <- t(x) %*% T_fast/nb_indiv
        U_XT <- matrix(yt_mu, ncol = g * n_t, nrow = n) *
            crossprod(avg_xtx_inv_tx, XT_fast)
        if (na_rm & sum(is.na(U_XT)) > 0) {
            U_XT[is.na(U_XT)] <- 0
        }
        U_XT_indiv <- crossprod(indiv_mat, U_XT)
        q_ext <- q - U_XT_indiv
        qq <- colSums(q, na.rm = na_rm)^2/nb_indiv
        return(rowSums(matrix(qq, ncol = K)))  # genewise scores
    }

    o <- order(as.numeric(unlist(split(x = as.character(seq_len(n)),
                                       f = indiv))))
    perm_list <- c(list(seq_len(n)), lapply(seq_len(n_perm), function(x){
        as.numeric(unlist(lapply(split(x = as.character(seq_len(n)), f = indiv),
                                 FUN=sample)))[o]}))


    if(!progressbar){
        opb <- getOption("pboptions")
        pbapply::pboptions(type="none")
    }

    if(!parallel_comp){
        par_clust <- 1L
    }else{
        if(.Platform$OS.type == "unix"){
            par_clust <- nb_cores
        }else{
            par_clust <- parallel::makeCluster(nb_cores)
        }
    }

    gene_Q <- pbapply::pbsapply(perm_list, compute_genewise_scores,
                                indiv_mat = indiv_mat,
                                avg_xtx_inv_tx = avg_xtx_inv_tx,
                                cl = par_clust)

    if(parallel_comp && .Platform$OS.type != "unix"){
        parallel::stopCluster(par_clust)
    }

    if(!progressbar){
        pboptions(opb)
    }
    if(is.vector(gene_Q)){
      gene_Q <- matrix(gene_Q, nrow = 1)
    }

    rownames(gene_Q) <- colnames(yt_mu)
    QQ <- colSums(gene_Q)


    return(list(score = QQ[1], scores_perm = QQ[-1],
                gene_scores_unscaled = gene_Q[, 1],
                gene_scores_unscaled_perm = gene_Q[, -1]))
}

#'Summary method for dearseq objects 
#'
#'@param object an object of class \code{dear_seq}
#'
#'@param signif_threshold a value between \code{0} and {1} specifying the 
#'nominal significance threshold. Default is \code{0.05}.
#'
#'@param ... further arguments
#'
#'
#'@author Boris Hejblum
#'
#'@return a \code{list}
#'
#'@export

summary.dearseq <- function(object, signif_threshold = 0.05, ...){
  adj_pval <- object$pvals$adjPval
  names(adj_pval) <- rownames(object$pvals)
  
  adj_pval <- sort(adj_pval)
  
  s <- list()
  s$which_test <- object$which_test
  s$preprocessed <- object$preprocessed
  s$n_tests <- length(adj_pval)
  s$n_signif <- sum(adj_pval < signif_threshold)
  s$which_signif <- names(adj_pval)[adj_pval < signif_threshold]
  s$signif_threshold <- signif_threshold
  s$adj_pval <- adj_pval[adj_pval < signif_threshold]
  s$gsa <- !is.null(object$genesets)
  
  class(s) <- "summary.dearseq"
  return(s)
}

#'@rdname summary.dearseq
#'
#'@param x an object of class '\code{summary.dearseq}'.
#'
#'@export
print.summary.dearseq <- function(x, ...){
  if(x$gsa){
    cat(paste("dearseq identifies", x$n_signif, "significant gene sets out of", x$n_tests, "\n"))
  }else{
    cat(paste("dearseq identifies", x$n_signif, "significant genes out of", x$n_tests, "\n"))
  }
  cat(paste(" - test:", x$which_test, "\n"))
  cat(paste(" - FDR significance level:", x$signif_threshold, "\n"))
}

#' Spaghetti plot for Specific Gene Set
#'
#' @param gs_index index of the specific gene set in \code{gmt}. 
#' @param gmt a \code{list} of elements: \code{geneset}, \code{geneset.name} and
#'  \code{geneset.description} (see \code{\link[GSA]{GSA.read.gmt}}).
#' @param expr_mat a \code{data.frame} with numerics of size \code{G x n} 
#' contraining the raw RNA-seq counts from \code{n} samples for \code{G} genes.
#' @param design a \code{data.frame} or \code{DFrame} containing the information 
#' of each sample (SampleID).
#' @param var_time the \code{time} or \code{visit} variable contained in 
#' \code{design}.
#' @param var_indiv the patient variable contained in \code{design} data.
#' @param sampleIdColname a character string indicating the name of the sample ID 
#' variable in \code{design} to be matched with the \code{colnames} of \code{expr_mat}
#' @param var_group a group variable in \code{design} data to divide into two 
#' facets. Default is \code{NULL}.
#' @param var_subgroup a subgroup variable in \code{design} data to add 2 curves 
#' on plot for each subgroup. Default is \code{NULL}.
#' @param plotChoice to choose which type of plot (either \code{"Medians"}, 
#' \code{"Individual"} or both). Default is \code{c("Medians", "Individual")}. 
#' @param loess_span smoothing span. Default is \code{0.75}.
#' 
#' @return a ggplot2 plot object 
#'
#' @importFrom tibble rownames_to_column
#' @importFrom reshape2 melt
#' @importFrom magrittr %>%
#' @importFrom dplyr filter left_join
#' @importFrom rlang eval_tidy
#' @importFrom stats median sd
#' @import ggplot2
#' @export
#' 
#' @examples
#' data(baduel_5gs) 
#' design$Indiv <- design$Population:design$Replicate
#' design$Vern <- ifelse(design$Vernalized, "Vernalized", "Non-vernalized")
#' 
#' library(ggplot2)
#' spaghettiPlot1GS(gs_index = 3, gmt = baduel_gmt, expr_mat = log2(expr_norm_corr+1), 
#'   design = design, var_time = AgeWeeks, var_indiv = Indiv, 
#'   sampleIdColname = "sample", var_group=Vern, var_subgroup=Population, 
#'   plotChoice = "Medians", loess_span= 1.5) +
#'   xlab("Age (weeks)") + guides(color= "none")

spaghettiPlot1GS <- function(gs_index, gmt, expr_mat, design, var_time, 
                             var_indiv, sampleIdColname, 
                             var_group = NULL, var_subgroup = NULL, 
                             plotChoice = c("Medians", "Individual"),
                             loess_span = 0.75){ 

  if(is.matrix(expr_mat)){
    expr_mat <- as.data.frame(expr_mat)
  }
  stopifnot(is.data.frame(expr_mat))
  if(is(design, "DFrame")){
    design <- as.data.frame(design)
  }
  stopifnot(is.data.frame(design))
  
  #Before to call a tidy evaluation function (ggplot) inside of another function
  # use enquo() and !! before object of the function
  var_subgroup_tidy <- enquo(var_subgroup)
  var_indiv_tidy <- enquo(var_indiv)
  var_time_tidy <- enquo(var_time)
  var_group_tidy <- enquo(var_group)
  
  SYMBOL_tidy <- sym("SYMBOL")
  Normalized_Expression_tidy <- sym("Normalized_Expression")
  Standardized_Expression_tidy <- sym("Standardized_Expression")

  #Select expression of genes in genesets
  gs_expr <- expr_mat %>% 
    tibble::rownames_to_column(var = "SYMBOL") %>% 
    dplyr::filter(!!SYMBOL_tidy %in% gmt$genesets[[gs_index]]) 

  colnames(design)[which(colnames(design) == sampleIdColname)] <- "SampleID"
  data2plot <- reshape2::melt(gs_expr, value.name = "Normalized_Expression", 
                              variable.name = "SampleID", id.vars = "SYMBOL") %>% 
    dplyr::left_join(y = design, by = "SampleID") %>% 
    dplyr::mutate("SYMBOL" = as.factor(!!SYMBOL_tidy))

  data2plot <- data2plot %>% 
    dplyr::mutate("group_line" = !!SYMBOL_tidy:!!var_indiv_tidy)
  
  data2plot <- data2plot %>% 
    dplyr::group_by(!!SYMBOL_tidy, !!var_group_tidy, !!var_subgroup_tidy, 
                    !!var_indiv_tidy) %>% 
    dplyr::mutate("Standardized_Expression" = ((!!Normalized_Expression_tidy - 
                                               mean(!!Normalized_Expression_tidy, 
                                                    na.rm = TRUE)) / 
                                               sd(!!Normalized_Expression_tidy)))

  data2plot_summ <- data2plot %>% dplyr::ungroup() %>% 
    dplyr::group_by(!!SYMBOL_tidy, !!var_group_tidy, !!var_subgroup_tidy, !!var_time_tidy) %>%
    dplyr::summarise("Standardized_Expression" = median(!!Standardized_Expression_tidy), 
              .groups = "drop_last") #%>% 

  # to have the vector of time
  var_time_vec <- rlang::eval_tidy(var_time_tidy, design)
  
  #Plot of Patient medians
  p1 <- ggplot(data2plot_summ, aes_string(x = var_time_tidy, y = "Standardized_Expression")) +
    geom_line(aes_string(color = "SYMBOL", linetype = var_subgroup_tidy)) +
    geom_smooth(aes_string(linetype = var_subgroup_tidy), color="black", 
                se=FALSE, method = 'loess', formula = 'y ~ x', span = loess_span) +
    theme_bw() +
    scale_x_continuous(breaks = unique(var_time_vec)) +
    scale_color_discrete("Gene") + 
    guides(linetype = guide_legend(override.aes = list(size=1))) +
    ylab("Standardized expression") +
    ggtitle("Median across individuals")


  #Plot of Individual data
  p2 <- ggplot(data2plot, aes_string(x = var_time_tidy, 
                                     y = "Standardized_Expression")) +
    geom_line(aes_string(group = "group_line", color = "SYMBOL", 
                         linetype = var_subgroup_tidy), alpha = 0.4) +
    geom_smooth(aes_string(linetype = var_subgroup_tidy), color="black", 
                se=FALSE, formula="y~x", method="loess", span = loess_span) +
    theme_bw() +
    scale_x_continuous(breaks = unique(var_time_vec)) +
    ylab("Standardized gene expression") +
    ggtitle("Individual data")
  
  #If there is var_group, add facet_wrap
  if(!is.null(eval_tidy(var_group_tidy, data = design))){
    p1 <- p1 + facet_wrap(var_group_tidy) 
    p2 <- p2 + facet_wrap(var_group_tidy) 
  }

  #Combine the 2 plots 
  pall <- p1/(p2 + guides(color = "none", linetype = "none")) + 
    plot_layout(guides = 'collect') + 
    plot_annotation(title = paste0(gmt$geneset.name[[gs_index]], ": ", 
                                   gmt$geneset.description[[gs_index]]))
  
  #Return plot according to plotChoice
  if(identical(plotChoice, "Medians")){
    p1 <- p1 +
          plot_annotation(title = paste0(gmt$geneset.name[[gs_index]], ": ", 
                                         gmt$geneset.description[[gs_index]]))
    return(p1)
  }else  if(identical(plotChoice, "Individual")){
    p2 <- p2 +    
          scale_color_discrete("Gene") + 
          guides(linetype = guide_legend(override.aes = list(size=1))) +
          plot_annotation(title = paste0(gmt$geneset.name[[gs_index]], ": ", 
                                         gmt$geneset.description[[gs_index]]))
    return(p2)
  }else if(length(plotChoice) == 2){
    return(pall)
  }else{
    warning("You must choose the type of plot to return.")
  }

}

#'Plotting mean-variance fit for precision weights estimation
#'
#'Display the variability with respect to the level of expression and the 
#'associated smoothed estimation of precision weights accounting for 
#'heteroscedasticity.
#'
#'@param x a list (such as outputed by the functions 
#'\code{\link[dearseq]{sp_weights}} or \code{\link[dearseq]{voom_weights}}) 
#'containing the following components:\itemize{
#'\item \code{weights}: a matrix \code{n x G} containing the estimated precision 
#'weights 
#'\item \code{plot_utilities}: a list containing the following elements:\itemize{
#'      \item\code{reverse_trans}: a function encoding the reverse function used 
#'      for smoothing the observations before computing the weights
#'      \item\code{method}: the weight computation method (either \code{"voom"} 
#'      or \code{"loclin"})
#'      \item\code{smth}: the vector of the smoothed values computed 
#'      \item\code{gene_based}: a logical indicating whether the computed 
#'      weights are based on average at the gene level or on individual 
#'      observations
#'      \item\code{mu}: the transformed observed counts or averages
#'      \item\code{v}: the observed variability estimates
#'}
#'}
#'
#'@author Boris Hejblum
#'
#'@return a \code{\link[ggplot2]{ggplot}} object
#'
#'@import ggplot2
#'@importFrom scattermore geom_scattermore
#'@export
#'
#'@examples
#'G <- 10000
#'n <- 12
#'p <- 2
#'y <- sapply(1:n, FUN = function(x){rnbinom(n = G, size = 0.07, mu = 200)})
#'x <- sapply(1:p, FUN = function(x){rnorm(n = n, mean = n, sd = 1)})
#'
#'if(interactive()){
#'  w <- sp_weights(y, x, use_phi=FALSE, na.rm = TRUE, gene_based=TRUE)
#'  plot_weights(w)
#'
#'  vw <-  voom_weights(y, x)
#'  plot_weights(vw)
#'}
#'
plot_weights <- function(x){
  
  stopifnot(!is.null(x$plot_utilities))
  stopifnot(!is.null(x$plot_utilities$method))
  
  if(x$plot_utilities$method == "voom"){
    r_tilde <- x$plot_utilities$mu
    s_rs <- x$plot_utilities$v
    o <- order(r_tilde, na.last = NA)
    
    plot_df <- data.frame(r_tilde_o = r_tilde[o], s_rs_o = s_rs[o])
    plot_df_lo <- data.frame(lo.x = x$plot_utilities$smth$x, lo.y = x$plot_utilities$smth$y)
    ggp <- (ggplot(data = plot_df) +
              geom_scattermore(aes_string(x = "r_tilde_o", y = "s_rs_o"),
                               alpha = 0.5, color = "grey30") +
              theme_bw() +
              xlab("Gene average") +
              ylab("sqrt(sd)") +
              ggtitle("Mean-variance") +
              geom_line(data = plot_df_lo,
                        aes_string(x = "lo.x", y = "lo.y"),
                        color = "blue", lwd = 1.4, lty = "solid",
                        alpha = 0.8))
    
    
  }else if(x$plot_utilities$method == "loclin"){
    
    mu_orig <- x$plot_utilities$reverse_trans(x$plot_utilities$mu)
    o <- order(mu_orig, na.last = NA)
    plot_df <- data.frame("m_o" = mu_orig[o], 
                          "v_o" = x$plot_utilities$v[o])
    smth <- x$plot_utilities$smth[o]
    if (x$plot_utilities$gene_based) {
      plot_df_lo <- data.frame("lo.x" = mu_orig[o], 
                               "lo.y" = smth)
    } else {
      plot_df_lo <- data.frame("lo.x" = x$plot_utilities$reverse_trans(x$plot_utilities$smth$x), 
                               "lo.y" = x$plot_utilities$smth$y)
    }
    
    ggp <- (ggplot(data = plot_df) +
              geom_scattermore(aes_string(x = "m_o", y = "v_o"), alpha = 0.5, 
                               color = "grey30") +
              theme_bw() +
              xlab(paste("Observed (transformed) ", 
                         ifelse(x$plot_utilities$gene_based, "gene average", "gene counts"))) +
              ylab(ifelse(x$plot_utilities$gene_based, "Variance", "log squared-error")) +
              ggtitle("Mean-variance local regression non-parametric fit") +
              geom_line(data = plot_df_lo, aes_string(x = "lo.x", y = "lo.y"), 
                        color = "blue", lwd = 1.4, lty = "solid", alpha = 0.5)
    )
  }else if(x$plot_utilities$method == "none"){
    warning("No plot to be drawn with weighting method = 'none'")
  }else{
    stop("Unknown weighting method")
  }
  
  return(ggp)
  
}

#' PBT gene sets related to kidney transplant
#'
#'9 Pathogenesis Based Transcripts (PBT) gene sets specifically related to
#'kidney transplant
#'
#'@name PBT_gmt
#'@rdname PBT_gmt
#'@aliases PBT_gmt PBT
#'
#'@usage data(PBT_gmt)
#'
#'@references Halloran PF, De Freitas DG, Einecke G, \emph{et al.}, The
#'molecular phenotype of kidney transplants: Personal viewpoint,
#'\emph{Am J Transplant}, 10: 2215-2222, 2010.
#'.
#'
#'@references Sellares J, Reeve J, Loupy A, et al., Molecular diagnosis of
#'antibody-mediated rejection in human kidney transplants,
#'\emph{Am J Transplant}, 13:971-983, 2013.
#'
#'@references Broin PO, Hayde N, Bao Y, et al.,  A pathogenesis-based transcript
#'signature in donor-specific antibody-positive kidney transplant patients with
#'normal biopsies, \emph{Genomics Data} 2: 357-60, 2014.
#'
#'@format a \code{gmt} object containing 9 gene sets specific to kidney
#'transplant (see \code{\link[GSA]{GSA.read.gmt}}), which is simply a
#'\code{list} with the 3 following components:\itemize{
#'\item \code{genesets}: a \code{list} of \code{n} gene identifiers vectors 
#'composing eachgene set (each gene set is represented as the vector of the 
#'gene identifiers composing it)
#'\item \code{geneset.names}: a vector of length \code{n} containing the gene 
#'set names (i.e. gene sets identifiers)
#'\item{geneset.descriptions}: a vector of length \code{n} containing gene set 
#'descriptions (e.g. textual information on their biological function)
#'}
#'
#'
#'@examples
#' data('PBT_gmt')
#' PBT_gmt
#'
#'
#' @source \url{http://atagc.med.ualberta.ca/Research/GeneLists}
#'
#' @keywords datasets
#' @docType data
NULL

#'Plot of gene-wise p-values
#'
#'This function prints the sorted exact p-values along with the Benjamini-Hochberg
#'limit and the 5% threshold
#'
#'@param pvals a vector of length \code{n} containing the raw p-values for
#'each gene
#'
#'@param signif_threshold a value between \code{0} and {1} specifying the 
#'nominal significance threshold. Default is \code{0.05}.
#'
#'
#'@return a plot of sorted gene-wise p-values
#'@import viridisLite ggplot2
#'@export
#'
#'@examples
#'#generate fake data
#'n <- 1000 #number of genes
#'nr=5 #number of measurements per subject (grouped data)
#'ni=50 #number of subjects
#'r <- nr*ni #number of measurements
#'t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested 
#'sigma <- 0.5
#'x <- matrix(1, ncol=1, nrow=r) #no covariates only intercept
#'y.tilde <- rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'
#'#Run dear_seq()
#'res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
#'                    sample_group=rep(1:ni, each=nr),
#'                    which_test = "asymptotic",
#'                    which_weights='none', preprocessed=TRUE)
#'
#'#Plot 
#'plot_ord_pvals(res_genes$pvals$rawPval)

plot_ord_pvals <- function(pvals, signif_threshold = 0.05){
  
  df_plot <- data.frame("y" = sort(pvals, na.last = NA), "x" = seq_len(length(pvals[!is.na(pvals)])))
  
  t <- seq_len(nrow(df_plot))
  s <- (t/length(pvals))*signif_threshold
  
  ggp <- 
    ggplot(data = df_plot, aes_string(x = "x")) + 
    scale_y_log10() + annotation_logticks(sides = "l") +
    geom_ribbon(aes(ymin = min(.data$y), ymax = s), fill = viridis(4)[3], alpha = 0.1) +
    geom_point(aes(y = .data$y, color = "p-values"), size = 0.5, alpha=0.4) +
    geom_line(aes(y = s, color = "B-H significance\nthreshold"), size = 0.5) +
    geom_line(aes(y = signif_threshold, color = paste0(signif_threshold*100, "%")), linetype = 4) +
    scale_color_manual(name = "", breaks = c("p-values", "B-H significance\nthreshold", paste0(signif_threshold*100, "%")),
                       values = c("black", viridis(4)[3], "red")) +
    guides(color = guide_legend(override.aes = list(linetype = c(0,1,4), pch = c(1,NA,NA), size = 1, alpha = 1))) +
    xlab("Descending rank") + 
    ylab("Raw p-value (log10 scale)") +
    theme_bw() +
    ggtitle("FDR significance", subtitle="Benjamini-Hochberg correction vs Ranked raw p-values")
  
  return(ggp)
}

#'Plotting raw p-values histogram
#'
#'Display the histogram of raw p-values for diagnostic plots
#'
#'@param pvals a vector of raw p-values
#'
#'@param binwidth a value specifying the width of the histogram bins. 
#'Default is \code{0.02}.
#'
#'@author Boris Hejblum
#'
#'@return a \code{\link[ggplot2]{ggplot}} object
#'
#'@import ggplot2
#'@export
#'
#'@examples
#'#generate fake data
#'n <- 1000 #number of genes
#'nr=5 #number of measurements per subject (grouped data)
#'ni=50 #number of subjects
#'r <- nr*ni #number of measurements
#'t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested 
#'sigma <- 0.5
#'x <- matrix(1, ncol=1, nrow=r) #no covariates only intercept
#'y.tilde <- rnorm(r, sd = sigma)
#'y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
#'       matrix(rep(y.tilde, n), ncol=n, nrow=r))
#'
#'#Run dear_seq()
#'res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
#'                    sample_group=rep(1:ni, each=nr),
#'                    which_test = "asymptotic",
#'                    which_weights='none', preprocessed=TRUE)
#'
#'#Plot
#'plot_hist_pvals(res_genes$pvals$rawPval)
#'
plot_hist_pvals <- function(pvals, binwidth = 0.02){
  
  stopifnot(is.numeric(pvals))
  
  df2plot <- cbind.data.frame("Rawpvals" = pvals)
  
  ggp <- ggplot(df2plot) + 
    geom_histogram(aes_string(x = "Rawpvals"), color="white", binwidth = binwidth) +
    xlab("Raw p-values") +
    theme_bw() +
    ggtitle("Histogram of raw p-values", subtitle = "before multiple testing correction")
  
  return(ggp)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/baduel.R
\docType{data}
\name{baduel_5gs}
\alias{baduel_5gs}
\alias{baduel}
\alias{baduel_gmt}
\alias{design}
\alias{expr_norm_corr}
\title{Small portion of RNA-seq data from plant physiology study.}
\format{
3 objects\itemize{
\item{\code{design}:} a design matrix for the 48 measured samples, containing
the following variables:\itemize{
 \item \code{SampleName} corresponding column names from
 \code{expr_norm_corr}
 \item \code{Intercept} an intercept variable
 \item \code{Population} a factor identifying the plant population
 \item \code{Age_weeks} numeric age of the plant at sampling time (in weeks)
 \item \code{Replicate} a purely technical variable as replicates are not
 from the same individual over weeks. Should not be used in analysis.
 \item \code{Vernalized} a logical variable indicating whether the plant had
 undergone vernalization (exposition to cold and short day photoperiods)
 \item \code{Vernalized} a binary variable indicating whether the plant
 belonged to the KA population
 \item \code{AgeWeeks_Population} interaction variable between the
 \code{AgeWeeks} and \code{Population} variables
 \item \code{AgeWeeks_Vernalized} interaction variable between the
 \code{AgeWeeks} and \code{Vernalized} variables
 \item \code{Vernalized_Population} interaction variable between the
 \code{Vernalized} and \code{Population} variables
 \item \code{AgeWeeks_Vernalized_Population} interaction variable between the
 \code{AgeWeeks}, \code{Vernalized} and \code{Population} variables
}
\item{\code{baduel_gmt}:} a \code{gmt} object containing 5 gene sets of
interest (see \code{\link[GSA]{GSA.read.gmt}}), which is simply a
\code{list} with the 3 following components:\itemize{
\item \code{genesets}: a \code{list} of \code{n} gene identifiers vectors 
composing eachgene set (each gene set is represented as the vector of the 
gene identifiers composing it)
\item \code{geneset.names}: a vector of length \code{n} containing the gene 
set names (i.e. gene sets identifiers)
\item{geneset.descriptions}: a vector of length \code{n} containing gene set 
descriptions (e.g. textual information on their biological function)
}

\item{\code{expr_norm_corr}:} a numeric matrix containing the normalized batch
corrected expression for the 2454 genes included in either of the 5 gene sets
of interests
}
}
\source{
\url{http://www.ncbi.nlm.nih.gov/bioproject/PRJNA312410}
}
\usage{
data(baduel_5gs)
}
\description{
A subsample of the RNA-seq data from Baduel \emph{et al.} studying Arabidopsis
Arenosa physiology.
}
\examples{
if(interactive()){
data('baduel_5gs')

set.seed(54321)
KAvsTBG <- dgsa_seq(exprmat=log2(expr_norm_corr+1),
                    covariates=apply(as.matrix(design[,
  c('Intercept', 'Vernalized', 'AgeWeeks', 'Vernalized_Population',
  'AgeWeeks_Population'), drop=FALSE]), 2, as.numeric),
                     variables2test =
                         as.matrix(design[, c('PopulationKA'), drop=FALSE]),
                     genesets=baduel_gmt$genesets[c(3,5)],
                     which_test = 'permutation', which_weights = 'loclin',
                     n_perm=1000, preprocessed = TRUE)

set.seed(54321)
Cold <- dgsa_seq(exprmat=log2(expr_norm_corr+1),
                 covariates=apply(as.matrix(design[,
   c('Intercept', 'AgeWeeks', 'PopulationKA', 'AgeWeeks_Population'),
   drop=FALSE]), 2, as.numeric),
                variables2test=as.matrix(design[, c('Vernalized',
                 'Vernalized_Population')]),
                 genesets=baduel_gmt$genesets[c(3,5)],
                 which_test = 'permutation', which_weights = 'loclin',
                 n_perm=1000, preprocessed = TRUE)
}


}
\references{
Baduel P, Arnold B, Weisman CM, Hunter B & Bomblies K (2016).
Habitat-Associated Life History and Stress-Tolerance Variation in Arabidopsis
Arenosa. \emph{Plant Physiology}, 171(1):437-51.
\href{https://doi.org/10.1104/pp.15.01875}{10.1104/pp.15.01875}.

Agniel D & Hejblum BP (2017). Variance component score test for
time-course gene set analysis of longitudinal RNA-seq data,
\emph{Biostatistics}, 18(4):589-604.
\href{https://doi.org/10.1093/biostatistics/kxx005}{10.1093/biostatistics/kxx005}.
\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_test_asym.R
\name{vc_test_asym}
\alias{vc_test_asym}
\title{Asymptotic variance component test statistic and p-value}
\usage{
vc_test_asym(
  y,
  x,
  indiv = rep(1, nrow(x)),
  phi,
  w,
  Sigma_xi = diag(ncol(phi)),
  genewise_pvals = FALSE,
  homogen_traj = FALSE,
  na.rm = FALSE
)
}
\arguments{
\item{y}{a numeric matrix of dim \code{g x n} containing the raw or normalized
RNA-seq counts for g genes from \code{n} samples.}

\item{x}{a numeric design matrix of dim \code{n x p} containing the \code{p}
covariates to be adjusted for}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced
to be a \code{factor}.}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} longitudinal variables to be tested (typically a vector of time
points or functions of time)}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples, corresponding to the inverse of the diagonal of the estimated
covariance matrix of y.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects corresponding to \code{phi}.}

\item{genewise_pvals}{a logical flag indicating whether gene-wise p-values
should be returned. Default is \code{FALSE} in which case gene set p-value is
computed and returned instead.}

\item{homogen_traj}{a logical flag indicating whether trajectories should be
considered homogeneous. Default is \code{FALSE} in which case trajectories
are not only tested for trend, but also for heterogeneity.}

\item{na.rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}
}
\value{
A list with the following elements when the set p-value is computed:
\itemize{
  \item \code{set_score_obs}: the approximation of the observed set score
  \item \code{set_pval}: the associated set p-value
}
or a list with the following elements when gene-wise p-values are computed:
\itemize{
  \item \code{gene_scores_obs}: vector of approximating the observed
  gene-wise scores
  \item \code{gene_pvals}: vector of associated gene-wise p-values
}
}
\description{
This function computes an approximation of the variance component test based
on the asymptotic distribution of a mixture of \eqn{\chi^{2}}s using the saddlepoint
method from \code{\link[survey]{pchisqsum}}, as per Chen & Lumley 20219 CSDA.
}
\examples{
set.seed(123)

##generate some fake data
########################
n <- 100
r <- 12
t <- matrix(rep(1:(r/4)), 4, ncol=1, nrow=r)
sigma <- 0.4
b0 <- 1

#under the null:
b1 <- 0
#under the alternative:
#b1 <- 0.5
y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))
x <- matrix(1, ncol=1, nrow=r)

#run test
asymTestRes <- vc_test_asym(y, x, phi=cbind(t, t^2),
                           w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                           Sigma_xi=diag(2), indiv=1:r, genewise_pvals=TRUE)
plot(density(asymTestRes$gene_pvals))
quantile(asymTestRes$gene_pvals)

}
\references{
Chen T & Lumley T (2019), Numerical evaluation of methods approximating the
distribution of a large quadratic form in normal variables, Computational
Statistics & Data Analysis, 139:75-81.
}
\seealso{
\code{\link[survey]{pchisqsum}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PBT_gmt.R
\docType{data}
\name{PBT_gmt}
\alias{PBT_gmt}
\alias{PBT}
\title{PBT gene sets related to kidney transplant}
\format{
a \code{gmt} object containing 9 gene sets specific to kidney
transplant (see \code{\link[GSA]{GSA.read.gmt}}), which is simply a
\code{list} with the 3 following components:\itemize{
\item \code{genesets}: a \code{list} of \code{n} gene identifiers vectors 
composing eachgene set (each gene set is represented as the vector of the 
gene identifiers composing it)
\item \code{geneset.names}: a vector of length \code{n} containing the gene 
set names (i.e. gene sets identifiers)
\item{geneset.descriptions}: a vector of length \code{n} containing gene set 
descriptions (e.g. textual information on their biological function)
}
}
\source{
\url{http://atagc.med.ualberta.ca/Research/GeneLists}
}
\usage{
data(PBT_gmt)
}
\description{
9 Pathogenesis Based Transcripts (PBT) gene sets specifically related to
kidney transplant
}
\examples{
data('PBT_gmt')
PBT_gmt


}
\references{
Halloran PF, De Freitas DG, Einecke G, \emph{et al.}, The
molecular phenotype of kidney transplants: Personal viewpoint,
\emph{Am J Transplant}, 10: 2215-2222, 2010.
.

Sellares J, Reeve J, Loupy A, et al., Molecular diagnosis of
antibody-mediated rejection in human kidney transplants,
\emph{Am J Transplant}, 13:971-983, 2013.

Broin PO, Hayde N, Bao Y, et al.,  A pathogenesis-based transcript
signature in donor-specific antibody-positive kidney transplant patients with
normal biopsies, \emph{Genomics Data} 2: 357-60, 2014.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_score_h.R
\name{vc_score_h}
\alias{vc_score_h}
\title{Computes variance component score test statistic for homogeneous trajectories}
\usage{
vc_score_h(y, x, indiv, phi, w, Sigma_xi = diag(ncol(phi)), na_rm = FALSE)
}
\arguments{
\item{y}{a numeric matrix of dim \code{g x n} containing the raw or
normalized RNA-seq counts for g genes from \code{n} samples.}

\item{x}{a numeric design matrix of dim \code{n x p} containing the \code{p}
covariates to be adjusted for.}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced
to be a \code{factor}.}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} longitudinal variables to be tested (typically a vector of time
points or functions of time).}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples, corresponding to the inverse of the diagonal of the estimated
covariance matrix of y.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects corresponding to \code{phi}.}

\item{na_rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}
}
\value{
A list with the following elements:\itemize{
  \item \code{score}: approximation of the set observed score
  \item \code{q}: observation-level contributions to the score
  \item \code{q_ext}: pseudo-observations used to compute covariance
  taking into account the contributions of OLS estimates
  \item \code{gene_scores}: approximation of the individual gene scores
}
}
\description{
This function computes the variance component score test statistics for 
homogeneous trajectories
}
\examples{
set.seed(123)

##generate some fake data
########################
ng <- 100
nindiv <- 30
nt <- 5
nsample <- nindiv*nt
tim <- matrix(rep(1:nt), nindiv, ncol=1, nrow=nsample)
tim2 <- tim^2
sigma <- 5
b0 <- 10

#under the null:
beta1 <- rnorm(n=ng, 0, sd=0)
#under the (heterogen) alternative:
beta1 <- rnorm(n=ng, 0, sd=0.1)
#under the (homogen) alternative:
beta1 <- rnorm(n=ng, 0.06, sd=0)

y.tilde <- b0 + rnorm(ng, sd = sigma)
y <- t(matrix(rep(y.tilde, nsample), ncol=ng, nrow=nsample, byrow=TRUE) +
      matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
           matrix(rep(tim, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
      #matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
      #    matrix(rep(tim2, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
      matrix(rnorm(ng*nsample, sd = sigma), ncol=ng, nrow=nsample,
             byrow=FALSE)
      )
myindiv <- rep(1:nindiv, each=nt)
x <- cbind(1, myindiv/2==floor(myindiv/2))
myw <- matrix(rnorm(nsample*ng, sd=0.1), ncol=nsample, nrow=ng)

#run test
score_homogen <- vc_score_h(y, x, phi=tim, indiv=myindiv,
                           w=myw, Sigma_xi=cov(tim))
score_homogen$score

score_heterogen <- vc_score(y, x, phi=tim, indiv=myindiv,
                           w=myw, Sigma_xi=cov(tim))
score_heterogen$score

scoreTest_homogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv, each=nt),
                                 w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                                 Sigma_xi=cov(tim),
                                 homogen_traj = TRUE)
scoreTest_homogen$set_pval
scoreTest_heterogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv,
                                                         each=nt),
                                   w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                                   Sigma_xi=cov(tim),
                                   homogen_traj = FALSE)
scoreTest_heterogen$set_pval

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.dearseq.R
\name{plot.dearseq}
\alias{plot.dearseq}
\title{Plot method for dearseq objects}
\usage{
\method{plot}{dearseq}(x, signif_threshold = 0.05, ...)
}
\arguments{
\item{x}{an object of class \code{dear_seq}}

\item{signif_threshold}{a value between \code{0} and {1} specifying the 
nominal significance threshold. Default is \code{0.05}.}

\item{...}{further arguments}
}
\value{
a \code{\link[ggplot2]{ggplot}} object
}
\description{
Plot method for dearseq objects
}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dgsa_seq.R
\name{dgsa_seq}
\alias{dgsa_seq}
\title{Time-course Gene Set Analysis}
\usage{
dgsa_seq(
  exprmat = NULL,
  object = NULL,
  covariates = NULL,
  variables2test,
  weights_var2test_condi = (which_test != "permutation"),
  genesets,
  sample_group = NULL,
  cov_variables2test_eff = NULL,
  which_test = c("permutation", "asymptotic"),
  which_weights = c("loclin", "voom", "none"),
  n_perm = 1000,
  progressbar = TRUE,
  parallel_comp = TRUE,
  nb_cores = parallel::detectCores(logical = FALSE) - 1,
  preprocessed = FALSE,
  gene_based_weights = TRUE,
  bw = "nrd",
  kernel = c("gaussian", "epanechnikov", "rectangular", "triangular", "biweight",
    "tricube", "cosine", "optcosine"),
  transform = TRUE,
  padjust_methods = c("BH", "BY", "holm", "hochberg", "hommel", "bonferroni"),
  lowess_span = 0.5,
  R = NULL,
  adaptive = TRUE,
  max_adaptive = 64000,
  homogen_traj = FALSE,
  na.rm_gsaseq = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{exprmat}{a numeric matrix of size \code{G x n} containing the raw
RNA-seq counts or preprocessed expressions from \code{n} samples for \code{G}
genes. Default is \code{NULL}, in which case \code{object} must not be
\code{NULL}.}

\item{object}{an object that can be either an
\code{\link[SummarizedExperiment:RangedSummarizedExperiment-class]{SummarizedExperiment}},
an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, a
\code{\link[DESeq2:DESeqDataSet]{DESeqDataSet}}, or a
\code{\link[edgeR:DGEList]{DGEList}}.
Default is \code{NULL}, in which case \code{exprmat} must not be
\code{NULL}.}

\item{covariates}{\itemize{
\item If \code{exprmat} is specified as a matrix:
then \code{covariates} must be a numeric matrix of size \code{n x p}
containing the model covariates for \code{n} samples (design matrix).
Usually, its first column is the intercept (full of \code{1}s).
\item If \code{object} is specified: then \code{covariates} must be a
character vector of length \code{p} containing the colnames of the
design matrix given in \code{object}.
} If \code{covariates} is \code{NULL} (the default), then it is just the
intercept.}

\item{variables2test}{\itemize{
\item If \code{exprmat} is specified as a matrix:
a numeric design matrix of size \code{n x K} containing
the \code{K} variables to be tested.
\item If \code{object} is specified: then \code{variables2test} must be a
character vector of length \code{K} containing the colnames of the
design matrix given in \code{object}.
}}

\item{weights_var2test_condi}{a logical flag indicating whether
heteroscedasticity weights computation should be conditional on both the
variable(s) to be tested \code{phi} and on covariate(s) \code{x}, or on
\code{x} alone.  Default is \code{TRUE} for the asymptotic test
(in which case conditional means are estimated conditionally on both
\code{variables2test} and \code{covariates}), and \code{FALSE} for the
permutation test (in which case conditional means are estimated
conditionally on only the  \code{covariates}).}

\item{genesets}{Can be either:\itemize{
\item a \code{vector}
\item a \code{list}
\item a \code{BiocSet} object
}
Can be a vector of index or subscripts that defines which
rows of \code{y} constitute the investigated gene set (when only 1 gene
set is being tested).

Can also be a \code{list} of index (or \code{rownames} of \code{y}) when
several gene sets are tested at once, such as the first element of a
\code{\link[GSA:GSA.read.gmt]{gmt}} object.

Finally, can also be a \code{\link[BiocSet:BiocSet-class]{BiocSet}} object

If \code{NULL}, then gene-wise p-values are returned.}

\item{sample_group}{a vector of length \code{n} indicating whether the samples
should be grouped (e.g. paired samples or longitudinal data). Coerced
to be a \code{factor}. Default is \code{NULL} in which case no grouping is
performed.}

\item{cov_variables2test_eff}{a matrix of size \code{K x K} containing the
covariance matrix of the \code{K} random effects. Only used if
\code{homogen_traj} is \code{FALSE}. Default assume diagonal correlation
matrix, i.e. independence of random effects.}

\item{which_test}{a character string indicating which method to use to
approximate the variance component score test, either \code{'permutation'} or
\code{'asymptotic'}. Default is \code{'permutation'}.}

\item{which_weights}{a character string indicating which method to use to
estimate the mean-variance relationship weights. Possibilities are
\code{'loclin'}, \code{'voom'} or \code{'none'} (in which case no weighting is
performed). Default is \code{'loclin'}.
See \code{\link{sp_weights}} and \code{\link{voom_weights}} for details.}

\item{n_perm}{the number of perturbations. Default is \code{1000}.}

\item{progressbar}{logical indicating wether a progressBar should be displayed
when computing permutations (only in interactive mode).}

\item{parallel_comp}{a logical flag indicating whether parallel computation
should be enabled. Only Linux and MacOS are supported, this is ignored on
Windows. Default is \code{TRUE}.}

\item{nb_cores}{an integer indicating the number of cores to be used when
\code{parallel_comp} is \code{TRUE}.
Default is \code{parallel::detectCores(logical=FALSE) - 1}.}

\item{preprocessed}{a logical flag indicating whether the expression data have
already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
which case \code{y} is assumed to contain raw counts and is normalized into
log(counts) per million.}

\item{gene_based_weights}{a logical flag used for \code{'loclin'} weights,
indicating whether to estimate weights at the gene-level, or rather at the
observation-level. Default is \code{TRUE}, and weights are then estimated at
the gene-level.}

\item{bw}{a character string indicating the smoothing bandwidth selection
method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}}

\item{kernel}{a character string indicating which kernel should be used.
Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
\code{'gaussian'} (NB: \code{'tricube'} kernel
corresponds to the loess method).}

\item{transform}{a logical flag used for \code{'loclin'} weights, indicating
whether values should be transformed to uniform for the purpose of local
linear smoothing. This may be helpful if tail observations are sparse and the
specified bandwidth gives suboptimal performance there. Default is
\code{TRUE}.}

\item{padjust_methods}{multiple testing correction method used if
\code{genesets} is a list. Default is 'BH', i.e. Benjamini-Hochberg procedure
for controlling the FDR. Other possibilities are: \code{'holm'},
\code{'hochberg'}, \code{'hommel'}, \code{'bonferroni'} or \code{'BY'}
(for Benjamini-Yekutieli procedure).}

\item{lowess_span}{smoother span for the lowess function, between 0 and 1.
This gives the proportion of points in the plot which influence the smooth at
each value. Larger values give more smoothness. Only used if
\code{which_weights} is \code{'voom'}. Default is \code{0.5}.}

\item{R}{library size (optional, important to provide if
\code{preprocessed = TRUE}). Default is \code{NULL}}

\item{adaptive}{a logical flag indicating whether adaptive permutation should
be performed. Default is \code{TRUE}}

\item{max_adaptive}{The maximum number of permutations considered.
Default is \code{64000}}

\item{homogen_traj}{a logical flag indicating whether trajectories should be
considered homogeneous. Default is \code{FALSE} in which case trajectories are
not only tested for trend, but also for heterogeneity.}

\item{na.rm_gsaseq}{logical: should missing values in \code{y} (including
\code{NA} and \code{NaN}) be omitted from the calculations?
Default is \code{TRUE}.}

\item{verbose}{logical: should informative messages be printed during the
computation? Default is \code{TRUE}.}
}
\value{
A list with the following elements:\itemize{
  \item \code{which_test}: a character string carrying forward the value of
  the '\code{which_test}' argument indicating which test was perform (either
  'asymptotic' or 'permutation').
  \item \code{preprocessed}: a logical flag carrying forward the value of the
  '\code{preprocessed}' argument indicating whether the expression data were
  already preprocessed, or were provided as raw counts and transformed into
  log-counts per million.
  \item \code{n_perm}: an integer carrying forward the value of the
  '\code{n_perm}' argument indicating the number of perturbations performed
  (\code{NA} if asymptotic test was performed).
  \item \code{genesets}: carrying forward the value of the '\code{genesets}'
  argument defining the gene sets of interest (\code{NULL} for gene-wise t
  esting).
  \item \code{pval}: computed p-values. A \code{data.frame} with one raw for
  each each gene set, or for each gene if \code{genesets} argument is
  \code{NULL}, and with 2 columns: the first one '\code{rawPval}' contains
  the raw p-values, the second one contains the FDR adjusted p-values
  (according to the '\code{padjust_methods}' argument) and is named
  '\code{adjPval}'.
}
}
\description{
Wrapper function for performing gene set analysis of (potentially
longitudinal) RNA-seq data
}
\examples{

nsims <- 2 #100
res_quant <- list()
for(i in 1:2){
 n <- 2000#0
 nr <- 3
 r <- nr*20 #4*nr#100*nr
 t <- matrix(rep(1:nr), r/nr, ncol=1, nrow=r)
 sigma <- 0.4
 b0 <- 1

 #under the null:
 b1 <- 0

 y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
 y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
        matrix(rep(y.tilde, n), ncol=n, nrow=r))
 x <- matrix(1, ncol=1, nrow=r)

 #run test
 res <- dgsa_seq(exprmat = y, covariates = x, variables2test = t,
                genesets=lapply(0:9, function(x){x*10+(1:10)}),
                cov_variables2test_eff = matrix(1),
                sample_group = rep(1:(r/nr), each=nr),
                which_test='asymptotic',
                which_weights='none', preprocessed=TRUE)
 res_genes <- dgsa_seq(exprmat = y, covariates = x,
                      variables2test = cbind(t),#, rnorm(r)), #t^2
                      genesets = NULL,
                      cov_variables2test_eff = diag(1),
                      sample_group = rep(1:(r/nr), each=nr),
                      which_test = 'asymptotic',
                      which_weights = 'none', preprocessed = TRUE)
 length(res_genes$pvals[, 'rawPval'])
 quantile(res_genes$pvals[, 'rawPval'])
 res_quant[[i]] <- res_genes$pvals[, 'rawPval']
}


#round(rowMeans(vapply(res_quant, FUN = quantile, FUN.VALUE = rep(1.1, 5))), 3)
#plot(density(unlist(res_quant)))
#mean(unlist(res_quant)<0.05)

if(interactive()){
res_genes <- dgsa_seq(exprmat = y, covariates = x, variables2test = t,
                    genesets = NULL,
                    cov_variables2test_eff = matrix(1),
                    sample_group = rep(1:(r/nr), each=nr),
                    which_test = 'permutation',
                    which_weights = 'none', preprocessed = TRUE,
                    n_perm = 1000, parallel_comp = FALSE)

mean(res_genes$pvals$rawPval < 0.05)
summary(res_genes$pvals$adjPval)
}
}
\references{
Agniel D & Hejblum BP (2017). Variance component score test for
time-course gene set analysis of longitudinal RNA-seq data,
\emph{Biostatistics}, 18(4):589-604.
\href{https://doi.org/10.1093/biostatistics/kxx005}{10.1093/biostatistics/kxx005}.
\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.

Law, C. W., Chen, Y., Shi, W., & Smyth, G. K. (2014). voom:
Precision weights unlock linear model analysis tools for RNA-seq read counts.
\emph{Genome Biology}, 15(2), R29.
}
\seealso{
\code{\link{sp_weights}} \code{\link{vc_test_perm}}
\code{\link{vc_test_asym}} \code{\link{p.adjust}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dearseq_package.R
\docType{package}
\name{dearseq-package}
\alias{dearseq}
\alias{dearseq-package}
\title{dearseq: Differential Expression Analysis for RNA-seq data through a robust variance component test}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Differential Expression Analysis RNA-seq data with variance component score test accounting for data heteroscedasticity through precision weights. Perform both gene-wise and gene set analyses, and can deal with repeated or longitudinal data. Methods are detailed in: i) Agniel D & Hejblum BP (2017) Variance component score test for time-course gene set analysis of longitudinal RNA-seq data, Biostatistics, 18(4):589-604 ; and ii) Gauthier M, Agniel D, Thiébaut R & Hejblum BP (2020) dearseq: a variance component score test for RNA-Seq differential analysis that effectively controls the false discovery rate, NAR Genomics and Bioinformatics, 2(4):lqaa093.
}
\details{
Analysis of RNA-seq data with variance component score
test accounting for data heteroscedasticity through precision weights.
Performs gene-wise analysis as well as gene set analysis, including for
complex experimental designs such as longitudinal data.

\tabular{ll}{
Package: \tab dearseq\cr
Type: \tab Package\cr
Version: \tab 1.13.3\cr
Date: \tab 2023-06-16\cr
License:\tab \href{http://www.gnu.org/licenses/gpl-2.0.txt}{GPL-2}\cr
}
The two main functions of the \code{dearseq} package are
\code{\link{dear_seq}} and \code{\link{dgsa_seq}}.
}
\references{
Agniel D & Hejblum BP (2017). Variance component score test for
time-course gene set analysis of longitudinal RNA-seq data,
\emph{Biostatistics}, 18(4):589-604.
\href{https://doi.org/10.1093/biostatistics/kxx005}{DOI: 10.1093/biostatistics/kxx005}.
\href{https://arxiv.org/abs/1605.02351}{arXiv:1605.02351}.

Gauthier M, Agniel D, Thiébaut R & Hejblum BP (2020). dearseq: a variance
component score test for RNA-Seq differential analysis that effectively
controls the false discovery rate, \emph{NAR Genomics and Bioinformatics},
2(4):lqaa093.
\href{https://doi.org/10.1093/nargab/lqaa093}{DOI: 10.1093/nargab/lqaa093}.
\href{https://www.biorxiv.org/content/10.1101/635714}{DOI: 10.1101/635714}
}
\seealso{
Useful links:
\itemize{
  \item Report bugs at \url{https://github.com/borishejblum/dearseq/issues}
}

}
\author{
\strong{Maintainer}: Boris P. Hejblum \email{boris.hejblum@u-bordeaux.fr} (\href{https://orcid.org/0000-0003-0646-452X}{ORCID})

Authors:
\itemize{
  \item Denis Agniel \email{denis.agniel@gmail.com}
  \item Marine Gauthier \email{marine.gauthier@u-bordeaux.fr}
}

Other contributors:
\itemize{
  \item Mélanie Huchon \email{melanie.huchon@u-bordeaux.fr} [contributor]
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_score_h_perm.R
\name{vc_score_h_perm}
\alias{vc_score_h_perm}
\title{Computes variance component score test statistics for homogeneous trajectory
and its permuted distribution}
\usage{
vc_score_h_perm(
  y,
  x,
  indiv,
  phi,
  w,
  Sigma_xi = diag(ncol(phi)),
  na_rm = FALSE,
  n_perm = 1000,
  progressbar = TRUE,
  parallel_comp = TRUE,
  nb_cores = parallel::detectCores(logical = FALSE) - 1
)
}
\arguments{
\item{y}{a numeric matrix of dim \code{g x n} containing the raw or
normalized RNA-seq counts for g genes from \code{n} samples.}

\item{x}{a numeric design matrix of dim \code{n x p} containing the \code{p}
covariates to be adjusted for.}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced
to be a \code{factor}.}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} longitudinal variables to be tested (typically a vector of time
points or functions of time).}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples, corresponding to the inverse of the diagonal of the estimated
covariance matrix of y.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects corresponding to \code{phi}.}

\item{na_rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}

\item{n_perm}{the number of permutation to perform. Default is \code{1000}.}

\item{progressbar}{logical indicating wether a progressBar should be displayed
when computing permutations (only in interactive mode).}

\item{parallel_comp}{a logical flag indicating whether parallel computation
should be enabled. Only Linux and MacOS are supported, this is ignored on
Windows. Default is \code{TRUE}.}

\item{nb_cores}{an integer indicating the number of cores to be used when
\code{parallel_comp} is \code{TRUE}.
Default is \code{parallel::detectCores(logical=FALSE) - 1}.}
}
\value{
A list with the following elements:
\itemize{
  \item \code{score}: an approximation of the observed set score
  \item \code{scores_perm}: a vector containing the permuted set scores
  \item \code{gene_scores_unscaled}: approximation of the individual gene
  scores
  \item \code{gene_scores_unscaled_perm}: a list of approximation of the
  permuted individual gene scores
}
}
\description{
This function computes the variance component score test statistics
for homogeneous trajectories along with its permuted values for estimating
its distribution under the null hypothesis.
}
\examples{
set.seed(123)

##generate some fake data
########################
ng <- 100
nindiv <- 30
nt <- 5
nsample <- nindiv*nt
tim <- matrix(rep(1:nt), nindiv, ncol=1, nrow=nsample)
tim2 <- tim^2
sigma <- 5
b0 <- 10

#under the null:
beta1 <- rnorm(n=ng, 0, sd=0)
#under the (heterogen) alternative:
beta1 <- rnorm(n=ng, 0, sd=0.1)
#under the (homogen) alternative:
beta1 <- rnorm(n=ng, 0.06, sd=0)

y.tilde <- b0 + rnorm(ng, sd = sigma)
y <- t(matrix(rep(y.tilde, nsample), ncol=ng, nrow=nsample, byrow=TRUE) +
      matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
           matrix(rep(tim, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
      #matrix(rep(beta1, each=nsample), ncol=ng, nrow=nsample, byrow=FALSE) *
      #     matrix(rep(tim2, ng), ncol=ng, nrow=nsample, byrow=FALSE) +
      matrix(rnorm(ng*nsample, sd = sigma), ncol=ng, nrow=nsample,
             byrow=FALSE)
      )
myindiv <- rep(1:nindiv, each=nt)
x <- cbind(1, myindiv/2==floor(myindiv/2))
myw <- matrix(rnorm(nsample*ng, sd=0.1), ncol=nsample, nrow=ng)

#run test
#We only use few permutations (10) to keep example running time low
#Otherwise one can use n_perm = 1000
score_homogen <- vc_score_h_perm(y, x, phi=tim, indiv=myindiv,
                                w=myw, Sigma_xi=cov(tim), n_perm = 10,
                                parallel_comp = FALSE)
score_homogen$score

score_heterogen <- vc_score_perm(y, x, phi=tim, indiv=myindiv,
                           w=myw, Sigma_xi=cov(tim), n_perm = 10,
                           parallel_comp = FALSE)
score_heterogen$score

scoreTest_homogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv, each=nt),
                                 w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                                 Sigma_xi=cov(tim), homogen_traj = TRUE)
scoreTest_homogen$set_pval
scoreTest_heterogen <- vc_test_asym(y, x, phi=tim, indiv=rep(1:nindiv,
                                                            each=nt),
                                   w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                                   Sigma_xi=cov(tim), homogen_traj = FALSE)
scoreTest_heterogen$set_pval

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dearseq_internal.R
\name{\%^\%}
\alias{\%^\%}
\title{Power for covaroances matrices}
\usage{
x \%^\% n
}
\arguments{
\item{x}{a positive definite symmetric matrix}

\item{n}{a real number}
}
\value{
a matrix of the same dimensions as \code{x}
}
\description{
Compute the power of a positive definite symmetric
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_score.R
\name{vc_score}
\alias{vc_score}
\title{Computes variance component score test statistics}
\usage{
vc_score(y, x, indiv, phi, w, Sigma_xi = diag(ncol(phi)), na_rm = FALSE)
}
\arguments{
\item{y}{a numeric matrix of dim \code{g x n} containing the raw RNA-seq
counts for g genes from \code{n} samples.}

\item{x}{a numeric design matrix of dim \code{n x p} containing the \code{p}
covariates to be adjusted for.}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced
to be a \code{factor}.}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} variables to .be tested}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects on \code{phi}.}

\item{na_rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}
}
\value{
A list with the following elements:\itemize{
  \item \code{score}: approximation of the set observed score
  \item \code{q}: observation-level contributions to the score
  \item \code{q_ext}: pseudo-observations used to compute the covariance,
   taking into account the contributions of OLS estimates
  \item \code{gene_scores_unscaled}: a vector of the approximations of the
  individual gene scores
}
}
\description{
This function computes the variance component score test statistics
}
\examples{
set.seed(123)

##generate some fake data
########################
n <- 100
r <- 12
t <- matrix(rep(1:3), r/3, ncol=1, nrow=r)
sigma <- 0.4
b0 <- 1

#under the null:
b1 <- 0
#under the alternative:
b1 <- 0.7
y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))
x <- matrix(1, ncol=1, nrow=r)

#run test
scoreTest <- vc_score(y, x, phi=t, w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                    Sigma_xi=matrix(1), indiv=rep(1:(r/3), each=3))
scoreTest$score

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_ord_pvals.R
\name{plot_ord_pvals}
\alias{plot_ord_pvals}
\title{Plot of gene-wise p-values}
\usage{
plot_ord_pvals(pvals, signif_threshold = 0.05)
}
\arguments{
\item{pvals}{a vector of length \code{n} containing the raw p-values for
each gene}

\item{signif_threshold}{a value between \code{0} and {1} specifying the 
nominal significance threshold. Default is \code{0.05}.}
}
\value{
a plot of sorted gene-wise p-values
}
\description{
This function prints the sorted exact p-values along with the Benjamini-Hochberg
limit and the 5% threshold
}
\examples{
#generate fake data
n <- 1000 #number of genes
nr=5 #number of measurements per subject (grouped data)
ni=50 #number of subjects
r <- nr*ni #number of measurements
t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested 
sigma <- 0.5
x <- matrix(1, ncol=1, nrow=r) #no covariates only intercept
y.tilde <- rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))

#Run dear_seq()
res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
                   sample_group=rep(1:ni, each=nr),
                   which_test = "asymptotic",
                   which_weights='none', preprocessed=TRUE)

#Plot 
plot_ord_pvals(res_genes$pvals$rawPval)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_hist_pvals.R
\name{plot_hist_pvals}
\alias{plot_hist_pvals}
\title{Plotting raw p-values histogram}
\usage{
plot_hist_pvals(pvals, binwidth = 0.02)
}
\arguments{
\item{pvals}{a vector of raw p-values}

\item{binwidth}{a value specifying the width of the histogram bins. 
Default is \code{0.02}.}
}
\value{
a \code{\link[ggplot2]{ggplot}} object
}
\description{
Display the histogram of raw p-values for diagnostic plots
}
\examples{
#generate fake data
n <- 1000 #number of genes
nr=5 #number of measurements per subject (grouped data)
ni=50 #number of subjects
r <- nr*ni #number of measurements
t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested 
sigma <- 0.5
x <- matrix(1, ncol=1, nrow=r) #no covariates only intercept
y.tilde <- rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))

#Run dear_seq()
res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
                   sample_group=rep(1:ni, each=nr),
                   which_test = "asymptotic",
                   which_weights='none', preprocessed=TRUE)

#Plot
plot_hist_pvals(res_genes$pvals$rawPval)

}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sp_weights.R
\name{sp_weights}
\alias{sp_weights}
\title{Non parametric local heteroscedasticity weights}
\usage{
sp_weights(
  y,
  x,
  phi = NULL,
  use_phi = TRUE,
  preprocessed = FALSE,
  gene_based = FALSE,
  bw = c("nrd", "ucv", "SJ", "nrd0", "bcv"),
  kernel = c("gaussian", "epanechnikov", "rectangular", "triangular", "biweight",
    "tricube", "cosine", "optcosine"),
  transform = TRUE,
  verbose = TRUE,
  na.rm = FALSE
)
}
\arguments{
\item{y}{a numeric matrix of size \code{G x n} containing the raw RNA-seq
counts or preprocessed expression from \code{n} samples for \code{G} genes.}

\item{x}{a numeric matrix of size \code{n x p} containing the model
covariate(s) from \code{n} samples (design matrix).}

\item{phi}{a numeric design matrix of size \code{n x K} containing the K
variable(s) of interest( e.g. bases of time).}

\item{use_phi}{a logical flag indicating whether conditional means should be
conditioned on \code{phi} and on covariate(s) \code{x}, or on \code{x} alone.
Default is \code{TRUE} in which case conditional means are estimated
conditionally on both \code{x} and \code{phi}.}

\item{preprocessed}{a logical flag indicating whether the expression data have
already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
which case \code{y} is assumed to contain raw counts and is normalized into
log(counts) per million.}

\item{gene_based}{a logical flag indicating whether to estimate weights at the
gene-level. Default is \code{FALSE}, when weights will be estimated at the
observation-level.}

\item{bw}{a character string indicating the smoothing bandwidth selection
method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}.
Default is \code{'nrd'}.}

\item{kernel}{a character string indicating which kernel should be used.
Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
\code{'gaussian'} (NB: \code{'tricube'} kernel corresponds to the loess
method).}

\item{transform}{a logical flag indicating whether values should be
transformed to uniform for the purpose of local linear smoothing. This may be
helpful if tail observations are sparse and the specified bandwidth gives
suboptimal performance there. Default is \code{TRUE}.}

\item{verbose}{a logical flag indicating whether informative messages are
printed during the computation. Default is \code{TRUE}.}

\item{na.rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}
}
\value{
a list containing the following components:\itemize{
\item \code{weights}: a matrix \code{n x G} containing the computed precision 
weights 
\item \code{plot_utilities}: a list containing the following elements:\itemize{
     \item\code{reverse_trans}: a function encoding the reverse function used 
     for smoothing the observations before computing the weights
     \item\code{method}: the weight computation method (\code{"loclin"})
     \item\code{smth}: the vector of the smoothed values computed 
     \item\code{gene_based}: a logical indicating whether the computed 
     weights are based on average at the gene level or on individual 
     observations
     \item\code{mu}: the transformed observed counts or averages
     \item\code{v}: the observed variability estimates
}
}
}
\description{
Computes precision weights that account for heteroscedasticity in RNA-seq
count data based on non-parametric local linear regression estimates.
}
\examples{
set.seed(123)

G <- 10000
n <- 12
p <- 2
y <- sapply(1:n, FUN = function(x){rnbinom(n = G, size = 0.07, mu = 200)})

x <- sapply(1:p, FUN = function(x){rnorm(n = n, mean = n, sd = 1)})

w <- sp_weights(y, x, use_phi=FALSE, na.rm = TRUE)

}
\seealso{
\code{\link[stats]{bandwidth}} \code{\link{density}}
}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spaghettiPlot_1GS.R
\name{spaghettiPlot1GS}
\alias{spaghettiPlot1GS}
\title{Spaghetti plot for Specific Gene Set}
\usage{
spaghettiPlot1GS(
  gs_index,
  gmt,
  expr_mat,
  design,
  var_time,
  var_indiv,
  sampleIdColname,
  var_group = NULL,
  var_subgroup = NULL,
  plotChoice = c("Medians", "Individual"),
  loess_span = 0.75
)
}
\arguments{
\item{gs_index}{index of the specific gene set in \code{gmt}.}

\item{gmt}{a \code{list} of elements: \code{geneset}, \code{geneset.name} and
\code{geneset.description} (see \code{\link[GSA]{GSA.read.gmt}}).}

\item{expr_mat}{a \code{data.frame} with numerics of size \code{G x n} 
contraining the raw RNA-seq counts from \code{n} samples for \code{G} genes.}

\item{design}{a \code{data.frame} or \code{DFrame} containing the information 
of each sample (SampleID).}

\item{var_time}{the \code{time} or \code{visit} variable contained in 
\code{design}.}

\item{var_indiv}{the patient variable contained in \code{design} data.}

\item{sampleIdColname}{a character string indicating the name of the sample ID 
variable in \code{design} to be matched with the \code{colnames} of \code{expr_mat}}

\item{var_group}{a group variable in \code{design} data to divide into two 
facets. Default is \code{NULL}.}

\item{var_subgroup}{a subgroup variable in \code{design} data to add 2 curves 
on plot for each subgroup. Default is \code{NULL}.}

\item{plotChoice}{to choose which type of plot (either \code{"Medians"}, 
\code{"Individual"} or both). Default is \code{c("Medians", "Individual")}.}

\item{loess_span}{smoothing span. Default is \code{0.75}.}
}
\value{
a ggplot2 plot object
}
\description{
Spaghetti plot for Specific Gene Set
}
\examples{
data(baduel_5gs) 
design$Indiv <- design$Population:design$Replicate
design$Vern <- ifelse(design$Vernalized, "Vernalized", "Non-vernalized")

library(ggplot2)
spaghettiPlot1GS(gs_index = 3, gmt = baduel_gmt, expr_mat = log2(expr_norm_corr+1), 
  design = design, var_time = AgeWeeks, var_indiv = Indiv, 
  sampleIdColname = "sample", var_group=Vern, var_subgroup=Population, 
  plotChoice = "Medians", loess_span= 1.5) +
  xlab("Age (weeks)") + guides(color= "none")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/voom_weights.R
\name{voom_weights}
\alias{voom_weights}
\title{Precision weights accounting for heteroscedasticity in RNA-seq count data}
\usage{
voom_weights(y, x, preprocessed = FALSE, lowess_span = 0.5, R = NULL)
}
\arguments{
\item{y}{a matrix of size \code{G x n} containing the raw RNA-seq counts or
preprocessed expressions from \code{n} samples for \code{G} genes.}

\item{x}{a matrix of size \code{n x p} containing the model covariates from
\code{n} samples (design matrix).}

\item{preprocessed}{a logical flag indicating whether the expression data have
already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
which case \code{y} is assumed to contain raw counts and is normalized into
log(counts) per million.}

\item{lowess_span}{smoother span for the lowess function, between 0 and 1.
This gives the proportion of points in the plot which influence the smooth at
each value. Larger values give more smoothness. Default is \code{0.5}.}

\item{R}{library.size (optional, important to provide if
\code{preprocessed = TRUE}). Default is \code{NULL}}
}
\value{
a vector of length \code{n} containing the computed precision weights
}
\description{
Implementation of the procedure described in Law \emph{et al.} for estimating
precision weights from RNA-seq data.
}
\examples{
set.seed(123)

G <- 10000
n <- 12
p <- 2

y <- sapply(1:n, FUN=function(x){rnbinom(n=G, size=0.07, mu=200)})
x <- sapply(1:p, FUN=function(x){rnorm(n=n, mean=n, sd=1)})

my_w <-  voom_weights(y, x)
plot_weights(my_w)
if (requireNamespace('limma', quietly = TRUE)) {
 w_voom <- limma::voom(counts=y, design=x, plot=TRUE)
 #slightly faster, same results
 all.equal(my_w$weights, w_voom$weights)
}

if(interactive()){
#microbenchmark::microbenchmark(limma::voom(counts=t(y), design=x,
#                               plot=FALSE), voom_weights(x, y),
#                               times=30)
}

}
\references{
Law, C. W., Chen, Y., Shi, W., & Smyth, G. K. (2014). voom:
Precision weights unlock linear model analysis tools for RNA-seq read counts.
\emph{Genome Biology}, 15(2), R29.
}
\seealso{
\code{\link{lowess}} \code{\link{approxfun}}
\code{\link[limma]{voom}}
}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_weights.R
\name{plot_weights}
\alias{plot_weights}
\title{Plotting mean-variance fit for precision weights estimation}
\usage{
plot_weights(x)
}
\arguments{
\item{x}{a list (such as outputed by the functions 
\code{\link[dearseq]{sp_weights}} or \code{\link[dearseq]{voom_weights}}) 
containing the following components:\itemize{
\item \code{weights}: a matrix \code{n x G} containing the estimated precision 
weights 
\item \code{plot_utilities}: a list containing the following elements:\itemize{
     \item\code{reverse_trans}: a function encoding the reverse function used 
     for smoothing the observations before computing the weights
     \item\code{method}: the weight computation method (either \code{"voom"} 
     or \code{"loclin"})
     \item\code{smth}: the vector of the smoothed values computed 
     \item\code{gene_based}: a logical indicating whether the computed 
     weights are based on average at the gene level or on individual 
     observations
     \item\code{mu}: the transformed observed counts or averages
     \item\code{v}: the observed variability estimates
}
}}
}
\value{
a \code{\link[ggplot2]{ggplot}} object
}
\description{
Display the variability with respect to the level of expression and the 
associated smoothed estimation of precision weights accounting for 
heteroscedasticity.
}
\examples{
G <- 10000
n <- 12
p <- 2
y <- sapply(1:n, FUN = function(x){rnbinom(n = G, size = 0.07, mu = 200)})
x <- sapply(1:p, FUN = function(x){rnorm(n = n, mean = n, sd = 1)})

if(interactive()){
 w <- sp_weights(y, x, use_phi=FALSE, na.rm = TRUE, gene_based=TRUE)
 plot_weights(w)

 vw <-  voom_weights(y, x)
 plot_weights(vw)
}

}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/perm_pe.R
\name{permPvals}
\alias{permPvals}
\title{Exact permutation p-values}
\usage{
permPvals(nPermSupObs, nPermEff, totalPossibleNPerm)
}
\arguments{
\item{nPermSupObs}{number of permutations that yielded test statistics at
least as extreme as the observed data. Can be a vector or an array of values.}

\item{nPermEff}{number of permutations effectively computed.}

\item{totalPossibleNPerm}{total number of permutations possible.}
}
\value{
a vector (or an array, similar to \code{nperm_supobs})
of exact p-values
}
\description{
Calculates exact p-values for permutation tests when permutations are randomly
drawn with replacement. This implementation is based on
(slightly adapted) the implementation by Belinda Phipson and Gordon Smyth
from the R package \code{statmod}
}
\examples{
permPvals(10, 100, 1000)

}
\references{
Phipson B, and Smyth GK (2010). Permutation p-values should never
be zero: calculating exact p-values when permutations are randomly drawn.
\emph{Statistical Applications in Genetics and Molecular Biology}, Volume 9,
Issue 1, Article 39.
\url{http://www.statsci.org/smyth/pubs/PermPValuesPreprint.pdf}
}
\seealso{
statmod::permp
}
\author{
Belinda Phipson and Gordon Smyth (adapted by Boris Hejblum)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dear_seq.R
\name{dear_seq}
\alias{dear_seq}
\title{Differential expression analyis of RNA-seq data through a variance component
test}
\usage{
dear_seq(
  exprmat = NULL,
  object = NULL,
  covariates = NULL,
  variables2test,
  sample_group = NULL,
  weights_var2test_condi = (which_test != "permutation"),
  cov_variables2test_eff = NULL,
  which_test = c("permutation", "asymptotic"),
  which_weights = c("loclin", "voom", "none"),
  n_perm = 1000,
  progressbar = TRUE,
  parallel_comp = TRUE,
  nb_cores = parallel::detectCores(logical = FALSE) - 1,
  preprocessed = FALSE,
  gene_based_weights = FALSE,
  bw = "nrd",
  kernel = c("gaussian", "epanechnikov", "rectangular", "triangular", "biweight",
    "tricube", "cosine", "optcosine"),
  transform = TRUE,
  padjust_methods = c("BH", "BY", "holm", "hochberg", "hommel", "bonferroni"),
  lowess_span = 0.5,
  R = NULL,
  adaptive = TRUE,
  max_adaptive = 64000,
  homogen_traj = FALSE,
  na.rm_dearseq = TRUE
)
}
\arguments{
\item{exprmat}{a numeric matrix of size \code{G x n} containing the raw
RNA-seq counts or preprocessed expressions from \code{n} samples for \code{G}
genes. Default is \code{NULL}, in which case \code{object} must not be
\code{NULL}.}

\item{object}{an object that can be either a
\code{\link[SummarizedExperiment:RangedSummarizedExperiment-class]{SummarizedExperiment}},
an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, a
\code{\link[DESeq2:DESeqDataSet]{DESeqDataSet}}, or a
\code{\link[edgeR:DGEList]{DGEList}}.
Default is \code{NULL}, in which case \code{exprmat} must not be
\code{NULL}.}

\item{covariates}{\itemize{
\item If \code{exprmat} is specified as a matrix:
then \code{covariates} must be a numeric matrix of size \code{n x p}
containing the model covariates for \code{n} samples (design matrix).
Usually, its first column is the intercept (full of \code{1}s).
\item If \code{object} is specified: then \code{covariates} must be a
character vector of length \code{p} containing the colnames of the
design matrix given in \code{object}.
} If \code{covariates} is \code{NULL} (the default), then it is just the
intercept.}

\item{variables2test}{\itemize{
\item If \code{exprmat} is specified as a matrix:
a numeric design matrix of size \code{n x K} containing
the \code{K} variables to be tested.
\item If \code{object} is specified: then \code{variables2test} must be a
character vector of length \code{K} containing the colnames of the
design matrix given in \code{object}.
}}

\item{sample_group}{a vector of length \code{n} indicating whether the samples
should be grouped (e.g. paired samples or longitudinal data). Coerced
to be a \code{factor}. Default is \code{NULL} in which case no grouping is
performed.}

\item{weights_var2test_condi}{a logical flag indicating whether
heteroscedasticity weights computation should be conditional on both the
variables to be tested \code{variables2test} and on the \code{covariates},
or on \code{covariates} alone. Default is \code{TRUE} for the asymptotic test
(in which case conditional means are estimated conditionally on both
\code{variables2test} and \code{covariates}), and \code{FALSE} for the
permutation test (in which case conditional means are estimated
conditionally on only the  \code{covariates}).}

\item{cov_variables2test_eff}{a matrix of size \code{K x K} containing the
covariance matrix of the \code{K} random effects. Only used if
\code{homogen_traj} is \code{FALSE}. Default assume diagonal correlation
matrix, i.e. independence of random effects.}

\item{which_test}{a character string indicating which method to use to
approximate the variance component score test, either \code{'permutation'} or
\code{'asymptotic'}. Default is \code{'permutation'}.}

\item{which_weights}{a character string indicating which method to use to
estimate the mean-variance relationship weights. Possibilities are
\code{'loclin'}, \code{'voom'} or \code{'none'} (in which case no weighting is
performed). Default is \code{'loclin'}. See \code{\link{sp_weights}} and
\code{\link{voom_weights}} for details.}

\item{n_perm}{the number of perturbations. Default is \code{1000}}

\item{progressbar}{logical indicating wether a progressBar should be displayed
when computing permutations (only in interactive mode).}

\item{parallel_comp}{a logical flag indicating whether parallel computation
should be enabled. Only Linux and MacOS are supported, this is ignored on
Windows. Default is \code{TRUE}.}

\item{nb_cores}{an integer indicating the number of cores to be used when
\code{parallel_comp} is \code{TRUE}.
Default is \code{parallel::detectCores(logical=FALSE) - 1}.}

\item{preprocessed}{a logical flag indicating whether the expression data have
already been preprocessed (e.g. log2 transformed). Default is \code{FALSE}, in
which case \code{y} is assumed to contain raw counts and is normalized into
log(counts) per million.}

\item{gene_based_weights}{a logical flag used for \code{'loclin'} weights,
indicating whether to estimate weights at the gene-level, or rather at the
observation-level. Default is \code{FALSE}, which is what it should be for
gene-wise analysis.}

\item{bw}{a character string indicating the smoothing bandwidth selection
method to use. See \code{\link[stats]{bandwidth}} for details. Possible values
are \code{'ucv'}, \code{'SJ'}, \code{'bcv'}, \code{'nrd'} or \code{'nrd0'}.}

\item{kernel}{a character string indicating which kernel should be used.
Possibilities are \code{'gaussian'}, \code{'epanechnikov'},
\code{'rectangular'}, \code{'triangular'}, \code{'biweight'},
\code{'tricube'}, \code{'cosine'}, \code{'optcosine'}. Default is
\code{'gaussian'} (NB: \code{'tricube'} kernel corresponds to the loess
method).}

\item{transform}{a logical flag used for \code{'loclin'} weights, indicating
whether values should be transformed to uniform for the purpose of local
linear smoothing. This may be helpful if tail observations are sparse and the
specified bandwidth gives suboptimal performance there. Default is
\code{TRUE}.}

\item{padjust_methods}{multiple testing correction method used if
\code{genesets} is a list. Default is 'BH', i.e. Benjamini-Hochberg procedure
for controlling the FDR. Other possibilities are: \code{'holm'},
\code{'hochberg'}, \code{'hommel'}, \code{'bonferroni'} or \code{'BY'} (for
Benjamini-Yekutieli procedure).}

\item{lowess_span}{smoother span for the lowess function, between 0 and 1.
This gives the proportion of points in the plot which influence the smooth at
each value. Larger values give more smoothness. Only used if
\code{which_weights} is \code{'voom'}. Default is \code{0.5}.}

\item{R}{library.size (optional, important to provide if
\code{preprocessed = TRUE}). Default is \code{NULL}}

\item{adaptive}{a logical flag indicating whether adaptive permutation should
be performed. Default is \code{TRUE}}

\item{max_adaptive}{The maximum number of permutations considered.
Default is \code{64000}}

\item{homogen_traj}{a logical flag indicating whether trajectories should be
considered homogeneous. Default is \code{FALSE} in which case trajectories
are not only tested for trend, but also for heterogeneity.}

\item{na.rm_dearseq}{logical: should missing values in \code{y} (including
\code{NA} and \code{NaN}) be omitted from the calculations?
Default is \code{TRUE}.}
}
\value{
A list with the following elements:\itemize{
  \item \code{which_test}: a character string carrying forward the value of
  the '\code{which_test}' argument indicating which test was perform (either
  'asymptotic' or 'permutation').
  \item \code{preprocessed}: a logical flag carrying forward the value of the
  '\code{preprocessed}' argument indicating whether the expression data were
  already preprocessed, or were provided as raw counts and transformed into
  log-counts per million.
  \item \code{n_perm}: an integer carrying forward the value of the
  '\code{n_perm}' argument indicating the number of perturbations performed
  (\code{NA} if asymptotic test was performed).
  \item \code{genesets}: carrying forward the value of the '\code{genesets}'
  argument defining the gene sets of interest (\code{NULL} for gene-wise
  testing).
  \item \code{pval}: computed p-values. A \code{data.frame} with one raw for
  each each gene set, or for each gene if \code{genesets} argument is
  \code{NULL}, and with 2 columns: the first one '\code{rawPval}' contains
  the raw p-values, the second one contains the FDR adjusted p-values
  (according to the '\code{padjust_methods}' argument) and is named
  '\code{adjPval}'.
}
}
\description{
Wrapper function for gene-by-gene association testing of RNA-seq data
}
\examples{

#Monte-Carlo estimation of the proportion of DE genes over `nsims`
#simulations under the null

#number of runs
nsims <- 2 #100
res <- numeric(nsims)
for(i in 1:nsims){
 n <- 1000 #number of genes
 nr=5 #number of measurements per subject (grouped data)
 ni=50 #number of subjects
 r <- nr*ni #number of measurements
 t <- matrix(rep(1:nr), ni, ncol=1, nrow=r) # the variable to be tested
 sigma <- 0.5
 b0 <- 1

 #under the null:
 b1 <- 0

 #create the matrix of gene expression
 y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
 y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
          matrix(rep(y.tilde, n), ncol=n, nrow=r))

 #no covariates
 x <- matrix(1, ncol=1, nrow=r)

 #run test
 #asymptotic test with preprocessed grouped data
 res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
                       sample_group=rep(1:ni, each=nr),
                       which_test='asymptotic',
                      which_weights='none', preprocessed=TRUE)

 #proportion of raw p-values>0.05
 mean(res_genes$pvals[, 'rawPval']>0.05)

 #quantiles of raw p-values
 quantile(res_genes$pvals[, 'rawPval'])

 #proportion of raw p-values<0.05 i.e. proportion of DE genes
 res[i] <- mean(res_genes$pvals[, 'rawPval']<0.05)
 message(i)
}

#results
mean(res)

if(interactive()){
b0 <- 1
#under the null:
b1 <- 0

#create the matrix of gene expression
y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))

#run test
#asymptotic test with preprocessed grouped data
res_genes <- dear_seq(exprmat=y, covariates=x, variables2test=t,
                   sample_group=rep(1:ni, each=nr),
                   which_weights='none', preprocessed=TRUE)

#results
summary(res_genes$pvals)
}
}
\references{
Gauthier M, Agniel D, Thiébaut R & Hejblum BP (2020). dearseq:
a variance component score test for RNA-Seq differential analysis that
effectivelycontrols the false discovery rate,
\emph{NAR Genomics and Bioinformatics}, 2(4):lqaa093.
\href{https://doi.org/10.1093/nargab/lqaa093}{DOI: 10.1093/nargab/lqaa093}.
\href{https://www.biorxiv.org/content/10.1101/635714}{DOI: 10.1101/635714}
}
\seealso{
\code{\link{sp_weights}} \code{\link{vc_test_perm}}
\code{\link{vc_test_asym}} \code{\link{p.adjust}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.dearseq.R
\name{summary.dearseq}
\alias{summary.dearseq}
\alias{print.summary.dearseq}
\title{Summary method for dearseq objects}
\usage{
\method{summary}{dearseq}(object, signif_threshold = 0.05, ...)

\method{print}{summary.dearseq}(x, ...)
}
\arguments{
\item{object}{an object of class \code{dear_seq}}

\item{signif_threshold}{a value between \code{0} and {1} specifying the 
nominal significance threshold. Default is \code{0.05}.}

\item{...}{further arguments}

\item{x}{an object of class '\code{summary.dearseq}'.}
}
\value{
a \code{list}
}
\description{
Summary method for dearseq objects
}
\author{
Boris Hejblum
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_test_perm.R
\name{vc_test_perm}
\alias{vc_test_perm}
\title{Permutation-based variance component test statistic and p-value}
\usage{
vc_test_perm(
  y,
  x,
  indiv = rep(1, nrow(x)),
  phi,
  w,
  Sigma_xi = diag(ncol(phi)),
  n_perm = 1000,
  progressbar = TRUE,
  parallel_comp = TRUE,
  nb_cores = parallel::detectCores(logical = FALSE) - 1,
  genewise_pvals = FALSE,
  adaptive = TRUE,
  max_adaptive = 64000,
  homogen_traj = FALSE,
  na.rm = FALSE
)
}
\arguments{
\item{y}{a numeric matrix of dim \code{G x n} containing the raw RNA-seq
counts for G genes from \code{n} samples.}

\item{x}{a numeric design matrix of dim \code{n x p} containing the \code{p}
covariates to be adjusted for.}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced to be a
\code{factor}.}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} variables to be tested}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects.}

\item{n_perm}{the number of perturbations. Default is \code{1000}.}

\item{progressbar}{logical indicating wether a progressBar should be displayed
when computing permutations (only in interactive mode).}

\item{parallel_comp}{a logical flag indicating whether parallel computation
should be enabled. Only Linux and MacOS are supported, this is ignored on
Windows. Default is \code{TRUE}.}

\item{nb_cores}{an integer indicating the number of cores to be used when
\code{parallel_comp} is \code{TRUE}.
Default is \code{parallel::detectCores(logical=FALSE) - 1}.}

\item{genewise_pvals}{a logical flag indicating whether gene-wise p-values
should be returned. Default is \code{FALSE} in which case gene-set p-value is
computed and returned instead.}

\item{adaptive}{a logical flag indicating whether adaptive permutation should
be performed. Default is \code{TRUE}}

\item{max_adaptive}{The maximum number of permutations considered.
Default is \code{64000}}

\item{homogen_traj}{a logical flag indicating whether trajectories should be
considered homogeneous. Default is \code{FALSE} in which case trajectories are
not only tested for trend, but also for heterogeneity.}

\item{na.rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}
}
\value{
A list with the following elements when the set p-value is computed:
\itemize{
  \item \code{set_score_obs}: the approximation of the observed set score
  \item \code{set_pval}: the associated set p-value
}
or a list with the following elements when gene-wise p-values are computed:
\itemize{
  \item \code{gene_scores_obs}: vector of approximating the observed
  gene-wise scores
  \item \code{gene_pvals}: vector of associated gene-wise p-values
  \item \code{ds_fdr}: vector of associated gene-wise discrete false
  discovery rates
}
}
\description{
This function computes an approximation of the Variance Component test for a
mixture of \eqn{\chi^{2}}s using permutations. This is preferable to the
asymptotic approximation for small sample sizes. We rely on exact p-values
following Phipson and Smyth, 2010 (see References).
}
\examples{
set.seed(123)

##generate some fake data
########################
n <- 100
r <- 12
t <- matrix(rep(1:3), 4, ncol=1, nrow=r)
sigma <- 0.4
b0 <- 1

#under the null:
b1 <- 0
#under the alternative:
b1 <- 0.5
y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))
x <- matrix(1, ncol=1, nrow=r)

#run test
permTestRes <- vc_test_perm(y, x, phi=t,
                           w=matrix(1, ncol=ncol(y), nrow=nrow(y)),
                           indiv=rep(1:4, each=3), n_perm=50, #1000,
                           parallel_comp = FALSE)
permTestRes$set_pval

}
\references{
Phipson B, and Smyth GK (2010). Permutation p-values should
never be zero: calculating exact p-values when permutations are randomly
drawn. \emph{Statistical Applications in Genetics and Molecular Biology},
Volume 9, Issue 1, Article 39.
\url{http://www.statsci.org/smyth/pubs/PermPValuesPreprint.pdf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vc_score_perm.R
\name{vc_score_perm}
\alias{vc_score_perm}
\title{Computes variance component score test statistics and its permuted distribution}
\usage{
vc_score_perm(
  y,
  x,
  indiv,
  phi,
  w,
  Sigma_xi = diag(ncol(phi)),
  na_rm = FALSE,
  n_perm = 1000,
  progressbar = TRUE,
  parallel_comp = TRUE,
  nb_cores = parallel::detectCores(logical = FALSE) - 1
)
}
\arguments{
\item{y}{a numeric matrix of dim \code{g x n} containing the raw RNA-seq
counts for g genes from \code{n} samples}

\item{x}{a numeric design matrix of dim \code{n x p} containing the
\code{p} covariates to be adjusted for}

\item{indiv}{a vector of length \code{n} containing the information for
attributing each sample to one of the studied individuals. Coerced
to be a \code{factor}}

\item{phi}{a numeric design matrix of size \code{n x K} containing the
\code{K} variables to be tested.}

\item{w}{a vector of length \code{n} containing the weights for the \code{n}
samples.}

\item{Sigma_xi}{a matrix of size \code{K x K} containing the covariance matrix
of the \code{K} random effects on \code{phi}}

\item{na_rm}{logical: should missing values (including \code{NA} and
\code{NaN}) be omitted from the calculations? Default is \code{FALSE}.}

\item{n_perm}{the number of permutation to perform. Default is \code{1000}.}

\item{progressbar}{logical indicating wether a progressBar should be displayed
when computing permutations (only in interactive mode).}

\item{parallel_comp}{a logical flag indicating whether parallel computation
should be enabled. Only Linux and MacOS are supported, this is ignored on
Windows. Default is \code{TRUE}.}

\item{nb_cores}{an integer indicating the number of cores to be used when
\code{parallel_comp} is \code{TRUE}.
Default is \code{parallel::detectCores(logical=FALSE) - 1}.}
}
\value{
A list with the following elements:\itemize{
  \item \code{score}: an approximation of the observed set score
  \item \code{scores_perm}: a vector containing the permuted set scores
  \item \code{gene_scores_unscaled}: approximation of the individual gene
  scores
  \item \code{gene_scores_unscaled_perm}: a list of approximationq of the
  permuted individual gene scores
}
}
\description{
This function computes the variance component score test statistics along
with its permuted values for estimating its distribution under the null
hypothesis.
}
\examples{
set.seed(123)

##generate some fake data
########################
n <- 100
r <- 12
t <- matrix(rep(1:3), r/3, ncol=1, nrow=r)
sigma <- 0.4
b0 <- 1

#under the null:
b1 <- 0
#under the alternative:
b1 <- 0.7
y.tilde <- b0 + b1*t + rnorm(r, sd = sigma)
y <- t(matrix(rnorm(n*r, sd = sqrt(sigma*abs(y.tilde))), ncol=n, nrow=r) +
      matrix(rep(y.tilde, n), ncol=n, nrow=r))
x <- matrix(1, ncol=1, nrow=r)

#run test
scoreTest <- vc_score_perm(y, x, phi=t, w=matrix(1, ncol=ncol(y),
                                                nrow=nrow(y)),
                    Sigma_xi=matrix(1), indiv=rep(1:(r/3), each=3),
                    parallel_comp = FALSE)
scoreTest$score

}
\keyword{internal}
